*-- Author :    Hartwig Albrecht   04/02/95

      SUBROUTINE ALTDEC

************************************************************************
*
* Description: fill Lund decay table from TDEC
*
* Called from: ALINIT etc.
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"
#include "auto/TDEC.fi"
#include "jets/LUDAT2.fi"
#include "jets/LUDAT3.fi"

      INTEGER I, J, K, L, M, N, LUCOMP
      CHARACTER*12 CNAME

#include "arte/Arte.ff"
#include "auto/TOPP.ff"
#include "auto/TDEC.ff"

      DO 10 K = 1, 500
        MDCY(K,3) = 0
 10   CONTINUE

      K = 0
      DO 50 I = 1, NTOPP()

        L = ITOPP_TDEC(I)
        IF (L .EQ. 0)  GO TO 50

        J = ITOPP_LUND(I)
        IF (J .NE. 0)  J = LUCOMP(J)

        IF (J .EQ. 0)  THEN
          C78 = 'ALTDEC: No decay table for particle'
          CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), CNAME)
          CALL CH78BC (CNAME)
          CALL ME78WC (9634585)
          GO TO 50
        END IF

        MDCY(J,2) = K + 1

 20     K = K + 1
        IF (K .GT. 2000)  THEN
          CALL MEERRC (7612346, 'ALTDEC: Lund decay table too short')
          GO TO 90
        END IF

        MDCY(J,3) = MDCY(J,3) + 1
        MDME(K,1) = ITDEC_MDME(1,L)
        MDME(K,2) = ITDEC_MDME(2,L)
        BRAT(K) = FTDEC_BRAT(L)

        DO 30 M = 1, 5
          KFDP(K,M) = 0

          N = ITDEC_DAUG(M,L)
          IF (N .EQ. 0)  GO TO 30

          N = ITOPP_LUND(N)
          IF (N .EQ. 0)  THEN
            C78 = 'ALTDEC: decay particle'
            CALL CHHTOC (IQ(HQTOPP_NAME(1,N)), CNAME)
            CALL CH78BC (CNAME)
            CALL CH78BC ('has no Lund code')
            CALL ME78EC (653414)
            GO TO 40
          END IF

          IF (LUCOMP (N) .EQ. 0)  THEN
            C78 = 'ALTDEC: decay particle'
            CALL CHHTOC (IQ(HQTOPP_NAME(1,N)), CNAME)
            CALL CH78BC (CNAME)
            CALL CH78BC ('has no compressed Lund code')
            CALL ME78WC (23457633)
          END IF

          KFDP(K,M) = N

 30     CONTINUE

 40     L = ITDEC_NEXT(L)
        IF (L .NE. 0)  GO TO 20

 50   CONTINUE

 90   END

************************************************************************
* End of ALTDEC
************************************************************************
