*-- Author :    Hartwig Albrecht   17/02/95

      SUBROUTINE UTPOPT (CTPL)

************************************************************************
*
* Description: Get printer destination from string CTPL containing
*              'T' (terminal); 'P' (printer); 'L' (logf). Upper or lower
*              case characters may be given.
*
* Called from: KR routines etc.
*
* External references: none
*
* Argument in/out description
*   CTPL   in     Character string containing only 'T', 'P', 'L'
*                 In batch jobs: 'T' is converted to 'P'
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEIO.fi"

      CHARACTER CTPL*(*)
      INTEGER CHIND1

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      LIOTPL(1) = 0
      LIOTPL(2) = 0
      LIOTPL(3) = 0

      IF (NOPRINT .NE. 0)  THEN
        LIOTPL(1) = LSTDO
        GO TO 90
      END IF

      IF (CHIND1 (CTPL, 'T') .NE. 0)  THEN
        IF (LOTRM .GT. 0)  THEN
          LIOTPL(1) = LOTRM
        ELSE
          IF (IMEIO_FLAG(IMEIO_CURRENT(LPRNT)) .GT. 1)
     +      LIOTPL(2) = LPRNT
        END IF
      END IF
      IF (CHIND1(CTPL, 'P') .NE. 0)  THEN
        IF (IMEIO_FLAG(IMEIO_CURRENT(LPRNT)) .EQ. 2)
     +    IQ(IQMEIO_FLAG(IMEIO_CURRENT(LPRNT))) = 3
        IF (IMEIO_FLAG(IMEIO_CURRENT(LPRNT)) .EQ. 3)  LIOTPL(2) = LPRNT
      END IF
      IF (CHIND1(CTPL, 'L') .NE. 0)  THEN
        IF (IMEIO_FLAG(IMEIO_CURRENT(LLOGF)) .EQ. 2)
     +    IQ(IQMEIO_FLAG(IMEIO_CURRENT(LLOGF))) = 3
        IF (IMEIO_FLAG(IMEIO_CURRENT(LLOGF)) .EQ. 3)  LIOTPL(3) = LLOGF
      END IF

      IF (LIOTPL(1) + LIOTPL(2) + LIOTPL(3) .EQ. 0)  LIOTPL(1) = LSTDO

 90   END

************************************************************************
* End of UTPOPT
************************************************************************
