//                              -*- Mode: C++ -*-
//: CmdCareECBoards.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
//
// 20.02.01 default file name set to file "default"
//

#include "care/CmdCareECBoards.hh"
#include "arte/ArteMessage.hh"

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string>
#include <math.h>


/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {

  void ecboard_(){
    CmdCareECBoards boardfile;
    boardfile.readAndExe();
    boardfile.dump();
  }
}

#endif

/////////////// Static data definition

char CmdCareECBoards::filename[256] = "\0";

/////////////// CmdCareECBoards class member function definition

CmdCareECBoards::CmdCareECBoards(){}
CmdCareECBoards::~CmdCareECBoards(){}

void CmdCareECBoards::defValues(){
  strcpy(filename,"default");
}


//--
//   Execute stored command
void CmdCareECBoards::execute(){}

#ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareECBoards::read(){
  char* name = readString();
  int i=0;
  for(; i<256 && name[i]!=' ' && name[i]!='\0'; i++)
    filename[i] = name[i];
  filename[i] = '\0';
}
#endif

char* CmdCareECBoards::boardfile(){
  if( filename[0]==0) 
    defValues();
  return filename;
}

void CmdCareECBoards::dump(){
  arteMsg<<" Board file name :"<<filename;
  arteMsg.allp();
}
