//                              -*- Mode: C++ -*-
//:CmdCareMCSIM.C
//
//
// Author: Pietro Faccioli
// ECAL group 
// HERA-B experiment, Desy

// Last Update ........
//

#include "care/CmdCareMCSIM.hh"
#include "care/caredata.hh"
#include "arte/ArteMessage.hh"

#ifdef USEKUIP

extern "C" {
void caremcsim_(){
  CmdCareMcSim careMcSim;
  careMcSim.readAndExe();
  careMcSim.dump();

}
}; // end of extern
#endif

const char dbn[] = "/ECAL_CALIB";
int CmdCareMcSim::dbmajor = 0;
int CmdCareMcSim::dbminor = 0;
char * CmdCareMcSim::dbname = 0;



CmdCareMcSim::CmdCareMcSim(){
 if( dbname==0 ){
   dbname = new char[strlen(dbn)+1];
   strcpy(dbname,dbn);
 }
}

CmdCareMcSim::~CmdCareMcSim(){}

void CmdCareMcSim::defValues(){
  dbmajor = 0;
  dbminor = 0;
  if( dbname!=0 ) delete [] dbname;
  dbname = new char[strlen(dbn)+1];
  strcpy(dbname,dbn);
}

//--
//   Execute stored command
void CmdCareMcSim::execute(){
}

#ifdef USEKUIP
//--
//   Read a command from external
void CmdCareMcSim::read(){

  dbmajor = readInt();
  dbminor = readInt();
  char * p = readString();
  if( dbname!=&dbn[0] ) delete [] dbname;
  dbname = new char[strlen(p)+1];
  strcpy(dbname,p);
  if(dbmajor<0 || dbminor<0)
    defValues();
}
#endif
                          
//--
//   Printout Information for the current info stored
void CmdCareMcSim::dump(){
  arteMsg<<" MC Sim constants";
  arteMsg.allp();
  arteMsg<<" Run: "<<dbmajor<<" vers: "<<dbminor<<" DB:"<<dbname;
  arteMsg.allp();
}


//--
//   Set Internal data
void CmdCareMcSim::setMcSim( int nrun, int nver, char *db){
  dbmajor = nrun;
  dbminor = nver;
  if( dbname!=&dbn[0] ) delete [] dbname;
  dbname = new char[strlen(db)+1];
  strcpy(dbname,db);  
}

