//                              -*- Mode: C++ -*-
//:ECCutFunction.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
//
// 20.02.01 Threshold in E or Pt depending on thresholdmode variable
//
#include "arte/arte.hh"
#include "care/caredata.hh"
#include "care/ECALtypes.hh"
#include <math.h>

      // 
      //  Energy cluster threshold 
      //  for 1) low energy recovery
      //      2) main cluster selection
      //
      // Set now to a ROUGHLY pt threshold (lower than a PT) for ONLINE
      // and to a constant threshold for offline


Energy_t ecCutFunction(ArtePointer<ECHS> echs){
  Energy_t re;
#ifndef ONLINE
  if( ECalInfo.thresholdmode==1 ){
    re = ECalInfo.clusThr;
  } else {
    re = ECalInfo.clusThr *
      sqrt(echs->r*echs->r+ECalInfo.ecalp->z1*ECalInfo.ecalp->z1) /
      (echs->r+10.);
  }
#else
  re = ECalInfo.clusThr *
    sqrt(echs->r*echs->r+ECalInfo.ecalp->z1*ECalInfo.ecalp->z1) /
    (echs->r+0.1);
#endif

  return re;
}


