//                              -*- Mode: C++ -*-
//:ECDcalIO.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 9/4/97
// Last Update ........
//

#include "care/ECDcalIO.hh"
#undef WRITE

/*
CLASS
  ECDcalIO


*/

// -------------------------------
#ifndef ONLINE
ECDcalIO::ECDcalIO() :  nchar(0),dcalbank(0), fedblock(0), data(0) , 
   lenght(0){}
#else

ETB_fed ECDcalIO::feds[256];
short   ECDcalIO::adc[32];
ECDcalIO::ECDcalIO() : nchar(0), currfed(-1), maxfeds(-1), bxid(0){}
#endif

void ECDcalIO::start(EcalEvent_t * event){
#ifndef ONLINE
  if(event!=0){
    dcalbank = (unsigned char*) event;
  } else {
    dcalbank = (unsigned char*)&(ArtePointer<DCAL>(1)->bits[0]);
  }
  fedblock = 0;
  data = 0;
  nchar = 0;
  lenght = ArtePointer<DCAL>::nrow()*4;
#else
  // copy the event pointer
  dcal = event;
  int n=256;
  int nmax = n;

  if( ETB_ok!=ETB_get_feds(event,COMP_ID_ECAL| 0xFF, n, feds, &nmax)){
    /* error: skip event ! */
    maxfeds = -1;
    currfed = -1;
    bxid = -1;
    return;
  } else {
    currfed = -1;
    maxfeds = (n<nmax)? n : nmax;
    current = 0;
    nrows = 0;
    short bx1 = -1;
    if( maxfeds>0)
        bxid = feds[0].hdr.bxid;
    if( maxfeds>1 ){
        bx1 = feds[1].hdr.bxid;
        if( bx1!=bxid && maxfeds>2){
          if(bx1==feds[2].hdr.bxid) bxid = bx1; 
        }
    }
  }
  current = 0;
  // std::cout<<std::endl<<" Event read with "<<maxfeds<<" FEDS"<<std::endl;
#endif
}

void ECDcalIO::start(){
#ifndef ONLINE
  dcalbank = (unsigned char*)&(ArtePointer<DCAL>(1)->bits[0]);
  fedblock = 0;
  data = 0;
  nchar = 0;
  lenght = ArtePointer<DCAL>::nrow()*4;
#endif
}

