//                              -*- Mode: C++ -*-
//:ECMCcalib.C
// 
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 26/5/97
// Last Update ........
//

#include "care/ECMCcalib.hh"
#include "arte/ArteMessage.hh"

/*
CLASS
  ECMCcalib
 
};

*/
////////////// ECMCcalib static data initialization

//--
//   Calibration constant to consider
Energy_t ECMCcalib::calibEnergy[] =  {0.0, 6.34, 6.59, 0.0, 0.0, 28.17};


//////////////////// Class ECMCcalib definition //////////////////////


// static member functions


//--
//   Set the calibration parameters 
void ECMCcalib::setCalibration(Energy_t innerCal, 
                                         Energy_t middleCal,
                                         Energy_t outerCal){
  // set calibrations
  calibEnergy[0] = 0.0;
  calibEnergy[1] = outerCal;  // Outer CAL has 1 cell per module
  calibEnergy[2] = middleCal; // Middle CAL has 2x2 cells per module
  calibEnergy[3] = 0.0;
  calibEnergy[4] = 0.0;
  calibEnergy[5] = innerCal;  // Inner CAL has 5x5 cells per module
}

                            
//--
//   Printout Information for the current calibration data stored
void ECMCcalib::dumpCalib(){
  arteMsg<<" ECMCcalib: constants for inner, middle and outer ECAL: ";
  arteMsg.allp();
  arteMsg<<calibEnergy[5]<<"  "<<calibEnergy[2]<<"  "<<calibEnergy[1];
  arteMsg.allp();
}






