//                              -*- Mode: C++ -*-
//:ELNearHitCellFrac.hh
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 27/5/97
// Last Update ........
//
//

#ifndef ELNEARHITCELLFRAC_HH_
#define ELNEARHITCELLFRAC_HH_


#include "care/ELNearHitCells.hh"
/**
class  ELNearHitCellFrac.
  Get the list of nearby clusterized cells
  and provide access to the list
*/

class ELNearHitCellFrac : public ELNearHitCells {
public:
  //--
  ///  constructor
  ELNearHitCellFrac();
  //--
  ///  destructor
  ~ELNearHitCellFrac();

  /**@name Beheavioral methods */
  //@{ 
  //--
  ///  Get the neighbours of a given cell
  void of(const EMHitCell* cell, const EMClusterTree & tree);
  //--
  ///  Get neighbouring cells of a given cell
  void of(CellIdx_t cell, const EMClusterTree & tree);
  //@}
 
  /**@name Iterator methods */
  //@{ 
  //--
  //  get the fraction
  inline Energy_t value() const { return fractions[curr];}
  //@}

private:
  //--
  ///  Array containing the fraction of the cells
  Energy_t fractions[20];
};

#endif // ELNEARHITCELLFRAC_HH_
