# ifndef __HIGZ_H
# define __HIGZ_H

#ifdef __cplusplus
extern "C" {
#endif

#include <string.h>

#ifndef TRUE
#define TRUE                     (1==1)
#endif
#ifndef FALSE
#define FALSE                    (1==0)
#endif

/*------------ Warning: maybe here are some typos!! --------------*/

/*
 *----------------------------------------------------------------------------
 * CERN Library declarations
 *----------------------------------------------------------------------------
 */
extern void hplzon_(int *, int *, int *, char *, int);
extern void hplot_ (int *, char *, char *, int *, int, int);
extern void hplint_(int *);
extern void hplopt_(char *, int *, int);
extern void igwkty_(int *);
extern void hplsiz_(float *, float *, char *, int);
extern void igset_ (char *, float *, int);
extern void igsse_ (int *, int *);
extern void iscr_ (int *, int *, float *, float *, float *);
extern void hdelet_(int *);
extern void igbox_ (float *, float *, float *, float *);
extern void igmeta_(int *, int *);
extern void hplend_(void);
extern void hplset_(char *, float *, int);
extern void iginit_(int *);
extern void igend_ (void);
extern void igrng_(float *, float *);
extern void igterm_(void);
extern void hpline_(float *, float *, int *, char *, int);
extern void hplarc_(float *, float *, float *, float *, float *);
extern void hplbox_(float *, float *, float *, float *, char *, int);
extern void hplerr_(float *, float *, float *, float *, int *, char *, int *, float *, int);
extern void ifa_   (int *, float *, float *);
extern void hplfra_(float *, float *, float *, float *, char *, int);
extern void hplsof_(float *, float *, char *, float *, float *, int *, int);
extern void igtext_(float *, float *, char *, float *, float *, char *, int, int);
extern void iswn_(int *, float *, float *, float *, float *);
extern void isvp_(int *, float *, float *, float *, float *);
extern void iselnt_(int *);
extern void iclrwk_(int *, int *);
extern void iopwk_ (int *, int *, int *);
extern void iclwk_ (int *);
extern void iacwk_ (int *);
extern void idawk_ (int *);
extern void iuwk_  (int *, int *);
extern void isfais_(int *);
extern void isplci_(int *);
extern void ispmci_(int *);
extern void ismk_(int *);
extern void ismksc_(float *);
extern void ipm_(int *, float *, float *);
extern void ipl_(int *, float *, float *);
extern void islwsc_(float *);
extern void isfaci_(int *);
extern void igarc_ (float *, float *, float *, float *, float *, float *);
extern void igaxis_(float *, float *, float *, float *, float *, float *, int *, char *, int);
extern void igzset_(char *, int);
extern void izfile_(int *, char *, char *, int, int);
extern void hplcap_(int *);
extern void hplsym_(float *, float *, int *, int *, float *, char *, int);
extern void ixselwi_(int *);
extern void ixclswi_(void);
extern void ixrscwi_(int *, int *, int *);
extern void ixupdwi_(int *);
extern void ixgetwi_(int *, int *);
extern void hpltit_(char *, int);
extern void hplzom_(int *, char *,int *, int *, int);

/*-- user def'd macros */

extern void hplnt   (int, int, int);
extern int  ixopnwi (int, int, int, int, char *);
extern int  ixopnds (char *);
extern void hpbeam  (float, float, float, float);
extern void hpcoos  (float, float, float, float, char *);
extern void polyplot(float, float);
extern void hpdot   (float, float);


/*
 *----------------------------------------------------------------------------
 * genuine higz/hplot/gks routines 
 *----------------------------------------------------------------------------
 */
#define Hplint(A)   do{int a=(A); hplint_(&a); }while(FALSE)
#define Hplend()    do{ hplend_(); }while(FALSE)
#define Hplot(A, B, C, D)                             \
do{                                                   \
  int a=(A), d=(D);                                   \
  hplot_(&a, (B), (C), &d, strlen((B)), strlen((C))); \
}while(FALSE)

#define Hplopt(A, B)             \
do{                              \
  int b=(B);                     \
  hplopt_((A), &b, strlen((A))); \
}while(FALSE)

#define Hplzon(A,B,C,D)                  \
do{                                      \
  int a=(A), b=(B), c=(C);               \
  hplzon_(&a, &b, &c, (D), strlen((D))); \
}while(FALSE)

#define Hplset(A, B)             \
do{                              \
  float b=(B);                   \
  hplset_((A), &b, strlen((A))); \
}while(FALSE)

#define Iginit(A)  do{int a=(A); iginit_(&a); }while(FALSE)
#define Igend()    do{igend_();}while(FALSE)
#define Igterm()   do{igterm_();}while(FALSE)
#define Igraph(A, B, C, D)               \
do{                                      \
  int    a=(A);                          \
  float* b=(B);                          \
  float* c=(C);                          \
  igraph_(&a, b, c, (D), strlen((D))); \
}while(FALSE)

#define Hpline(A, B, C, D)             \
do{                                    \
  int    c=(C);                        \
  float *a=(A), *b=(B);                \
  hpline_(a, b, &c, (D), strlen((D))); \
}while(FALSE)

#define Hplarc(A, B, C, D, E)              \
do{                                        \
  float a=(A), b=(B), c=(C), d=(D), e=(E); \
  hplarc_(&a, &b, &c, &d, &e);             \
}while(FALSE)

#define Hplbox(A, B, C, D, E)                \
do{                                          \
  float a=(A), b=(B), c=(C), d=(D);          \
  hplbox_(&a, &b, &c, &d, (E), strlen((E))); \
}while(FALSE)

#define Hplerr(A, B, C, D, E, F, G, H)               \
do{                                                  \
  int   e=(E), g=(G);                                \
  float *a=(A), *b=(B), *c=(C), *d=(D), h=(H);       \
  hplerr_(a, b, c, d, &e, (F), &g, &h, strlen((F))); \
}while(FALSE)

#define Ifa(A, B, C)    \
do{                     \
  int    a=(A);         \
  float *b=(B), *c=(C); \
  ifa_(&a, b, c);       \
}while(FALSE)

#define Hplfra(A, B, C, D, E)                \
do{                                          \
  float a=(A), b=(B), c=(C), d=(D);          \
  hplfra_(&a, &b, &c, &d, (E), strlen((E))); \
}while(FALSE)

#define Igset(A,B)              \
do{                             \
  float b=(B);                  \
  igset_((A), &b, strlen((A))); \
}while(FALSE)

#define Igsse(A,B)              \
do{                             \
  int a=(A); int b=(B);         \
  igsse_(&a, &b);               \
}while(FALSE)

#define Iscr(A,B,C,D,E)                  \
do{                                      \
  int a=(A); int b=(B);                  \
  float c=(C); float d=(D); float e=(E); \
  iscr_(&a, &b, &c, &d, &e);             \
}while(FALSE)

#define Hplsof(A, B, C, D, E, F, G)              \
do{                                              \
  int   g=(G);                                   \
  float a=(A), b=(B), d=(D), e=(E);              \
  hplsof_(&a, &b, (C), &d, &e, &f, strlen((C))); \
}while(FALSE)

#define Igtext(A, B, C, D, E, F)                               \
do{                                                            \
  float a=(A), b=(B), d=(D), e=(E);                            \
  igtext_(&a, &b, (C), &d, &e, (F), strlen((C)), strlen((F))); \
}while(FALSE)

#define Iclrwk(A, B) \
do{                  \
  int a=(A), b=(B);  \
  iclrwk_(&a, &b);   \
}while(FALSE)

#define Iopwk(A, B, C)     \
do{                        \
  int a=(A), b=(B), c=(C); \
  iopwk_(&a, &b, &c);      \
}while(FALSE)

#define Iclwk(A) do { int a=(A); iclwk_(&a); } while(FALSE)
#define Iacwk(A) do { int a=(A); iacwk_(&a); } while(FALSE)
#define Idawk(A) do { int a=(A); idawk_(&a); } while(FALSE)

#define Iuwk(A, B) \
do{                  \
  int a=(A), b=(B);  \
  iuwk_(&a, &b);   \
}while(FALSE)

#define Igmeta(A,B) do{int a=(A), b=(B); igmeta_(&a,&b); }while(FALSE);
#define Igarc(A,B,C,D,E,F)                        \
do{                                               \
  float a=(A), b=(B), c=(C), d=(D), e=(E), f=(F); \
  igarc_(&a, &b, &c, &d, &e, &f);                 \
}while(FALSE)

#define Igaxis(A, B, C, D, E, F, G, H)                   \
do{                                                      \
  int   g=(G);                                           \
  float a=(A), b=(B), c=(C), d=(D), e=(E), f=(F);        \
  igaxis_(&a, &b, &c, &d, &e, &f, &g, (H), strlen((H))); \
}while(FALSE)

#define Igzset(A)            \
do{                          \
  igzset_((A), strlen((A))); \
}while(FALSE)

#define Izfile(A, B, C)                            \
do{                                                \
  int a=(A);                                       \
  izfile_(&a, (B), (C), strlen((A)), strlen((B))); \
}while(FALSE)

#define Hplcap(A) \
do{               \
  int a=(A);      \
  hplcap_(&a);    \
}while(FALSE)

#define Hplsym(A, B, C, D, E, F)                 \
do{                                              \
  int   c=(C), d=(D);                            \
  float a=(A), b=(B), e=(E);                     \
  hplsym_(&a, &b, &c, &d, &e, (F), strlen((F))); \
}while(FALSE)

#define Ixselwi(A) \
do{                \
  int a=(A);       \
  ixselwi_(&a);    \
}while(FALSE)

#define Ixclswi()  do{ ixclswi_(); }while(FALSE)

#define Ixrscwi(A, B, C)   \
do{                        \
  int a=(A), b=(B), c=(C); \
  ixrscwi_(&a, &b, &c);    \
}while(FALSE)

#define Ixupdwi(A) do{int a=(A); ixupdwi_(&a); }while(FALSE)

#define Ixgetwi(A, B)  \
do{                    \
  int a=(A), b=(B);    \
  ixgetwi_(&a, &b);    \
}while(FALSE)

#define Hplsiz(A,B,C)                \
do{                                  \
  float a=(A), b=(B);                \
  hplsiz_(&a, &b, (C), strlen((C))); \
}while(FALSE)

#define Igbox(A,B,C,D)              \
do{                                 \
  float a=(A), b=(B), c=(C), d=(D); \
  igbox_(&a, &b, &c, &d);           \
}while(FALSE)

#define Igwkty(A)   do{ igwkty_(&A); }while(FALSE)

#define Hpltit(A)           \
do{                         \
  hpltit_((A),strlen((A))); \
}while(FALSE)

#define Hplzom(A,B,C,D)                  \
do{                                      \
  int   a=(A), c=(C), d=(D);             \
  hplzom_(&a, (B), &c, &d, strlen((B))); \
}while(FALSE)


#define Igrng(A, B)                                                  \
do{                                                                  \
  float a=(A); float b=(B);                                          \
  igrng_(&a, &b);                                                    \
}while(FALSE)

#define Iswn(A, B, C, D, E)                                          \
do{                                                                  \
  int a=(A); float b=(B); float c=(C); float d=(D); float e=(E);     \
  iswn_(&a, &b, &c, &d, &e);                                         \
}while(FALSE)

#define Isvp(A, B, C, D, E)                                          \
do{                                                                  \
  int a=(A); float b=(B); float c=(C); float d=(D); float e=(E);     \
  isvp_(&a, &b, &c, &d, &e);                                         \
}while(FALSE)

#define Iselnt(A)                                                    \
do{                                                                  \
  int a=(A);                                                         \
  iselnt_(&a);                                                       \
}while(FALSE)

#define Isplci(A)                                                    \
do{                                                                  \
  int a=(A);                                                         \
  isplci_(&a);                                                       \
}while(FALSE)

#define Isfais(A)                                                    \
do{                                                                  \
  int a=(A);                                                         \
  isfais_(&a);                                                       \
}while(FALSE)

#define Ispmci(A)                                                    \
do{                                                                  \
  int a=(A);                                                         \
  ispmci_(&a);                                                       \
}while(FALSE)

#define Ismk(A)                                                      \
do{                                                                  \
  int a=(A);                                                         \
  ismk_(&a);                                                         \
}while(FALSE)

#define Ismksc(A)                                                    \
do{                                                                  \
  float a=(A);                                                       \
  ismksc_(&a);                                                       \
}while(FALSE)

#define Ipm(A, B, C)                                                 \
do{                                                                  \
  int a=(A); float *b=(B); float *c=(C);                             \
  ipm_(&a, b, c);                                                    \
}while(FALSE)

#define Ipl(A, B, C)                                                 \
do{                                                                  \
  int a=(A); float *b=(B); float *c=(C);                             \
  ipl_(&a, b, c);                                                    \
}while(FALSE)


#define Islwsc(A)                                                    \
do{                                                                  \
  float a=(A);                                                       \
  islwsc_(&a);                                                       \
}while(FALSE)

#define Isfaci(A)                                                    \
do{                                                                  \
  int a=(A);                                                         \
  isfaci_(&a);                                                       \
}while(FALSE)




/*
 *----------------------------------------------------------------------------
 * higher level adaption(s) and/or modifications
 *----------------------------------------------------------------------------
 */
#define hplint(A)                  Hplint(A)
#define hplend()                   Hplend()
#define hplot(A,B,C,D)             Hplot(A,B,C,D)
#define hplopt(A)   do{int a=1; hplopt_((A), &a, strlen((A))); }while(FALSE)
#define hplzon(A,B,C,D)            Hplzon(A,B,C,D)
#define hplzon2(A,B)            \
do{                            \
  int a=(A), b=(B), c=1;       \
  hplzon_(&a, &b, &c, " ", 1); \
}while(FALSE)
#define hplset(A,B)                Hplset(A,B)
#define iginit(A)                  Iginit(A)
#define igend()                    Igend()
#define igterm()                   Igterm()
#define igraph(A,B,C,D)            Igraph(A,B,C,D)
#define hpline(A,B,C,D)            Hpline(A,B,C,D)
#define hplarc(A,B,C,D,E)          Hplarc(A,B,C,D,E)
#define hplbox(A,B,C,D,E)          Hplbox(A,B,C,D,E)
#define hplerr(A,B,C,D,E,F,G,H)    Hplerr(A,B,C,D,E,F,G,H)
#define ifa(A,B,C)                 Ifa(A,B,C)
#define hplfra(A,B,C,D,E)          Hplfra(A,B,C,D,E)
#define igset(A,B)                 Igset(A,B)
#define igsse(A,B)                 Igsse(A,B)
#define iscr(A,B,C,D,E)            Iscr(A,B,C,D,E)
#define hplsof(A, B, C, D, E, G)                 \
do{                                              \
  int   g=(G);                                   \
  float a=(A), b=(B), d=(D), e=0.;               \
  hplsof_(&a, &b, (C), &d, &e, &f, strlen((C))); \
}while(FALSE)
#define igtext(A,B,C,D,E,F)         Igtext(A,B,C,D,E,F)
#define iclrwk(A,B)                 Iclrwk(A,B)
#define iopwk(A,B,C)                Iopwk(A,B,C)
#define iclwk(A)                    Iclwk(A)
#define iacwk(A)                    Iacwk(A)
#define idawk(A)                    Idawk(A)
#define iuwk(A,B)                   Iuwk(A,B)
#define igmeta(A,B)                 Igmeta(A,B)
#define igarc(A,B,C,D,E,F)                        \
do{                                               \
  float a=(A), b=(B), c=(C), d=(D), e=(E), f=(F); \
  igarc_(&a, &b, &c, &d, &e, &f);                \
}while(FALSE)
#define igaxis(A,B,C,D,E,F,G,H)     Igaxis(A,B,C,D,E,F,G,H)
#define igzset(A)                   Igzset(A)
#define izfile(A,B,C)               Izfile(A,B,C)
#define hplcap(A)                   Hplcap(A)
#define hplsym(A,B,C,D,E,F)         Hplsym(A,B,C,D,E,F)
#define ixselwi(A)                  Ixselwi(A)
#define ixclswi()                   Ixclswi()
#define ixrscwi(A,B,C)              Ixrscwi(A,B,C)
#define ixupdwi(A)                  Ixupdwi(A)
#define ixgetwi(A,B)                Ixgetwi(A,B)
#define hplsiz(A,B)        \
do{                        \
  float a=(A), b=(B);      \
  hplsiz_(&a, &b, " ", 1); \
}while(FALSE)
#define igbox(A,B,C,D)              Igbox(A,B,C,D)
#define igwkty(A)                   Igwkty(A)
#define hpltit(A)                    Hpltit(A)
#define hplzom(A,B,C,D)              Hplzom(A,B,C,D)

#define igrng(A,B)                  Igrng(A,B)
#define iswn(A,B,C,D,E)             Iswn(A,B,C,D,E)
#define isvp(A,B,C,D,E)             Isvp(A,B,C,D,E)
#define iselnt(A)                   Iselnt(A)
#define isplci(A)                   Isplci(A)
#define isfais(A)                   Isfais(A)
#define ispmci(A)                   Ispmci(A)
#define ismk(A)                     Ismk(A)
#define ismksc(A)                   Ismksc(A)
#define ipm(A,B,C)                  Ipm(A,B,C)
#define ipl(A,B,C)                  Ipl(A,B,C)
#define islwsc(A)                   Islwsc(A)
#define isfaci(A)                   Isfaci(A)


#ifdef __cplusplus
           }
#endif
# endif


