// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   27. Jan 1997
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: ARTE constructor for Wire
//
// changes:
// 23 Jul 1999 creation by C. Borgmeier
// 12 Jan 2001 (TG) changed constructor
// 09 Feb 2001 (TG) added RTAR constructor
//
// ********************************************************************

#include "clue/cluearte.hh"
#include "clue/Wire.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

  Wire::Wire( const ArtePointer<GTAR>& wire ) :
    X ( wire->x ),
    Y ( wire->y ),
    Z ( wire->z ),
    dX( wire->dx ),
    dY( wire->dy ),
    dZ( wire->dz ) {
    
    //  cout << "wire: " << *this << endl;
  }

  Wire::Wire( const ArtePointer<RTAR>& wire ) :
    X ( wire->x ),
    Y ( wire->y ),
    Z ( wire->z ),
    dX( wire->dx ),
    dY( wire->dy ),
    dZ( wire->dz ) {
    
    //  cout << "wire: " << *this << endl;
  }

#ifdef NAMESPACE
} // end of namespace CLUE
#endif
