#ifndef ARTE_CLUEARTE_HH
#define ARTE_CLUEARTE_HH
// *****************************************************************************
//
// source:
//
// type:      header file
//
// created:   16. Jul 1999
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: clueWriteEvent() writes the current ARTE event into a BEE
//              file. clueGetEvent() fill the BEE event and returns pointer to
//              event object.
//
// changes:
// 16 Jul 1999 created by C. Borgmeier
// 02 Jan 2001 (TG) added TableFillBase argument to clueWriteEvent
// 10 Sep 2001 (TG) added clueGetEvent() declaration
//
// *****************************************************************************

class TableFillBase;
class RtEvent;

/** Write current ARTE event into a CLUE file.
    The filename is given by /CLUE/SETFILENAME
*/
int clueWriteEvent( const TableFillBase& tf );
/// function to load a BEE event inside ARTE
RtEvent* clueGetEvent( const TableFillBase& tf );

#endif
