// *****************************************************************************
//
// source:    daq_ecal_if.C
//
// type:      source code
//
// created:   14 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   functions to deliver FED IDs and contents to the class
//            DAQ_ECAL_IF
//            called by DAQ_MC_IF::buildFED and DAQ_UNSPARSE_IF::setSLBs
//
// changes:   
//
// *****************************************************************************
#include "daqif/daq_ecal_if.hh"

unsigned int ECALgetFED_IDs(unsigned int slbid, unsigned short *buf, 
                              unsigned int maxIDs);
 
int ECALgetFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize);

unsigned int DAQ_ECAL_IF::getFED_IDs(unsigned short *buf, unsigned int maxIDs)
{
  return ECALgetFED_IDs(0, buf, maxIDs);
}

int DAQ_ECAL_IF::getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize)
{
  return ECALgetFED(fedid, buf, maxSize);
}
