/************************************************************************
*
* DGMUOI.C
* 
* first author : Jing-Ge Shiu 
* purpose      : C++/SLT code for digitizing MC MUON pixel hits.
*                This routines translates GEANT output hits into 
*                ARTE HITB for inner muon pixel chamber
* called from  : dgevnt.C 
* start date   : Jan. 25, 2000
*
* last generation of this program is dgmuoi.F by Boris Fominykh
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*  ipl        in          Detector number in BANK GEDE table (from dgevnt)
*  
*-----------------------------------------------------------------------
* note :
* 
* head file : dgmupix.h
*
************************************************************************/

#include "arte/arte.hh"
#include "arte/ArteTable.hh"
#include "arte/ArteMessage.hh"
#include "arte/artefunc.h"
#include "digi/dgmupix.h"


void dgmuoi(int &ipl) {
  int n_mimphit = 0;

  ArtePointer<GEDE>gede(ipl);
  MuPixGEDE mupixgede(gede);

       for (ArteTableIterator<MIMP> mhit = gede->mim1;
            (mhit != gede->miml +1);
            mhit++) {  

           int check;  
           if (mupixgede.ingede(mhit,&check)) n_mimphit++;

       }  
         
       mupixgede.fillhitb();

 return;
} 






