
// ******************************************************************
//
// source:    DQ_FARM_raw_init.C
//
// type:      source code
//
// created:   Oct 2001
//
// author:    Jose Hernandez
//
// called by: DQ_init()
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_raw_init()
{
  // show up
  ARTE_mark( "DQ_FARM_raw_init 0", 0 );
  cout << "DQ_FARM_raw_init" << endl;
  
  // book histograms
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 1 ), "FARM Trigger code", 16, -0.5, 15.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 2 ), "FARM Target Rate / MHz", 50, 0, 50. );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 3 ), "FARM SLP_node", 241, -0.5, 240.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 4 ), "FARM 4LT_node", 110, -0.5, 109.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 6 ), "FARM Raw event size / kB", 50, 0.0, 250 );
  
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 15 ), "FARM DQ Time / sec", 50, 0.0, 1.0 );

  // size of some raw tables
  //rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 101 ), "FARM DSVD / kB", 50, 0,  25 );
  //rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 102 ), "FARM DITR / kB", 50, 0,  50 );
  //rhp_hbook1( DQ_ID( COMP_FARM, LVL_RAW, 104 ), "FARM DOTR / kB", 60, 0, 120 );

  ARTE_mark( "DQ_FARM_raw_init 1", 0 );

  return 0;
}
