 
// *****************************************************************************
//
// source:    DQ_RECO_CAL1HT.C
//
// type:      source code
//
// created:   26 Jun 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_event()
//
// changes:
//  5 Jul 2000 (AG) creation
//  7 Jul 2000 (AG) polished printout
// 13 Nov 2000 (AG) introduced cutCAL1HT
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RECO.h"

// externals
extern float etCAL1HT;
extern float cutCAL1HT; // cut set in rcClassCAL1HT.C

//
// function code
//
int
DQ_RECO_CAL1HT_init()
{
  // show up
  ARTE_mark( "DQ_RECO_CAL1HT_init 0", 0 );
  cout << "DQ_RECO_CAL1HT_init" << endl;

  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 160 ), "RECO CAL1HT Et",       50, 0, 50 );
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 161 ), "RECO CAL1HT Et (cut)", 50, 0, 50 );

  // show up
  ARTE_mark( "DQ_RECO_CAL1HT_init 1", 0 );

  return 0;
}

//
// function call
//
int
DQ_RECO_CAL1HT_evnt()
{
  // show up
  ARTE_mark( "DQ_RECO_CAL1HT_evnt 0", 0 );
  
  rhp_hf1( DQ_ID( COMP_RECO,LVL_REC, 160 ), etCAL1HT, 1 );
  if( etCAL1HT > cutCAL1HT ) rhp_hf1( DQ_ID( COMP_RECO,LVL_REC, 161 ), etCAL1HT, 1 );

  // show up
  ARTE_mark( "DQ_RECO_CAL1HT_evnt 1", 0 );

  return 0; // return error code (0 = okay)
}
