 
// *****************************************************************************
//
// source:    DQ_RECO_rec_evnt.C
//
// type:      source code
//
// created:   26 Jun 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_event()
//
// changes:
//  5 Jul 2000 (AG) creation
//  7 Jul 2000 (AG) added CAL1HT
// 24 Nov 2000 (PC) Added DQ_RECO_MATCH
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RECO.h"

//
// function code
//
int
DQ_RECO_rec_evnt()
{
  // show up
  ARTE_mark( "DQ_RECO_rec_evnt 0", 0 );

  //
  // flag
  //
  if( ArteTable<EVRC>::size() > 0 ){
    ArtePointer<EVRC> evrc( ArteTable<EVRC>::size() );
    
    if( evrc->errmask != 0 ){
      rhp_hf1( DQ_ID( COMP_RECO, LVL_REC, 1 ), 1 , 1 );
    }
    else {
      rhp_hf1( DQ_ID( COMP_RECO, LVL_REC, 1 ), 0, 1 );
    }
    
    unsigned flag = 0x00000001;    
    for( float bin = 2; bin < 33; bin += 1 ){
      if( evrc->errmask & flag ) rhp_hf1( DQ_ID( COMP_RECO, LVL_REC, 1 ), bin, 1 );
      flag = flag << 1;
    }
  }

  //
  // DQ code
  //
  ARTE_mark( "DQ_RECO_vertex_evnt", 0 );
  DQ_RECO_vertex_evnt();

  ARTE_mark( "DQ_RECO_JPSIEE_evnt", 0 );
  DQ_RECO_JPSIEE_evnt();

  ARTE_mark( "DQ_RECO_JPSIMM_evnt", 0 );
  DQ_RECO_JPSIMM_evnt();

  ARTE_mark( "DQ_RECO_CAL1HT_evnt", 0 );
  DQ_RECO_CAL1HT_evnt();

  ARTE_mark( "DQ_RECO_RTRA_evnt", 0 );
  DQ_RECO_RTRA_evnt();

  ARTE_mark( "DQ_RECO_MATCH_evnt", 0 );
  DQ_RECO_MATCH_evnt();

  // show up
  ARTE_mark( "DQ_RECO_rec_evnt 1", 0 );

  return 0; // return error code (0 = okay)
}
