// ------------------------------------------------------
// ---
// ---  created: Aug 99 
// ---  author:  Denis Dujmic
// ---
// ---
// ---  RICH FED Occupancy Quality Check
// ---
// ---
// changes:
// 28 Oct 1999 (AG) use utility function for ia rate
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 16 Dec 1999 (RP) histograms for fed channels and ph.det.
// 09 Jun 2000 (RP) change id of the channel
// 16 Jun 2000 (AG) remove SEGV bug
// 29 Jun 2000 (AG) bug removal by P. Conde
// 02 Nov 2000 (AG) added ARTE_mark()
// 24 Nov 2000 (AG) check pointer RICH_DAQ
//  5 Apr 2002 (MS) int DQ_RICH_raw_allfed() removed
//                  "FED Occupancy ratio": hfill removed
//                  "FED Occupancy total": hfill with wt=1 
//                  "FED channel Occupancy": use of rhp_hf1, instead of array+hpak
//                   polishing
// ------------------------------------------------------

#include "dq/DQ.h"
#include "rhp.h"
#include "rich/rich.h"
#include "farm/farm.hh"
#define MAX_RICH_CHANNELS 28672  


int DQ_RICH_raw_evnt(EVENT_HDR *event)
{
  ARTE_mark( "DQ_RICH_raw_evnt 0", 0 );

  if( !RICH_DAQ ){
    ARTE_mark( "DQ_RICH_raw_evnt 1", 0 );
    return 0;
  }
  if (!RICH_DAQ->NextEvent(event)){ 
    ARTE_mark( "DQ_RICH_raw_evnt 1", 0 );
    return 1;
  }

  // --  histogram ID's
  unsigned int rich_fed_histo_id=DQ_ID(COMP_RICH, LVL_RAW,100);
  unsigned int rich_chan_histo_id=DQ_ID(COMP_RICH, LVL_RAW,103);
  unsigned int phdet[2]={ DQ_ID(COMP_RICH, LVL_RAW,104),
			  DQ_ID(COMP_RICH, LVL_RAW,105) };

  // -- event count -> the last bin of rich_chan_histo
  rhp_hf1(rich_chan_histo_id,MAX_RICH_CHANNELS,1);

  // -- fill 
  for (int i=0; RICH_DAQ->HitChannelExist(i); i++)  {
    rhp_hf1(rich_fed_histo_id,RICH_DAQ->fedid(),1);
    unsigned int id = RICH_DAQ->ChannelIndex();
    if ( id <  MAX_RICH_CHANNELS ) rhp_hf1(rich_chan_histo_id,id,1);
    int sm   =RICH_DAQ->sm();
    int row  =RICH_DAQ->row();
    int col  =RICH_DAQ->col();
    int ch   =RICH_DAQ->pm_channel();
    int type =RICH_DAQ->pm_numchannel();
    int hid = 1;
    if (sm >6) {
      hid = 0;
      sm  = 13-sm;
      col = 11-col;
      row = 31-row;        
    }
    sm--;
    if (type==16) type=0; else type=1;
    int x0=col*4+sm*48;
    int y0=row*4;
    if (!type) {
      x0+=3-(ch%4);
      y0+=3-(ch/4);
    } else {
      x0+=(1-ch%2)*2;
      y0+=(1-ch/2)*2;    
    }
    for (int k=0;k<(type+1);k++) {
      for (int l=0;l<(type+1);l++) {
	rhp_hfill(phdet[hid], float(x0+k) , float(y0+l) ,1);
      }
    }
  }

  ARTE_mark( "DQ_RICH_raw_evnt 1", 0 );
  return 0;
}

