
#ifndef _DQ_H_
#define _DQ_H_

/******************************************************************************
 *                                   
 * source:    DQ.h                   
 *                                  
 * type:      header file           
 *                                  
 * created:   19 Oct 1999           
 *                                  
 * author:    Andreas Gellrich      
 *            HERA-B Collaboration  
 *            DESY Zeuthen          
 *            Platanenallee 6       
 *            D-15738 Zeuthen       
 *            Germany               
 *            email: Andreas.Gellrichdesy.de                     
 *                                                               
 * changes:                                                      
 * 20 Oct 1999 (AG) make DQ_flag() usable for C                  
 * 27 Oct 1999 (AG) define modules (MOD) and levels (LVL)        
 * 01 Nov 1999 (AG) include CNA stuff
 * 16 Nov 1999 (AG) polishing
 * 19 Nov 1999 (AG) cna -> ac (alca)
 * 26 Nov 1999 (AG) COMP_USR3 -> COMP_RECO
 * 01 Feb 2000 (AG) repair AC stuff; add AC_print()
 * 25 Feb 2000 (AG) extract defines to dq.h (ONLINE)
 * 26 Feb 2000 (AG) extract AC stuff to alca/AC.h
 *
 *****************************************************************************/

/* includes */
#include "dq.h"

#ifdef __cplusplus
extern "C" {
#endif

/* flag */
int DQ_flag( int COMP_XYZ, int LVL_M_ABC );

#ifdef __cplusplus
}
#endif

/* DB access */
int  DQ_db();

/* print */
void DQ_print( const char *txt );

/* set DQ level to raw for all components */
void DQ_Comp_SetRAW(void);

/* set DQ level to raw+hit for all components */
void DQ_Comp_SetHIT(void);

#endif
