// ********************************************************************
//
//  Routine:      gageFillRhp
//  Author:       T. Oest
//
//  Description:  steering routine to fill rhp histograms for global 
//                alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "gage/gage.hh"
#include "arte/RSEG_cmp.hh"

FILE * gageFile = 0;

static int BufferInit = 0;

//*********************************************************************
// function
//*********************************************************************

int gageFillRhp() {

  int     cmpRSEG, cmpAlign;
  float * Cuts;

//---------------------------------------------------------------------
//  open disk file if required
//---------------------------------------------------------------------

  if (BufferInit == 0) {
   char *FileBuffer;
   FileBuffer = getenv("GAGE_BUFFER");
   if (FileBuffer) {
     BufferInit = 1;
     gageFile = fopen(FileBuffer,"w+");
   };
  };

//---------------------------------------------------------------------
//  fill rhp ring buffer for VDS, ECAL/RICH
//---------------------------------------------------------------------

  if (gageSelectVdsEcalRich == 1){

   cmpRSEG  =  Rsegc::ecal |  Rsegc::rich;
   cmpAlign =  Rsegc::vxd;
   Cuts     =  gageCutsVdsEcalRich;

   gageFillRhpVdsEcalRich(cmpRSEG, cmpAlign, Cuts);

  };

//---------------------------------------------------------------------
//  fill rhp ring buffer for VDS OTR
//---------------------------------------------------------------------

  if (gageSelectVdsOtr == 1){

   cmpRSEG  =  Rsegc::vxd;
   cmpAlign =  Rsegc::patt;
   Cuts     =  gageCutsVdsOtr;

   gageFillRhpSegments(cmpRSEG, cmpAlign, Cuts);

  };

//---------------------------------------------------------------------
//  fill rhp histograms for ECAL/RICH, OTR/RICH, OTR/ECAL
//---------------------------------------------------------------------

  if (gagePlotsVdsEcalRich == 1) {

   cmpRSEG  =  Rsegc::ecal |  Rsegc::rich;
   cmpAlign =  Rsegc::vxd;
   Cuts     =  gagePCutsVdsEcalRich;

   gageFillRhpVdsEcalRich(cmpRSEG, cmpAlign, Cuts);
  };
 
  if (gagePlotsRichEcal    == 1) gageFillRhpRich();
  if (gagePlotsOtrEcal     == 1) gageFillRhpOtrEcal();
  if (gagePlotsOtrRich     == 1) gageFillRhpOtrRich();
  if (gagePlotsOtrVds      == 1) gageFillRhpOtrVds();

//---------------------------------------------------------------------
//  
//---------------------------------------------------------------------

  return 0;
}
