/***********************************************************************
* Author :    Siegmund Nowak   10/11/95
* CRLVBK      (partly taken from GLMOTH)
*
* This routine loads for a volume given by its hollerith name IUDET and
* user number NCOPY the top part of the Volume tree in LVOLS (hollerith
* volume names) and LCOPY (user copy numbers. In gives also the link
* number within the mother bank, where the daughter bank JIN is installed*
*
* Arguments  kind         description
*-----------------------------------------------------------------------
* NAME       in           name of the volume under consideration
* NCOPY      in           user number of this volumen
* INDAUT     out          serial number of link in its mother volume (in)
* LVOLS      out          volume names of the top tree
* LCOPY      out          user numbers for the top tree (incl. NCOPY)
***********************************************************************/
#include <stdio.h>
#include "arte/arte.hh"
#include "gean/gclink.h"
#include "gean/Geant2Arte.hh"
// ------------------------------------------------------------------

extern "C"{
void crlvbk_(char *, int &, int &, int &, char *,int *);
} 

void crlvbk_(char *name,int &ncopy,int &indaut,int &nlev,char *lvols ,int *lcopy) {

  Geant2Arte G2A;
  int ivos[15];
  int ivfld =  G2A.GetGvolNumber(name);
  ivos[0] = ivfld;
  int mult = ncopy;
  int nldv = 0;
  int ilev = 0;

//   scan all volumes to check if it could be mother of the current volume
  while (ivfld > 1) {
    for(int ivo = 1; ivo <= *(gcbank_.iq + gclink_.jvolum -2);ivo++ ) {
      if (ivo == ivfld) continue;
      int jvo = *(gcbank_.lq + gclink_.jvolum -1 - ivo);
      int *pji = gcbank_.iq + jvo -1;   float *pjx = (float*)pji; 
      int nin = int(*(pjx+3));
      int in = 0;
      if (!nin) continue;         // volume has no daugthers

      else if (nin < 0) {         // volume is divided 
        int jdiv = *(gcbank_.lq + jvo - 2);
        pji = gcbank_.iq + jdiv -1;     pjx = (float*)pji;
        if(int(*(pjx+2)) != ivfld)       continue;
        if(mult == 0) {
          in = 1;    mult = 1;
        }  
        else  in = mult;
      }

      else {                      // volume has daughters
        int found = 0;  
        for (int in = 1; in <= nin; in++){
          int jin = *(gcbank_.lq + jvo - 1 - in);
          pji = gcbank_.iq + jin -1;     pjx = (float*)pji; 
          if (int(*(pjx+2)) != ivfld)     continue;
          int multi = int(*(pjx+3));
          if (!mult) mult = multi;
          else {
            if (mult != multi) continue;
          }
          found = 1;             break;
        }
        if(!found) continue;
      }

//      mother found    
      lcopy[ilev] = mult;
      if(ilev == 0) indaut = in;
      if (nldv)    break;
      ilev++;
      ivfld = ivo;
      ivos[ilev] = ivo;
      mult = 0;
      if(*(gcbank_.lq + jvo - 1) != 0) nldv = ilev+1;
    } 
  }

//  now rearrange the order of the volumes

  if(ivfld == 1) lcopy[ilev] = 1;
  nlev = ilev + 1;
  int nlv  = nlev/2;
  if(nlv >0)  {
    for (int i = 0; i < nlv; i++) {
      int lid = lcopy[i];  lcopy[i] = lcopy[ilev-i];  lcopy[ilev-i] = lid;
    }
  }

  for (int i=nlev; i>0; i--) 
    memcpy(&lvols[4*i-4], gcbank_.iq + gclink_.jvolum -1 + ivos[nlev-i],4);
}






