#include <vector.h>
#include "arte/arte.hh"
#include "auto/auto.hh"
#include "gean/zgvers.hh"

extern "C" {
   void mmfree_(int &);   void geostat_();
 }
void geostat();

void geofin() {

//  free unused space in detector banks
    mmfree_(ArtePointer<NESL>::getLink().getRef());
    mmfree_(ArtePointer<NEDE>::getLink().getRef());
    mmfree_(ArtePointer<NCAL>::getLink().getRef());
    mmfree_(ArtePointer<NWAL>::getLink().getRef());

//  delete intermediate vector  hg_tmed;
    extern vector<int*>    hg_tmed;
    vector<int*>::iterator tm; 
    int *ptr;
    for (tm=hg_tmed.begin(); tm != hg_tmed.end(); ++tm) {
      ptr = *tm;
      delete [] ptr; 
    }

//  set rotation in NEDE and NWAL to exact zero if roundings gave nonzero
    ArteTableIterator<NEDE> gd;
    for(; gd.valid(); gd.next()){
      for (int i=0; i<9; i++) {
	if(fabs(gd->rot[i]) < 1.e-6) gd->rot[i] =0.; 
      }     
    }
    ArteTableIterator<NWAL> gw;
    for(; gw.valid(); gw.next()){
      for (int i=0; i<9; i++) {
	if(fabs(gw->rot[i]) < 1.e-6) gw->rot[i] =0.; 
      }     
    }

//  print final statistic
    geostat(); 

    zgvers::fin();

}
