
/********************************************************************
source:    gtest_hbook.C

created:   14. May 2000 by Siegmund Nowak
********************************************************************/
#include <stdio.h>
#include "arte/arte.hh"
#include "gean/gcflag.h"
#include "gean/ZGESL.h"

extern "C" {
    void hbook1_(int*,char*,int*,float*,float*,float*, int );
    void hbook2_(int*,char*,int*,float*,float*,int*,float*,float*,float*,int);
    void hbookn_(int*,char*,int*,char*,int*,char*,int,int,int );
}
void hb1();
void hb3();

void gtest_hbook() {
  if (gcflag_.iswit[5] == 1) hb1();
  else if( gcflag_.iswit[5] == 3) hb3();  
}

void hbook1( int id, char *title, int nbin, float xl, float xh )
{
  float dummy=0.;
  hbook1_( &id, title, &nbin, &xl, &xh, &dummy, strlen(title) );
  return;
}

void hbook2( int id, char *title, int nbin1, float xl1, float xh1,
                                  int nbin2, float xl2, float xh2, float bw )
{
  hbook2_( & id, title, & nbin1, &xl1, &xh1, & nbin2, &xl2, &xh2, &bw,
           strlen(title) );
  return;
}

void hbookn( int id, char * title, char * topdir, char tags[] )
{
  int n=0;
  int l=0, j=0;
  int elli = 0;
  char * c;
  char * calloc;
  int bufsiz = 1000;

  for (c=tags; *c != '\0'; c += 1)
    if (!strncmp( c, ",", 1)) 
    {
      n++;
      if (!elli) { printf ("hbookn > idiot !\n"); exit (999); }
      if (l<elli) l = elli;
      elli = 0;
    }
    else
    {
      elli++;
    }

  calloc = (char *) malloc ((l*(n+1)+1) *  sizeof(char));
  j = elli = 0;

  for (c=tags; *c != '\0'; c += 1)
    if (!strncmp( c, ",", 1)) 
    {
      while (elli<l)
      {
        calloc[j++] = *" ";
        elli++;
      }
      elli = 0;
    }
    else
    {
      calloc[j++] = *c;
      elli++;
    }

  while (elli<l)
  {
    calloc[j++] = *" ";
    elli++;
  }

  calloc [j] = '\0';
  n++;

  hbookn_( & id, title, & n, topdir, & bufsiz, calloc, strlen(title),
           strlen(topdir), l );

  free ((void *) calloc);

  return;
}




void hb1(){
   hbook1( 1,"Time per event$",100,0.,500.);
   hbook1( 2,"GEAN vertices per event $",100,0.5,20000.5);
   hbook1( 3,"MVER per event$",100,0.,5000.);
   hbook1( 4,"GEAN tracks per event$",100,0.5,20000.5);
   hbook1( 5,"MTRA per event$",100,0.,5000.);
   hbook1( 6,"MIMP per event$",100,0.,50000.);
   hbook1( 7,"MCAL per event$",100,0.,5000.);
   hbook1( 8,"MTCP per event$",100,0.,5000.);

   hbook1(10,"SVD mimps$",100,0.5,1000.5);
   hbook1(11,"OTR mimps$",100,0.5,10000.5);
   hbook1(12,"ITR mimps$",100,0.5,5000.5);
   hbook1(13,"PTC mimps$",100,0.5,1000.5);
   hbook1(14,"RICH ckov mimps$",100,0.5,10000.5);
   hbook1(15,"TRD mimps$",100,0.5,10000.5);
   hbook1(16,"MUON mimps$",100,0.5,500.5);
   hbook1(17,"MUX mimps$",100,0.5,200.5);
   hbook1(18,"RICH entry mimps$",100,0.5,2000.5);

   hbook1(30,"track id$",100,  0.5,100.5);
   hbook1(31,"track id$",100,100.5,200.5);
   hbook1(32,"track id$",100,200.5,300.5);
   hbook1(33,"track id$",100,300.5,400.5);
   hbook1(34,"track id$",100,400.5,500.5);
   hbook1(35,"track id$",100,500.5,600.5);

   hbook1(36,"momentum below 1 GeV$",100,0.,1.);
   hbook1(37,"momentum above 1 GeV$",100,0.,200.);
   hbook1(38,"track-flags$",10,-.5,9.5);
   hbook1(39,"len$",110,0.,2200.);
   hbook1(40,"pt$",100,0.,4.);

   hbook1(49,"origin MTRA per event$",100,0.,200.);
   hbook1(41,"origin track id$",100,  0.5,100.5);
   hbook1(42,"origin id$",100,100.5,200.5);
   hbook1(43,"origin id$",100,200.5,300.5);
   hbook1(44,"origin id$",100,300.5,400.5);
   hbook1(45,"origin id$",100,400.5,500.5);
   hbook1(46,"origin id$",100,500.5,600.5);
   hbook1(47,"momentum$",100,0.,500.);
   hbook1(48,"pt$",100,0.,4.);

   int ngesl = ArteTable<GESL>::size();
   hbook1(100,"MIMP in ISL$",ngesl,.5,float(ngesl)+.5);
   hbook1(200,"HITB in ISL$",ngesl,.5,float(ngesl)+.5);
   for(ArteTableIterator<GESL> sl ; sl.valid(); sl.next()) {
     float min = float(sl->fpl) - .5;
     float max = float(sl->fpl + sl->npl-1) +.5;
     if(sl->cmp == LGESL_SIL) {
       hbook1(100+sl->nsl,"SVD-TEST$",sl->npl,min,max);
       hbook1(100+sl->nsl+20,"SVD-TEST$",sl->npl,min,max);
     }
     else if(sl->cmp == LGESL_WCH) { 
       hbook1(200+sl->nsl,"OTR-TEST$",sl->npl,min,max);
       hbook1(200+sl->nsl+20,"OTR-TEST$",sl->npl,min,max);
     }
     else if(sl->cmp == LGESL_MSG) {
       hbook1(300+sl->nsl,"ITR-TEST$",sl->npl,min,max);
       hbook1(300+sl->nsl+20,"ITR-TEST$",sl->npl,min,max);
     }
     else if(sl->cmp == LGESL_PTC) {
       hbook1(400+sl->nsl,"PTC-TEST$",sl->npl,min,max);
       hbook1(400+sl->nsl+20,"PTC-TEST$",sl->npl,min,max);
     } 
     else if(sl->cmp == LGESL_RIC) {
       hbook1(500+sl->nsl,"RICH-TEST$",sl->npl,min,max);
       hbook1(500+sl->nsl+20,"RICH-TEST$",sl->npl,min,max);
     }  
     else if(sl->cmp == LGESL_TRD) { 
       hbook1(600+sl->nsl,"TRD-TEST$",sl->npl,min,max);
       hbook1(600+sl->nsl+20,"TRD-TEST$",sl->npl,min,max);
     } 
     else if(sl->cmp == LGESL_ECA) { 
       hbook2(700,"energy for modules$",56,0.,56.,42,0.,42.,0.);
     } 
     else if(sl->cmp == LGESL_MUO) {
       hbook1(800+sl->nsl,"MUO-TEST$",sl->npl,min,max);
       hbook1(800+sl->nsl+20,"MUO-TEST$",sl->npl,min,max);
     } 
     else if(sl->cmp == LGESL_MUX) {
       hbook1(900+sl->nsl,"MUX-TEST$",sl->npl,min,max);
       hbook1(900+sl->nsl+20,"MUX-TEST$",sl->npl,min,max);
     }
   }

}   
  
void hb3(){ 
   hbook1(101,"INTERACTIONS$",100,   .5,100.5);
   hbook1(102,"INTERACTIONS$",100,100.5,200.5);
   hbook1(103,"INTERACTIONS$",100,200.5,300.5);
   hbook1(104,"INTERACTIONS$",100,300.5,400.5);

   hbook2(105,"z vs x $",270,-20.,1330.,160,-400,400,63);
   hbook2(106,"z vs y $",270,-20.,1330.,160,-400,400,63);
   hbook2(107,"z vs r $",100,180.,680.,100,1.8,11.8,63);
   hbook2(108,"z vs r $",130,680.,1330.,100,1.8,11.8,63);



   hbook2(110,"z vs x RPOT$",220,-20.,200.,130, -65., 65.,63);
   hbook2(111,"z vs y RPOT$",220,-20.,200.,130, -65., 65.,63);
   hbook2(112,"z vs r RPOT$",220,-20.,200., 65,   0., 65.,63);

   hbook2(120,"z vs x MAGN$",104,180.,700.,100,-100.,100.,63);
   hbook2(121,"z vs y MAGN$",104,180.,700.,100,-100.,100.,63);
   hbook2(122,"z vs r MAGN$",104,180.,700.,150,   0.,150.,63);

   hbook2(130,"z vs x PCRC$",100,680.,1180.,150,-300.,300.,63);
   hbook2(131,"z vs y PCRC$",100,680.,1180.,150,-300.,300.,63);
   hbook2(132,"z vs r PCRC$",100,680.,1180.,150,   0.,150.,63);

   hbook2(140,"z vs x TRD $",124,1175.,1330.,100,-300.,300.,63);       
   hbook2(141,"z vs y TRD $",124,1175.,1330.,100,-300.,300.,63);
   hbook2(142,"z vs r TRD $",124,1175.,1330.,100,   0.,100.,63);

}



