/***********************************************************************
*
* written by Siegmund Nowak 97/03/20
*
* This routine defines default values for HBGEAN constants
*
* called from ATINIT
***********************************************************************/
#include "gean/gcphys.h"
#include "gean/gctmed.h"
#include "gean/zgbeam.hh"
#include "gean/zgvers.hh"

extern "C" {
   void hgcons_();
}

float nspirl_angle;
float muon_turbfl;

void hgcons_() {

//    the default value will be 
      gcphys_.iloss = 1;

//    maximal rotation angle for spiraling particles
      nspirl_angle = 94.25;                     // 30*pi

//    switch for fast muon tracing
      muon_turbfl = 0; 

//     Cerenkov photon generation will be switched on by default
      gctlit_.itckov = 1;

//     time spread of primary vertex will be switched off by default
       zgbeam ZGB;
       ZGB.Set_time(0,0.,0.);

//     beam shift ( default is ON )
       ZGB.Set_hdir(-1);

//     default values for DETV (long/short/user version)
       zgvers ZGV;
       ZGV.lsu_default();
}       




