/***********************************************************************
*
* Author :    Siegmund Nowak   05/08/96*
* Description: gives the index of the material <name> inside GMAT
*
***********************************************************************/
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

extern "C" {
int matnum_(char *name, const int len) {
  char cname[13]; 
  for (int i=0; i<len; i++) cname[i] = toupper(name[i]);   
  cname[len] = '\0';

  for(ArteTableIterator<GMAT> gm; gm.valid(); gm.next()){
    if(!strncmp(gm->name,cname,len)) return gm.index();
  }
  arteMsg << "Material " << cname << " does not exist";
  arteMsg.warn();
  return 0;
}
}



