
/***********************************************************************
*-- Author :    Siegmund Nowak   05/08/96
*
* Description: gives gean-tmed nr for given sensflag and material name 

***********************************************************************/
#include <vector.h>
#include <ctype.h>
#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

extern "C" {

   int mednum_(int *isfl, char *cinp, const int leng) {
      extern vector<int*>    hg_tmed;

//    convert lower case into upper case and remove blanks
      char cnam[13];
      
      int len = leng;
      if(len > 12) len = 12;

      for( int k=0; k<len; k++) {
          if(cinp[k] == ' ') { len=k;  break;
          } 
          cnam[k] = toupper(cinp[k]);
	}
      cnam[len] = '\0';

//    go through material table GMAT
      int mednm = 0;
      for (ArteTableIterator<GMAT> gm; gm.valid(); gm.next() ) {
         if(!strncmp(gm->name,cnam,len)){ 
             vector<int*>::iterator tm = hg_tmed.begin() + gm.index() -1;
             mednm = (*tm)[*isfl-1];
             if(mednm == 0) break;
             return mednm;
         }
      }
      arteMsg << "medium " << cnam <<  
              " does not exist with sens/magnfld flag " << *isfl;
      arteMsg.error();
      return mednm;
   }      
}





