
/***********************************************************************
* SZH3_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced NEDE/NWAL
* banks for the rich 
*
*       called from GEOMAIN
*
* The transferred parameters are
* void szh3_arte_(int ncal,int nwal,char lvols[],int lcopy[],int nlev)  
***********************************************************************/

#include <stdio.h>
#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/gclink.h"
#include "gean/zgeom.h"
#include "gean/Geant2Arte.hh"

void szh3_arte(const int ncal, const int, const char lvols[],
                               const int lcopy[], const int nlev) {

  if(!ncal) return; 
  if(nlev == 3) {
    int ll =lcopy[nlev]&4095;
    if(ll == 2) {
        ArtePointer<NCAL> n2(ncal), n1(ncal-1);
        float z1 = n1->zmin+n1->zmax;  float z2 = n2->zmin+n2->zmax;
        if(z1 < z2) {
           n1->ncl = 1;  n2->ncl=2;
        }
        else { 
           n2->ncl = 1;  n1->ncl=2;
        }
     }
  }   
  zgvol ZGVOL;
  char volname[4];
  memcpy(volname,&lvols[4*nlev-4],4); 
  int Gvolnum = ZGVOL.Check_Gvol(volname);
  int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
  int *pji = gcbank_.iq + jvos + 2;
  float *pjx = (float *)pji;
  int nin = int(*pjx);
  for(int in = 1; in <= nin;in++) {
      int jin = *(gcbank_.lq + jvos -1 -in);
      pji = gcbank_.iq + jin - 1;
      pjx = (float *)pji; 
      int iuser = int(*(pjx+3));
      if(iuser == lcopy[nlev] && !memcmp
            (&lvols[4*nlev],gcbank_.iq+gclink_.jvolum-1+int(*(pjx+2)),4)){
        if(nlev == 2) { 
           iuser = iuser&037777770000; 
           float jx = float(iuser+ncal);
           memcpy(gcbank_.iq + jin + 2, &jx,4);
        }
        else if(nlev == 3) {
          ArtePointer<NCAL> nd(ncal);
          float cen = 0.5*(nd->xmin + nd->xmax);
          nd->xmin = cen - *(pjx+12); nd->xmax = cen + *(pjx+12);
          cen = 0.5*(nd->ymin + nd->ymax);
          nd->ymin = cen - *(pjx+11); nd->ymax = cen + *(pjx+11);
          cen = 0.5*(nd->zmin + nd->zmax);
          nd->zmin = cen - *(pjx+10); nd->zmax = cen + *(pjx+10);      
        } 
        return;
      }
  }
      arteMsg << "szh3_arte: copy not found -contact S.Nowak ";
      arteMsg.error();        
}          

/* szh3_arte_ */









