#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/zgvers.hh"
#include "gean/hgdat.h"
#include "gean/ZGDETV.h"
#include "gean/ZGESL.h"

geovers *zgvers::ptvers; 
int zgvers::maxvers ;

void zgvers::ini(int n){ 
        ptvers = new geovers[n];
        if(ptvers==NULL) {
           arteMsg << "no geovers[32] allocated";
           arteMsg.error();      }
        maxvers = n;}

void zgvers::fin() {delete [] ptvers;}   

void zgvers::Set_default() {
  for (int i=0; i<maxvers; i++) {
        geovers *vers = verspointer(i);   
        vers->vers_cmp = 0;
        vers->vers_nr  = -1;
        memset(vers->datafile,' ',32);
  }
}           
 
float  zgvers::Read_geovers(char *card) {
        int cmp=0; double in;  float vn;  char taga[32];
        int nitem=sscanf(card,"%s %d %f ",taga,&cmp,&vn);
        if (nitem!=3)  {
           arteMsg <<"check data on version cards in geovers";
           arteMsg.error();
        }
        geovers *vers = ptvers + cmp -1 ;
        fillstr(taga,12);
        strncpy(vers->name,taga,12);  
        card+=itemlength(card,nitem);
        nitem=sscanf(card,"%s",taga);
        char *ptr = &taga[0];
        while (strlen(ptr) != 0) {
           ptr = strpbrk(ptr,"0123456789");
           if(ptr == NULL) break;
	   if(strspn(ptr,"0123456789") == 6) { 
               in = strtod(ptr,&ptr); vn = float(in)/10000.;   break;
           }
        }
        vers->vers_cmp = cmp; 
        vers->vers_nr = vn;

        if(nitem == 1) {
           int n = strlen(taga);
           if(n>1 && n<32) {
              strncpy(vers->datafile,taga,n); vers->datafile[n]='\0';
           } 
           ArtePointer<NGHD> ghd(1);
           ghd->gevs[cmp-1] = vers->vers_nr;
        }
        if(zgdetv_.DETV[cmp-1] == 'U') return vers->vers_nr;   
        if(cmp == LGESL_FLD  && zgdetv_.DETV[cmp-1] != ' ')
                                	return vers->vers_nr;
        card+=itemlength(card,nitem);
        memset(taga,' ',32); 
        nitem=sscanf(card,"%s",taga);
        if(nitem == 1) zgdetv_.DETV[cmp-1] = toupper(taga[0]); 
        return vers->vers_nr;
      }

  float zgvers::Compare_vers_nr(int type) {
        int found = 0;   geovers *vers;
        for (int nr=0;nr<32;nr++) { 
           vers = ptvers + nr;
           if(type == vers->vers_cmp) { found = 1; break;} }
        if(found ==0) { 
            arteMsg <<"vers_nr " << type << " does not exist" ;
            arteMsg.error(); 
	    return 0;}
        else { 
            ArtePointer<NGHD> ghd(1);
            if(ghd->gevs[type-1]==vers->vers_nr)  return vers->vers_nr;
            else return -1.;}}

  char* zgvers::Get_vers_datafile(int type) {
        geovers *vers = verspointer(type -1);
        ArtePointer<NGHD> ghd(1);
        if(ghd->gevs[type-1]==vers->vers_nr) return vers->datafile;
        else return "not_found";} 

  void zgvers::lsu_default() {
      memset(zgdetv_.DETV,' ',32);  
      zgdetv_.DETV[LGESL_SIL-1 ] = 'L';
      zgdetv_.DETV[LGESL_WCH-1 ] = 'L';
      zgdetv_.DETV[LGESL_MSG-1 ] = 'L';
      zgdetv_.DETV[LGESL_PTC-1 ] = 'L';
      zgdetv_.DETV[LGESL_RIC-1 ] = 'L';
      zgdetv_.DETV[LGESL_ECA-1 ] = 'L';
      zgdetv_.DETV[LGESL_TAR-1 ] = 'L';
      zgdetv_.DETV[LGESL_FLD-1 ] = 'L';
      zgdetv_.DETV[LGESL_HOD1-1] = 'L';
      zgdetv_.DETV[LGESL_HOD2-1] = 'L';
      zgdetv_.DETV[LGESL_HOD3-1] = 'L';
      zgdetv_.DETV[LGESL_TRSL-1] = 'S';
      zgdetv_.DETV[LGESL_RPOT-1] = 'L';
      zgdetv_.DETV[LGESL_MAG-1 ] = 'L';
      zgdetv_.DETV[LGESL_PPIP-1] = 'L';
      zgdetv_.DETV[LGESL_EPIP-1] = 'L';
      zgdetv_.DETV[LGESL_MUON-1] = 'L';
     }





