*CMZ :          10/04/96  23.07.23  by  Fedor Ratnikov
*CMZ :  1.00/00 22/12/94  15.04.15  by  Dominik Ressing
*-- Author :    Dominik Ressing   22/12/94
************************************************************************
*
* L1CPREL
* written by Dominik Ressing, 22/12/94 13.40.04
*
* This routines action:
* JFrom,iRowFrom specify an entry in an allready existing relation table
* between two banks. All relation entries are added to the entry JTo,iRowTo.
* Hence this routine copies the rlations between A<->B into C<->B where
* A is ``from'' and C is ``to''. If a relation C<->B is existing it is not
* stored a second time.
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* ix         in           zebra store division
* iDir       in           direction of relation 1 or 2
* JFrom      in           relation table for existing relation
* iRowFrom   in           row in table of existin relation
* JTo        in           new relation table pointer
* iRowTo     in           row for new relation
*
************************************************************************
c
      SUBROUTINE L1CPREL(ix,iDir,JFrom,iRowFrom,JTo,iRowTo)
c
      IMPLICIT NONE
#include "l1si/rcbank.fi"
#include "l1si/rcfdef.fi"
c
      INTEGER ix,iDir,JFrom,iRowFrom,JTo,iRowTo
      INTEGER jAux,iRowRel
c
#include "l1si/rcfunc.ff"
c
      IF ( iDir.eq.2 ) THEN
         jAux = I_2(iRowFrom,JFrom)                 ! first ``From'' relation pointer
         DO WHILE (jAux.gt.0 )                      ! while there are ``from'' relations
            iRowRel = K_2(jAux,JFrom)               ! related ``From'' row
            CALL l1exrel(ix,JTo,iRowTo,iRowRel)     ! establish new ``To'' relation
            jAux = N_2(jAux,JFrom)                  ! next ``From'' relation pointer
         END DO
      ELSE
         jAux = I_1(iRowFrom,JFrom)                 ! first ``From'' relation pointer
         DO WHILE (jAux.gt.0 )                      ! while there are ``from'' relations
            iRowRel = K_1(jAux,JFrom)               ! related ``From'' row
            CALL l1exrel(ix,JTo,iRowTo,iRowRel)     ! establish new ``To'' relation
            jAux = N_1(jAux,JFrom)                  ! next ``From'' relation pointer
         END DO
      END IF
c
      RETURN
c
      END
