*CMZ :  1.00/01 13/03/95  21.34.36  by  Fedor Ratnikov
*CMZ :  1.00/00 02/01/95  19.26.08  by  Dominik Ressing
*CMZ :  0.01/02 22/08/94  12.18.25  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  17.09.41  by  Dominik Ressing
*-- Author :    Dominik Ressing   20/07/94
************************************************************************************
*
* L1MESDE
* written by Dominik Ressing, 20/07/94 18.31.03
*
* This routines action:
* Deletes message: RE-chain it from the used to the free chain!
* The BX trace pointers L1MEbx are maintained.
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* Lmess        in          pointer to message in L1MEstor
* iAction      in          Flag weather or not to call for user actions
*
************************************************************************************
c
      SUBROUTINE L1MESDE(Lmess,iAction)
c
      IMPLICIT NONE
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER Lmess,iBX,iBXpo,nBX,iAction
c
c     --- check weather this message is valid
      IF ( ABS(L1MEstor(Lmess+L1MEactive)).eq.L1MEacDEL ) THEN
         WRITE(L1LUNprn,*)
     &        'L1MESDE ==> message was already deleted !!!:',Lmess
         RETURN
      END IF
c     --- check weather it is the first message for BX
      iBX   = L1MEstor(Lmess+L1MEprbx)
      iBXpo = L1MEbx(L1MEBXfipo,iBX)
      nBX   = L1MEbx(L1MEBXn,iBX)
      IF ( iBXpo.eq.Lmess ) THEN
         IF ( nBX.gt.1 ) THEN
            iBXpo = L1MEstor(Lmess+L1MEnext) ! pointer to next message
            L1MEbx(L1MEBXfipo,iBX) = iBXpo   ! set new first-of-BX message
         ELSE
            L1MEbx(L1MEBXfipo,iBX) = 0       ! no more messages for this BX
         END IF
      END IF
      L1MEbx(L1MEBXn,iBX) = nBX - 1          ! one message for this BX less
c
      IF ( L1MEstor(Lmess+L1MEactive).gt.0 ) THEN   ! is this message active ?
         nBX = L1MEbx(L1MEBXnact,iBX)               ! number of active messaages for BX
         nBX = nBX - 1
         L1MEbx(L1MEBXnact,iBX) = nBX
      END IF
c
c     --- disconnect from used chain
      CALL l1mesdi(Lmess)
c     --- connect as first message in the free chain
      CALL l1mesco(Lmess,L1MEfree)
c     --- call user routine
      IF ( iAction.eq.L1MEDEusr ) CALL l1usrmd(Lmess)
      L1MEstor(Lmess+L1MEactive) = -1*L1MEacDEL   ! mark as deleted
c
c     --- maintain number of active messages
      IF ( nBX.lt.0 ) THEN      ! this should never happen
         WRITE(L1LUNprn,*)
     &        'L1MESDE ==> invalid active count',nBX,iBX
         L1MEbx(L1MEBXnact,iBX) = 0
      ELSE IF ( nBX.eq.0.and.iAction.ne.L1MEDEnoscr ) THEN
         CALL l1messc(iBX)  ! delete all messages for BX
         CALL l1usrev(iBX)
         CALL l1datsc(iBX)  ! sratch detector data for BX
      END IF
c
      RETURN
c
      END
