*CMZ :          04/09/96  20.21.56  by  Fedor Ratnikov
*CMZ :  1.01/02 06/02/96  00.56.51  by  Fedor Ratnikov
*CMZ :  1.01/00 18/12/95  21.10.50  by  Fedor Ratnikov
*CMZ :  1.00/06 28/09/95  18.17.56  by   Ivan Belyaev
*CMZ :  1.00/01 17/08/95  11.12.50  by   Ivan Belyaev
*CMZ :  1.00/00 17/01/95  13.03.04  by  Dominik Ressing
*CMZ :  0.01/03 17/09/94  19.04.51  by  Fedor Ratnikov
*CMZ :  0.01/02 12/09/94  11.54.14  by  Fedor Ratnikov
*CMZ :  0.01/01 24/07/94  17.04.17  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1TPMFA
* written by Dominik Ressing, 24/07/94 16.23.08
*
* This routines action:
* Performes a fast TPM simulation
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* JobPo       in          pointer to job
* val         out         is message still valid ?
* itime       out         time at completion
* ierr        out         error flag
*
************************************************************************
c
      SUBROUTINE L1TPMFA(JobPo,val,itime,ierr)
c
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1kindf.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/l1user.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1banks.fi"
c
      INTEGER NtrkMax,MaxPlane
      PARAMETER(NtrkMAX=100,MaxPlane=10)
      INTEGER JobPo,itime,ierr,MePo,iPcPo,iPoilast,iPoi2,job,
     &        iROI,iTPM,iCharge,ltype,Ntrk(MaxPlane),itrk,ighost,
     &        Npo,Jpo,iBX,
     &        Itrs(NtrkMAX,MaxPlane),Iflas(NtrkMAX,MaxPlane),
     &        mask,iGP,iRP,j,i,iPo,iPoi,
     &        IGtrs(NtrkMAX),iGfla(NtrkMAX),itrks,isor(0:7),ktrk,
     &        nSPbest,itrabest,iSPbest,ibuf,nSP,iSP,Ipo2,jj,itra,
     &        ipretra,iPOmin,iPOmax
      CHARACTER*10 cSP,cRP
      REAL    Etot,Px,Py,Pz,charge,Eratio,dP3,dP3t,Efrac,x,y,z,Pt
      LOGICAL val
      INTEGER IUCOMP,JBIT
      EXTERNAL IUCOMP,JBIT
c
      DATA isor/0,1,1,2,1,2,2,3/
c
#include "arte/Arte.ff"
#include "l1si/l1mesdf.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
c
c
      val = .false.
      ierr = 0
c
      MePo  = L1JOBstore(JobPo+L1JOBmess)             ! this message
      iPcPo = L1MEstor(MePo+L1MEnextPC)               ! this processor
      iBX   = L1MEstor(MePo+L1MEprbx)                 ! this BX
      L1PCstor(iPcPo+L1PCbusy) = L1RUNcutime+L1DEFtpmcyc ! this cycle this TPM is busy
      iTPM = L1PCstor(iPcPo+L1PCnum) ! get TPM num
      IF (L1PARprnlev.GE.1) THEN
         WRITE (L1LUNprn,998) iTPM
 998     FORMAT(1x,'L1TPMFA==> BEGIN ',25('#'),' TPM',i03,1x,25('#'))
      ENDIF
c
      IF ( L1PCstor(iPcPo+L1PCncon).gt.0 ) THEN       ! anything connected ??
         L1MEstor(MePo+L1MEnextPC) =                  ! first connected processor
     &        L1PCstor(iPcPo+L1PCcons)
      IF (L1MEstor(MePo+L1MElast).GE.2) THEN       ! 2 measured points exist
         iPoilast = MePo+L1MEpoint(L1MEstor(MePo+L1MElast)) ! pointer to last Point
         iROI = MePo+L1MEroi(L1MEstor(MePo+L1MElast))
         iPoi2 = MePo+L1MEpoint(L1MEstor(MePo+L1MElast)-1) ! pointer to last but one Point

         IF (L1MEstor(MePo+L1HAprid).NE.L1PREpipi) THEN
          IF (L1PARprnlev.ge.1 ) THEN
             WRITE (L1LUNprn,*) 'L1TPMFA==>  track points (x/y/z)'
             WRITE (L1LUNprn,*) '              ',
     &            T1MEstor(iROI+L1ROIreg+L1GEOINFx0)+
     &              0.5*T1MEstor(iROI+L1ROIreg+L1GEOINFsx),
     &            T1MEstor(iROI+L1ROIreg+L1GEOINFy0)+
     &              0.5*T1MEstor(iROI+L1ROIreg+L1GEOINFsy),
     &            T1MEstor(iROI+L1ROIreg+L1GEOINFz)
              WRITE (L1LUNprn,*) '              ',
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFx0)+
     &              0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsx),
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFy0)+
     &              0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsy),
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFz)
          ENDIF
          CALL L1KIN4M(
     &         T1MEstor(iROI+L1ROIreg+L1GEOINFx0)+
     &                 0.5*T1MEstor(iROI+L1ROIreg+L1GEOINFsx),
     &         T1MEstor(iROI+L1ROIreg+L1GEOINFy0)+
     &                 0.5*T1MEstor(iROI+L1ROIreg+L1GEOINFsy),
     &         T1MEstor(iROI+L1ROIreg+L1GEOINFz),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFx0)+
     &                 0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsx),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFy0)+
     &                 0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsy),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFz),
     &         L1APPROXseco,                               ! second order approximation
     &         Etot,Px,Py,Pz,charge)                       ! track parameters
         ELSE
          iPoilast = MePo + L1MEpoint( 1 )
          iPoi2    = MePo + L1MEpoint( 4 )
          IF (L1PARprnlev.ge.1 ) THEN
             WRITE (L1LUNprn,*) 'L1TPMFA==>  track points (x/y/z)'
             WRITE (L1LUNprn,*) '              ',
     &            T1MEstor(iPoi2+L1POreg+L1GEOINFx0)+
     &              0.5*T1MEstor(iPoi2+L1POreg+L1GEOINFsx),
     &            T1MEstor(iPoi2+L1POreg+L1GEOINFy0)+
     &              0.5*T1MEstor(iPoi2+L1POreg+L1GEOINFsy),
     &            T1MEstor(iPoi2+L1POreg+L1GEOINFz)
              WRITE (L1LUNprn,*) '              ',
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFx0)+
     &              0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsx),
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFy0)+
     &              0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsy),
     &            T1MEstor(iPoilast+L1POreg+L1GEOINFz)
          ENDIF
          CALL L1KIN4M(
     &         T1MEstor(iPoi2+L1POreg+L1GEOINFx0)+
     &                 0.5*T1MEstor(iPoi2+L1POreg+L1GEOINFsx),
     &        T1MEstor(iPoi2+L1POreg+L1GEOINFy0)+
     &                 0.5*T1MEstor(iPoi2+L1POreg+L1GEOINFsy),
     &         T1MEstor(iPoi2+L1POreg+L1GEOINFz),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFx0)+
     &                 0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsx),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFy0)+
     &                 0.5*T1MEstor(iPoilast+L1POreg+L1GEOINFsy),
     &         T1MEstor(iPoilast+L1POreg+L1GEOINFz),
     &         L1APPROXseco,                               ! second order approximation
     &         Etot,Px,Py,Pz,charge)                       ! track parameters
         ENDIF
         iCharge = INT(charge+SIGN(0.1,charge))
c
c        --- get particle type and Apply Bremsstrahlungs Correcion
         Eratio = 1.
         ltype = 0
         IF (L1MEstor(MePo+L1HAprid).EQ.L1PREelec) THEN
            IF (iCharge.GT.0 .and.
     &        T1MEstor(MePo+L1MEbremPlusTh).ge.T1DEFBremKfrac) THEN ! e+
               Eratio = 1.+T1MEstor(MePo+L1MEbremPlus)/Etot
               ltype  = L1MCUeplus
            ELSE IF (iCharge.LT.0 .and.
     &        T1MEstor(MePo+L1MEbremMinusTh).ge.T1DEFBremKfrac) THEN ! e-
               Eratio = 1.+T1MEstor(MePo+L1MEbremMinus)/Etot
               ltype  = L1MCUeminus
            END IF
         ELSE IF (L1MEstor(MePo+L1HAprid).EQ.L1PREmuon) THEN
            IF (iCharge.GT.0) THEN ! mu+
               ltype  = L1MCUmuplus
            ELSE IF (iCharge.LT.0) THEN ! mu-
               ltype  = L1MCUmuminus
            END IF
         ELSE IF (L1MEstor(MePo+L1HAprid).EQ.L1PREpipi) THEN ! P.Pakhlov Trigger
            IF (iCharge.GT.0) THEN ! pi+
               ltype  = L1MCUpiplus
            ELSE IF (iCharge.LT.0) THEN ! pi-
               ltype  = L1MCUpiminus
            END IF
            Eratio = 1.
         END IF
c
         IF (L1PARprnlev.ge.1 ) THEN
            WRITE (L1LUNprn,*)
     &        'L1TPMFA==>  message parameters E/Px/Py/Pz/q/(E+Ebrem)'
            WRITE (L1LUNprn,'(11X,4F8.3,I3,f8.3)')
     &        Etot,Px,Py,Pz,iCharge,Etot*Eratio
         ENDIF
C*
C*       Find the Maximal Transverse Momentum
C*
         Pt = SQRT( Px*Px + Py*Py )
         IF( Pt .LE. 10.0 ) THEN  ! skip Huge Transverse Momentums
          IF( Pt .GT. T1EVMaxPtValues( ltype , iBX ) ) THEN
           T1EVMaxPtValues( ltype , iBX ) = Pt
          ENDIF
         ENDIF
c
c        find ``closest to message'' track:
c
         Ntrk(1) = N_U(JMTRA)
         dP3 = 99999999.
         itrk = 0
         DO i=1,Ntrk(1)
            CALL l1getrx(i,Jpo)
            IF ( Jpo.gt.0 ) THEN  ! compare momentum after magnet
               Efrac = Q(Jpo+L1_TRK_PAFTER)/   ! fraction of momentum after Magnet
     &                           SQRT(FMTRA_PX(i)**2+
     &                                FMTRA_PY(i)**2+
     &                                FMTRA_PZ(i)**2)
               dP3t = ((FMTRA_PX(i)*Efrac-Px)**2+
     &                 (FMTRA_PY(i)*Efrac-Py)**2+
     &                 (FMTRA_PZ(i)*Efrac-Pz)**2)/Etot**2
            ELSE   ! compare momentum in front of magnet
               dP3t = ( (FMTRA_PX(i)-Px*Eratio)**2+
     &              (FMTRA_PY(i)-Py*Eratio)**2+
     &              (FMTRA_PZ(i)-Pz*Eratio)**2  )/(Etot*Eratio)**2
            END IF
            IF ( dP3t.lt.1.0 ) THEN   ! store this difference for track
               IF ( Jpo.gt.0 ) THEN
                  IF ( Q(Jpo+L1_TRK_DIFF).ge.0 ) THEN
                     Q(Jpo+L1_TRK_DIFF) =
     &                 MIN(Q(Jpo+L1_TRK_DIFF),dP3t)
                  ELSE
                     Q(Jpo+L1_TRK_DIFF) = dP3t
                  END IF
               END IF
            END IF
            IF ( dP3t.lt.dP3 ) THEN
               dP3 = dP3t
               itrk = i
            END IF
         END DO
         dP3 = SQRT(dP3)
c
c        --- find ghostivity of message:
         IF(L1MEstor(MePo+L1HAprid).EQ.L1PREelec) THEN  ! electron
                                                        ! pretrigger
          CALL L1ECAPO(MePo,iPreTra,x,y,z)
          iPOmin = 1            ! do not consider Pretrigger point
          iPOmax = L1MEstor(MePo+L1MElast)
         ELSEIF(L1MEstor(MePo+L1HAprid).EQ.L1PREmuon) THEN
          CALL L1MUOPO(MePo,iPreTra,x,y,z)
          iPOmin = 2            ! do not consider 2 Pretrigger point
          iPOmax = L1MEstor(MePo+L1MElast)
         ELSEIF(L1MEstor(MePo+L1HAprid).EQ.L1PREpipi) THEN
          iPreTra = 0
          iPOmin = 0            ! do not consider 2 Pretrigger point
          iPOmax = L1MEstor(MePo+L1MElast)
         ENDIF
         Npo = iPOmax-iPOmin+1
         IF(Npo.GT.MaxPlane)   THEN
            PRINT *, 'L1TPMFA=> Error: too many planes:',Npo
         ELSE
            iRP = 0       ! No real points so far
            DO Ipo = 1,Npo
               iPoi = MePo+L1MEpoint(Ipo-1+iPOmin) ! pointer to point
               Ntrk(Ipo) = NtrkMAX ! dimension of Itrs,Iflas
               IF(L1MEstor(iPoi+L1POtrkp).NE.0)  THEN ! stereowires
                CALL L1GETRS(L1MEstor(iPoi+L1POtrk0), ! find all tracks for point
     &               L1MEstor(iPoi+L1POtrkp),
     &               L1MEstor(iPoi+L1POtrkn),
     &               Ntrk(Ipo),Itrs(1,Ipo),Iflas(1,Ipo))
               ELSE    ! padlike: zero angles only
                CALL L1GETR0(L1MEstor(iPoi+L1POtrk0),Ntrk(Ipo),
     &              Itrs(1,Ipo))
                DO j=1,Ntrk(Ipo)
                 Iflas(j,Ipo) = 7
                ENDDO
               ENDIF
               j = IUCOMP(7,Iflas(1,Ipo),Ntrk(Ipo))    ! look for real
               IF(j.GT.0)  THEN
                  CALL SBIT1(iRP,Ipo)
               ENDIF
            ENDDO
            nSPbest = 0     ! No self-points yet
            itrabest = 0    ! No best track yet
            iSPbest = 0
            DO Ipo = 1,Npo    ! look for candidates in tracker
               j = IUCOMP(iPreTra,Itrs(1,Ipo),Ntrk(Ipo)) ! match with
                                                        ! pretrigger
               IF(j.GT.1.AND.Iflas(j,Ipo).EQ.7) THEN  ! put it on first
                                                       ! place
                  ibuf = Itrs(1,Ipo)
                  Itrs(1,Ipo) = Itrs(j,Ipo)
                  Itrs(j,Ipo) = ibuf
                  ibuf = Iflas(1,Ipo)
                  Iflas(1,Ipo) = Iflas(j,Ipo)
                  Iflas(j,Ipo) = ibuf
               ENDIF
               DO j=1,Ntrk(Ipo)
                  IF(Iflas(j,Ipo).EQ.7)   THEN   ! full hit
                     iSP = 0
                     CALL SBIT1(iSP,Ipo)
                     itra = Itrs(j,Ipo)
                     nSP = 1
                     DO Ipo2 = 1,Npo
                        IF(Ipo2.NE.Ipo)   THEN
                           jj = IUCOMP(itra,Itrs(1,Ipo2),Ntrk(Ipo2))
                           IF(jj.GT.0)    THEN ! hit for track found
                              IF(Iflas(jj,Ipo2).EQ.7) THEN
                                 CALL SBIT1(iSP,Ipo2)
                                 nSP = nSP+1
                              ENDIF
                           ENDIF
                        ENDIF
                     ENDDO
                     IF (nSP.GT.nSPbest)   THEN   ! best found
                        nSPbest = nSP
                        itrabest = itra
                        iSPbest = iSP
                     ENDIF
                  ENDIF
               ENDDO
            ENDDO
         ENDIF
c
         IF (L1PARprnlev.gt.1)   THEN
            DO j=1,Npo
               IF(JBIT(iSPbest,j).EQ.0)  THEN
                  cSP(j:j) = '-'
               ELSE
                  cSP(j:j) = '+'
               ENDIF
               IF(JBIT(iRP,j).EQ.0)  THEN
                  cRP(j:j) = '-'
               ELSE
                  cRP(j:j) = '+'
               ENDIF
            ENDDO
            DO j=Npo+1,MaxPlane
             cSP(j:j) = ' '
             cRP(j:j) = ' '
            ENDDO
            WRITE(L1LUNprn,850) MePo,iPreTra,itrabest,
     &           cSP(1:Npo),cRP(1:Npo)
 850        FORMAT(1x,'L1TPMFA==>  assign to message ',i5,
     &           ' PRE track:',i4,' TFU track:',i4/
     &           13x,'self points:',A10,'; real points:',A10)
         ENDIF
c
c        fill  message with parameters from track reconstruction
c
         T1MEstor(MePo+L1HApx)     = Px
         T1MEstor(MePo+L1HApy)     = Py
         T1MEstor(MePo+L1HApz)     = Pz
         L1MEstor(MePo+L1HAcharge) = iCharge
         T1MEstor(MePo+L1MEpx)     = Px
         T1MEstor(MePo+L1MEpy)     = Py
         T1MEstor(MePo+L1MEpz)     = Pz
         T1MEstor(MePo+L1MEp)      = Etot
         L1MEstor(MePo+L1MEcharge) = iCharge
         T1MEstor(MePo+L1MEBremRatio) = Eratio
         L1MEstor(MePo+L1MEpartID) = ltype
         L1MEstor(MePo+L1MEpretrk)  = iPreTra
         L1MEstor(MePo+L1MEtrktrk)  = itrabest
         T1MEstor(MePo+L1MEtrkDP)  = dP3
         L1MEstor(MePo+L1MEghost)  = nSPbest
         L1MEstor(MePo+L1MEselfP) = iSPbest
         L1MEstor(MePo+L1MErealP)  = iRP
c
c          L1MEstor(MePo+L1MElast)   = L1MEstor(MePo+L1MElast)+1
         L1MEstor(MePo+L1MEactive)   = L1MEacTPM          ! last processed is TPM
         itime = L1RUNcutime + L1DEFtpmcyc*L1DEFtpmNcyc   ! add execution time
         val = .true.
      END IF
      END IF
c
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,999)
 999     FORMAT(1x,'L1TPMFA==> END ',60('#'))
      END IF
c
      RETURN
c
      END
