*-- Author :    Rainer Mankel   19/05/95
*-- Modified by Wolfgang Gradl <gradl@mail.desy.de> 12/Mar/2002:
*     fix typos preventing RVERs to be listed if no MC vertices
*     are present.

      subroutine prrver()

*     **** print RC vertex table
*     **** called by KUIP

      implicit none
#include "arte/Arte.fi"
      integer iver, iver1, iver2, nprint, rtfitflag, mv, ii
      real fracmv
      character*1 cresp
      character*12 cmoth
#include "auto/MC.fi"
#include "auto/REC.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/MC.ff"
#include "auto/REC.ff"
#include "auto/TOPP.ff"

*     **** number of selected reconstructed vertices
      call kugeti(iver1)
      call kugeti(iver2)

*     **** fixup
      if (jrver.le.0) then
         call mewarn('prver: table RVER is not booked')
         go to 999
      endif

      if (iver2.eq.0) iver2 = iver1
      if (iver1.eq.0) then
       iver1 = 1
       iver2 = iq(jrver+2)
      endif
      iver1 = max(1,iver1)
      iver2 = min(iver2,iq(jrver+2))

      nprint = 0

      do 10 iver=iver1,iver2
         nprint = nprint + 1

         if (mod(nprint,20).eq.1) then
*           **** header
            write(*,'(a6,3a9,a7,a3,a5,a5,a5,a6,a12)')
     +           'ver','x','y','z','mass','nt','rt','fi',
     +           'mv','frac','moth'
         endif

*        **** locate corresponding mver
         mv = 0
         fracmv = 0
         cmoth = ' '
         call tfremv(iver,mv,fracmv)
         if (mv.gt.0) then
            if (omver_btra(mv).gt.0) then
               write(cmoth,'(3a4)') 
     +              (htopp_name(ii,omtra_topp(omver_btra(mv)))
     +              ,ii=1,3)
            endif
         endif

*        **** locate mother rtra
         rtfitflag = 0
         if (orver_btra(iver).gt.0) then
            rtfitflag = irtra_fit(orver_btra(iver))
         endif
         write(* ,'(i6,3f9.3,f7.3,i3,i5,i5,i5,f6.2,a12)')
     +        iver,frver_xv(iver),frver_yv(iver),frver_zv(iver),
     +        frver_mass(iver),
     +        irver_nt(iver),orver_btra(iver),rtfitflag,
     +        mv,fracmv,cmoth

         if (mod(nprint,100).eq.0) then
            print *,' <any key to continue>'
            read(*,'(a1)') cresp
            if (cresp.eq.'q'.or.cresp.eq.'Q') go to 999
         endif

 10   continue

 999  end

