//##
//      /**Author:        Boris Fominykh
//
//      Date:             November 26th, 2001
//
//      returns pad efficiency and two single wire layer efficiencies of pad chamber

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuGetPadEff.h"

  MuGetPadEff  EffPad;
  static  int Ready = 0;
  static float eff0 = 1.;
  static float eff1 = 1.;
  static float eff2 = 1.;

extern "C" void mueffp_(int* iv,float effp[3])
{
// first call - initialization
  if(Ready == 0)
  {
// no efficiency file in kumac
    if(getenv("MUON_PADEFF") == NULL) Ready = -1;
// efficiency file exists in kumac
    else
    {
      if(EffPad.getReady() == 1)
      {
        Ready = 1;
        // cout << "MuEffP: object is ready" << endl;
        // EffPad.print();
      }
      else 
      {
// object initialization
        char fname[128] = "MuPadEff.dat";
        strncpy(fname,getenv("MUON_PADEFF"),128);    
        EffPad.read(fname);
// object initialized correctly
        if(EffPad.getReady() == 1)
        {
          Ready = 1;
          arteMsg << "MuEffP: pad efficiencies are read from file " << fname << endl;
          arteMsg.warn();
          // EffPad.print();
        }
// object is not initialized
        else
        {
          Ready = -1;
          eff0  = -1.;
          eff1  = -1.;
          eff2  = -1.;
          arteMsg << "MuEffP: failed to read pad efficiencies from file " << fname << endl;
          arteMsg.warn();
        }
      }
    }
  }
  if(Ready == -1)
  {
    effp[0] = eff0;
    effp[1] = eff1;
    effp[2] = eff2;
  }
  if(Ready == 1)
  {
    ArtePointer<GEDE> gede(*iv);
    char name[9];
    strncpy(name,&(gede->hwc[0]),9);
    name[8]='\0';
    effp[0] = EffPad.getP(name);
    effp[1] = EffPad.getT(name,0);
    effp[2] = EffPad.getT(name,1);
    // cout << "MuEffP: iv " << dec << *iv << "  " << name << "  effp " << effp[0];
    // cout << " efft1 " << effp[1] << " efft2 " << effp[2] << endl;
  }
  return;  
}
