#ifndef MuGetPadEff_h
#define MuGetPadEff_h 1

//## Class: MuGetPadEff
//      /**Author:        Boris Fominykh
//
//      Date:             November 19th, 2001
//
//      Class:            MuGetPadEff
//
//      Base Class:       none
//
//      Description:
//      Class MuGetPadEff returns efficiency of pad chamber pads and tubes*/

typedef unsigned int   LWord;
typedef unsigned short Word;

class MuGetPadEff
{
public:
    //## Constructor
           MuGetPadEff();
    //## Destructor
           ~MuGetPadEff();

    // public methods
      //        /** Clear the object contents */
      void clear();
      //        /** Print pad and tube efficiencies */
      void print();
      //        /** Read pad and tube efficiencies from file*/
      int read(char* file);
      //        /** Get pad efficiency*/
      float getP(char* chname);
      //        /** Get tube efficiency*/
      float getT(char* chname,int sd);

    //## Get and Set Operations for Class Attributes
      int  getReady();

  protected:

    int Ready;
    static const Word NslG  = 2;
    static const Word NudG  = 2;
    static const Word NchG  = 34;
    static const Word NsdG  = 2;
    float EffP[NslG][NudG][NchG];
    float EffT[NslG][NudG][NchG][NsdG];
 
  private:

};

//## Get and Set Operations for Class Attributes (inline)

inline int MuGetPadEff::getReady()
{
  return Ready;
}

#endif


