
*  B.Fominykh  20.04.2000
*  the program of MuonID package
*  calculates the MU1, MU2 contributions to muon likelihood
*  input:  IBR     - branch number
*          MSL     - muon superlayer
*          IPR     - print control
*  otput:  NHT     - number of hits
*          XP(6)   - x,y,z,cov of space point
*          LHS     - likelyhood of shape           
*          LHP     - likelyhood of position           
*          NDF     - degree of freedom number
*
*  updated 05.01.2001 by B.Fominykh - more soft cut is implemented
*
*
      SUBROUTINE MURLH12(IBR,MSL,IPR,NHT,XP,LHS,LHP,NDF)
C-    ==================================================
      IMPLICIT NONE
      INTEGER IBR,MSL,IPR,JBR,NHT,I,NCL,ISD,JSD,NPIX,IC,ICL,JC,JBC
      INTEGER IH,JH,RLF,NW,NDF
      REAL XP(6),LHS,LHP
      REAL XH(10),YH(10),ZH(10),ERHX(10),ERHY(10)
      INTEGER NHIT,TYP(10),RLAY(10),RCL(10)
#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      NHT=0
      NDF=0
      DO I=1,6
        XP(I)=0.
      ENDDO
      LHS=0.
        LHP=0.
      IF(MSL.LT.1.OR.MSL.GT.2) RETURN
      JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* control the number of branch clucters
      IF(IQ(JBR+8).LT.1) GOTO 200
      NCL=IQ(JBR+8)
      ISD=IQ(JBR+4)
      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2

* loops over branch clusters
      NPIX=0
      NHIT=0
      DO 10 IC=1,NCL
        JBC=JBR+LCMUTR+IC
        ICL=IQ(JBC)
        JC=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
* select muon superlayer MSL
        IF(IQ(JC+3).NE.MSL) GOTO 10
* crazy check - reject the pads
        IF(IQ(JC+5).EQ.2) GOTO 10
        IF(IQ(JC+5).EQ.3) NPIX=NPIX+1
* collect clusters
        NHIT=NHIT+1
        RCL(NHIT)=ICL
        TYP(NHIT) =IQ(JC+5)
        XH(NHIT)  = Q(JC+8)
        YH(NHIT)  = Q(JC+9)
        ZH(NHIT)  = Q(JC+6)
        ERHX(NHIT)= Q(JC+11)
        ERHY(NHIT)= Q(JC+12)
* link from cluster to first hit
        IH=IQ(JC+15)
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        RLAY(NHIT)=IQ(JH+2)
 10   CONTINUE
      IF(NHIT.LE.0) GOTO 200
* leave only pixels if there is at least one pixel
      RLF=1
      IF(MSL.EQ.2) RLF=11
      IF(NPIX.GT.0) THEN
        NW=0
        DO I=1,NHIT
          IF(TYP(I).EQ.3) THEN
            NW=NW+1
            RCL(NW) = RCL(I)
            RLAY(NW)= RLAY(I)
            TYP(NW) = 3
            XH(NW)  = XH(I)
            YH(NW)  = YH(I)
            ZH(NW)  = ZH(I)
            ERHX(NW)= ERHX(I)
            ERHY(NW)= ERHY(I)
          ENDIF
        ENDDO
        NHIT=NW
        RLF=9
        IF(MSL.EQ.2) RLF=17
      ENDIF

* calculate the space point for wires
***      IF(NPIX.EQ.0.AND.NHIT.GT.2) THEN
      IF(NPIX.EQ.0.AND.NHIT.GT.1) THEN
        CALL MURSPT(NHIT,RCL,ISD,IPR,XP,LHS)
        NDF=4
      ENDIF
* space point for pixel
      IF(NPIX.GT.0) THEN
        XP(1)=XH(1)
        XP(2)=YH(1)
        XP(3)=ZH(1)
        XP(4)=ERHX(1)**2
        XP(5)=ERHY(1)**2
        XP(6)=0.
        LHS  = 0.
      ENDIF
* position contribution to likelyhood
      CALL MURSPD(MSL,ISD,IPR,XP,LHP)
      NDF=NDF+2

      IF(IPR.GT.0.AND.NHIT.GT.0) THEN
***        PRINT 1002,MSL,NHIT,NPIX,RLF
*** 1002   FORMAT(1X,'MSL',I2,' Nhit',I2,' Npix',I2,' RLF',I3)
***        DO I=1,NHIT
***          PRINT 1001,I,TYP(I),RLAY(I),RCL(I),XH(I),YH(I),
***     +               ZH(I),ERHX(I),ERHY(I)
*** 1001     FORMAT(1X,I2,' typ',I2,' Rlay',I3,' cl',I4,' x,y',
***     +              2F8.2,' z',F9.2,' erx,y',2F7.3)
***        ENDDO
        PRINT 1003,MSL,NHIT,(XP(I),I=1,6),LHS,LHP,NDF
 1003   FORMAT(1X,'MSL',I2,' Nhit',I2,' sp X,Y',2F8.2,
     +     ' Z',F9.2,' cov',3E12.4,/,3X,' LHS',E12.4,
     +     ' LHP',E12.4,' NDF',I3)
      ENDIF
*
 200  CONTINUE
      RETURN
      END




