
*  B.Fominykh  25.04.2000
*  the program of MuonID package
*  calculates the MU3, MU4 contributions to muon likelihood
*  input:  IBR     - branch number
*          MSL     - muon superlayer
*          IPR     - print control
*  otput:  LHS     - likelyhood of shape           
*          LHP     - likelyhood of position           
*
      SUBROUTINE MURLH34(IBR,MSL,IPR,LHS,LHP)
C-    =======================================
      IMPLICIT NONE
      INTEGER IBR,MSL,IPR,JBR,I,ISD,JSD,NPIX
      REAL XH(10),YH(10),ZH(10),ERHX(10),ERHY(10)
      INTEGER NHIT,TYP(10),RCL(10),NCL,NW
      INTEGER IC,JBC,ICL,JC
      REAL LHS,LHP,XP(6)
#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      LHS=-1.
        LHP=-1.
      IF(MSL.LT.3.OR.MSL.GT.4) RETURN
      JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* control the number of branch clucters
      IF(IQ(JBR+8).LT.1) GOTO 200
      NCL=IQ(JBR+8)
      ISD=IQ(JBR+4)
      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2

* loops over branch clusters
      NPIX=0
      NHIT=0
      DO 10 IC=1,NCL
        JBC=JBR+LCMUTR+IC
        ICL=IQ(JBC)
        JC=JTMP8+IQ(JTMP8+1)*(ICL-1)+2
* select muon superlayer MSL
        IF(IQ(JC+3).NE.MSL) GOTO 10
* count the pixels
        IF(IQ(JC+5).EQ.3) NPIX=NPIX+1
* collect clusters
        NHIT      = NHIT+1
        RCL(NHIT) = ICL
        TYP(NHIT) = IQ(JC+5)
        XH(NHIT)  = Q(JC+8)
        YH(NHIT)  = Q(JC+9)
        ZH(NHIT)  = Q(JC+6)
        ERHX(NHIT)= Q(JC+11)
        ERHY(NHIT)= Q(JC+12)
 10   CONTINUE
      IF(NHIT.LE.0) GOTO 200
* leave only pixels if there is at least one pixel
      IF(NPIX.GT.0) THEN
        NW=0
        DO I=1,NHIT
          IF(TYP(I).EQ.3) THEN
            NW      = NW+1
            RCL(NW) = RCL(I)
            TYP(NW) = 3
            XH(NW)  = XH(I)
            YH(NW)  = YH(I)
            ZH(NW)  = ZH(I)
            ERHX(NW)= ERHX(I)
            ERHY(NW)= ERHY(I)
          ENDIF
        ENDDO
        NHIT = NW
      ENDIF

* likelyhood for pad chambers
      IF(NPIX.EQ.0) THEN
        IF(NHIT.GT.0) 
     +    CALL MURLHPAD(MSL,NHIT,RCL,ISD,IPR,LHS,LHP)
      ENDIF
* likelyhood for pixel
      IF(NPIX.GT.0) THEN
* space point
        XP(1)=XH(1)
        XP(2)=YH(1)
        XP(3)=ZH(1)
        XP(4)=ERHX(1)**2
        XP(5)=ERHY(1)**2
        XP(6)=0.
        LHS  = 0.
* position contribution to likelyhood
        CALL MURSPD(MSL,ISD,IPR,XP,LHP)
      ENDIF

      IF(IPR.GT.0.AND.NHIT.GT.0) THEN

        PRINT 1002,MSL,NHIT,NPIX
 1002   FORMAT(1X,'MSL',I2,' Nhit',I2,' Npix',I2)
        DO I=1,NHIT
          PRINT 1001,I,TYP(I),RCL(I),XH(I),YH(I),
     +               ZH(I),ERHX(I),ERHY(I)
 1001     FORMAT(1X,I2,' typ',I2,' cl',I4,' x,y',
     +              2F8.2,' z',F9.2,' erx,y',2F7.3)
        ENDDO

        IF(NPIX.GT.0) THEN
          PRINT 1003,MSL,(XP(I),I=1,6),LHS,LHP
 1003     FORMAT(1X,'MSL',I2,' pixel X,Y',2F8.2,
     +     ' Z',F9.2,' cov',3E12.4,/,3X,' pixel LHS',E12.4,' LHP',E12.4)
        ELSE
          PRINT 1004,MSL,LHS,LHP
 1004     FORMAT(1X,'MSL',I2,' pad LHS',E12.4,' LHP',E12.4)
        ENDIF
      ENDIF
*
 200  CONTINUE
      RETURN
      END




