/* Use these staff in the form:

   assign_to_data_member((ValueType*)0, &<your_class_object>, 
                         &<Your_Class>::<data_member>);

   Returns an object of class AssignToDataMember<...>.
   This class has 
     void operator()(Value value);
   which assigns "value" to <data_member> of <your_class_object>.
   Prototype: assign_to_data_member(Value*, T* object, PtrMember pmember);
   expression 
     (*object).*pmember
   should be valid
*/

// Author V.Balagura (balagura@mail.desy.de)   (09.04.98).

#ifndef _assign_to_data_member_hh
#define _assign_to_data_member_hh 1

template <class T, class PtrMember, class Value>
struct AssignToDataMember {
  T* object;
  PtrMember pmember;
  AssignToDataMember(T* obj, PtrMember pm) : object(obj), pmember(pm) {}
  void operator()(Value value) { (*object).*pmember = value; }
};

template <class T, class PtrMember, class Value>
AssignToDataMember<T, PtrMember, Value> assign_to_data_member
(Value*, T* object, PtrMember pmember) {
  return AssignToDataMember<T, PtrMember, Value>(object, pmember);
}

#endif
