/* See index_range.hh for details */

// Author R.Mizuk (mizuk@mail.desy.de)                       (19.02.99).
// Slightly modified by V.Balagura (balagura@mail.desy.de)   (27.02.99).

#include "ptset/index_range.hh"

istream& operator>> (istream& is, IndexRange_X& ir) {
  char c;
  if ( !(is >> c) ) return is;
  if ( c != '[' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.ix0) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ':' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.ix1) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ',' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.iy) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ')' ) { is.setstate(ios::failbit); return is; }
  return is;
}
ostream& operator<< (ostream& os, const IndexRange_X& ir) {
  return os << '[' << ir.ix0 << ':' << ir.ix1 << ',' << ir.iy << ')';
}

istream& operator>> (istream& is, IndexRange_Y& ir) {
  char c;
  if ( !(is >> c) ) return is;
  if ( c != '[' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.ix) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ',' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.iy0) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ':' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.iy1) ) return is;
  if ( !(is >> c) ) return is;
  if ( c != ')' ) { is.setstate(ios::failbit); return is; }
  return is;
}
ostream& operator<< (ostream& os, const IndexRange_Y& ir) {
  return os << '[' << ir.ix << ',' << ir.iy0 << ':' << ir.iy1 << ')';
}

