// 
//  Author:  Rainer Mankel                     Created:  28-May-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include <iostream.h>
#include <iomanip.h>
#include "rang/Monitor.hh"
#include "rang/DomWin.hh"
#include "rang/DomLay.hh"

void rangerMonitor::countDls(rangerDomLay* dl,const int flag) {
  //cout << "Monitor: Find window " << *(dl->win()) << endl;
  map<rangerDomWin*,rangerStatItem,less<rangerDomWin*> >::iterator 
    mi=winStat.find(dl->win());
  if (mi != winStat.end()) {
    //(*mi).count(flag);
    winStat[dl->win()].count(flag);
  }
  else {
    rangerStatItem si;
    si.count(flag);
    winStat[dl->win()] = si;
  }
}


void rangerMonitor::output() {
  cout << "-----------------------------------------------------" << endl;
  cout << "rangerMonitor:  x seed statistics " << endl;
  for (map<rangerDomWin*,rangerStatItem,less<rangerDomWin*> >::iterator
	 mi=winStat.begin(); mi != winStat.end(); ++mi) {
    cout << " DomWin: " << setw(3) << *(*mi).first 
	 << " Statistics: " << (*mi).second << endl;
  }
}

rangerMonitor rangerMon;

extern "C" {
  void rgmondls_(rangerDomLay*& dl,const int& flag) {
    if (dl) {
      rangerMon.countDls(dl,flag);
    }
  }

  void rgmonout_() {
    rangerMon.output();
  }

}

