// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// function rangerFit
// user interface for (re)fitting of RSEG, RTRA

#ifndef rangerFit_HH
#define rangerFit_HH

#include <vector.h>
#include "rang/ParticleType.hh"


int rangerFit(ArtePointer<RSEG> rseg,
	      rangerParticleType pType= MUON);
int rangerFitL(ArtePointer<RSEG> rseg,
	      rangerParticleType pType= MUON);
int rangerFitV(ArtePointer<RSEG> rseg,const int method = 0,
	      rangerParticleType pType= MUON);
int rangerFit(ArtePointer<RTRA> rtra,
	      rangerParticleType pType= MUON);
int rangerFit(ArtePointer<RTRA> rtra,
	      rangerParticleType pType,
	      bool addecal, bool addrich);
int rangerFitL(ArtePointer<RTRA> rtra,
	      rangerParticleType pType= MUON);
int rangerFit(vector<ArtePointer<RSEG> > rsegVec,
	      rangerParticleType pType= MUON);
int rangerFitL(vector<ArtePointer<RSEG> > rsegVec,
	      rangerParticleType pType= MUON);

#endif
