// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerHitUnsigned
// node class for drift chamber hit without external L/R information

#ifndef rangerHitUnsigned_HH
#define rangerHitUnsigned_HH

#include "rang/Hit.hh"
#include "rang/FitMode.hh"
#include "CLHEP/Matrix/Matrix.h"
#include "CLHEP/Matrix/Vector.h"

class rangerHitUnsigned : public rangerHit {

public:

  rangerHitUnsigned();
  rangerHitUnsigned(ArtePointer<RHIT> rhit,rangerFitMode fm);
  rangerHitUnsigned(ArtePointer<HITB>   hb,rangerFitMode fm);
  ~rangerHitUnsigned();

  void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);

//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStateP* s);
//   void project(HepVector& resid,
// 	       HepMatrix& HH,
// 	       rangerStatePI* s);
  inline int dim() const {return 1;};         // dimension of measurement

private:

};

#endif
