// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerThinPlane
// class for thin multiple scattering object based on Gede plane

#ifndef rangerThinPlane_HH
#define rangerThinPlane_HH

#include "arte/arte.hh"
#include "rang/Node.hh"
#include "rang/Thin.hh"
#include "rang/Volume.hh"


class rangerThinPlane : public rangerThin {

public:

  rangerThinPlane();
  rangerThinPlane(const ArtePointer<GEDE>& ge,rangerNode* n);
  rangerThinPlane(const ArtePointer<GEDE>& ge,rangerNode* n,const float path);
  virtual ~rangerThinPlane(){};   // virtual destructor
  
  inline float ms() const {return sPath*vol->ms();}
  inline float dedx() const {return sPath*vol->dedx();}
  inline float msPlain() const { return sPath*gede->ms; }
  inline float dz(){return (gede->zmax - gede->zmin);}
  inline int plane(){return gede.index();}

protected:

private:
  ArtePointer<GEDE> gede;
  rangerVolume* vol;
  float sPath;
};

#endif
