// 
//  Author:  Alexander Spiridonov              Created:  27.11.01
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgfitvtr.C
//
//       swim vds paramters to pc-tracker 
//       and find momentum prividing a best fit
//
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"

#undef DEBUG_PRINT
//#define DEBUG_PRINT

// Prototypes

extern "C" {

  void rgauxsvm_(float&, float*, float&, float*);
  //void rgauxsmv_(float&, float*, float&, float*);

}

extern "C" void rgfitvtr_(ArtePointer<RSEG> vds, ArtePointer<RSEG> otr,
			  float& p0, float& chi2x, float& chi2y) 
{

  int id0 = zfparext_.id_hist; 
  int id;
  float w = 1.; float w05 = 0.5; float vx,vy;

  float p_vds[5],p_otr[5],var_vds[5],var_otr[5],r0[5],var_r0[5],r1[5];
  float p1,dp;
  float z_vds,z_otr;

  p0 = otr->pf;

  z_vds = vds->ze;
  p_vds[0] = vds->xe;
  p_vds[1] = vds->ye;
  p_vds[2] = vds->txe;
  p_vds[3] = vds->tye;
  var_vds[0] = vds->cve[0];
  var_vds[1] = vds->cve[2];
  var_vds[2] = vds->cve[5];
  var_vds[3] = vds->cve[9];

  z_otr = otr->zf;
  p_otr[0] = otr->xf;
  p_otr[1] = otr->yf;
  p_otr[2] = otr->txf;
  p_otr[3] = otr->tyf;
  var_otr[0] = otr->cvf[0];
  var_otr[1] = otr->cvf[2];
  var_otr[2] = otr->cvf[5];
  var_otr[3] = otr->cvf[9];

  float dz = z_otr - z_vds;
  float dz2 = dz * dz;

  float dr[5];
  dr[0] = p_otr[0] - p_vds[0] - p_vds[2] * dz;
  dr[1] = p_otr[1] - p_vds[1] - p_vds[3] * dz;
  dr[2] = p_otr[2] - p_vds[2];
  dr[3] = p_otr[3] - p_vds[3];
  float erp2 = 0.0002;                    // 0.014 ** 2

  var_r0[0] = var_otr[0] + var_vds[2] * dz2;
  //var_r0[0] = var_otr[0] + var_vds[2] * dz2 + dr[0] * dr[0] * erp2;
  var_r0[1] = var_otr[1] + var_vds[3] * dz2;
  //var_r0[1] = var_otr[1] + var_vds[3] * dz2 + dr[1] * dr[1] * erp2;
  var_r0[2] = var_otr[2] + var_vds[2] + dr[2] * dr[2] * erp2;
  //var_r0[2] = var_otr[2] + var_vds[2];
  var_r0[3] = var_otr[3] + var_vds[3];
  //var_r0[3] = var_otr[3] + var_vds[3] + dr[3] * dr[3] * erp2;
  float var_1[4];
  for(int i =0; i < 4; ++i) var_1[i] = 1./var_r0[i];
  
  int N_iter = 0;
  dp = 0;

 StartIter: p0 += dp; 
  p_vds[4] = p0;
  ++N_iter;

#ifdef DEBUG_PRINT
  cout << " rgfitvtr.C -=-=-=- iter " << N_iter 
       << " vds " << vds << " otr " << otr
       << endl;
  if(N_iter == 1) 
    {
      cout << " z_vds " << z_vds << " x_vds " << p_vds[0] << " y " << p_vds[1] 
	   << " tx " << p_vds[2] << " ty " << p_vds[3] << endl;
      cout << " z_otr " << z_otr << " x_otr " << p_otr[0] << " y " << p_otr[1] 
	   << " tx " << p_otr[2] << " ty " << p_otr[3] 
	   << " 1/p0 " << 1./p0 << endl;

  cout << " var_otr x " << sqrtf(var_otr[0]) << " y " << sqrtf(var_otr[1])
       << " tx " <<  sqrtf(var_otr[2]) << " ty " << sqrtf(var_otr[3]) << endl;
  cout << " var_vds x " << sqrtf(var_vds[2] * dz2) 
       << " y " << sqrtf(var_vds[3] * dz2) 
       << " tx " <<  sqrtf(var_vds[2]) << " ty " << sqrtf(var_vds[3]) << endl;

  //cout << " var_p x " << sqrtf(dr[0] * dr[0] * erp2) 
  //     << " y " << sqrtf(dr[1] * dr[1] * erp2)
  //     << " tx " <<  sqrtf(dr[2] * dr[2] * erp2) 
  //     << " ty " << sqrtf(dr[3] * dr[3] * erp2) << endl;
    }
#endif

  rgauxsvm_(z_vds, p_vds, z_otr, r0);
  float ddp = - 0.1 * p0; float ddp_1 = 1./ddp;
  p_vds[4] = 0.9 * p0;
  rgauxsvm_(z_vds, p_vds, z_otr, r1);
  float ddr[5];
  for(int i =0; i < 4; ++i) ddr[i] = (r1[i] - r0[i]) * ddp_1;

#ifdef DEBUG_PRINT 
  cout << " ddp " << ddp << " ddrx " << ddr[0] << " y " << ddr[1]
       << " tx " << ddr[2] << " ty " << ddr[3] << endl;
#endif

  float A_dp = 0.;
  for(int i =0; i < 4; ++i) A_dp += (p_otr[i] - r0[i]) * var_1[i] * ddr[i];
  float B_dp = 0.;
  for(int i =0; i < 4; ++i) B_dp += var_1[i] * ddr[i] * ddr[i];
  
  dp = A_dp / B_dp;
  
  chi2x = 0;  
  for(int i =0; i < 2; ++i) chi2x += (p_otr[i] - r0[i]) * (p_otr[i] - r0[i]) 
			      * var_1[i];
  chi2y = 0;  
  for(int i =2; i < 4; ++i) chi2y += (p_otr[i] - r0[i]) * (p_otr[i] - r0[i]) 
			      * var_1[i];

#ifdef DEBUG_PRINT
  cout << " dx " << (p_otr[0] - r0[0]) * sqrtf(var_1[0])
       << " dy " << (p_otr[1] - r0[1]) * sqrtf(var_1[1])
       << " dtx " << (p_otr[2] - r0[2]) * sqrtf(var_1[2])
       << " dty " << (p_otr[3] - r0[3]) * sqrtf(var_1[3]) << endl;
  //cout << " dp " << dp/p0 << " 1/p0 " << 1./p0 << " chi2 " << chi2 << endl;
  cout << " dp " << dp/p0 << " 1/p0 " << 1./p0 << " chi2x " << chi2x 
       << " chi2y " << chi2y << endl;
#endif

  if(fabs(dp/p0) > 0.005 && N_iter < 3) goto StartIter;
  //if(N_iter < 3) goto StartIter;

#ifdef DEBUG_PRINT
  cout << " ========================================= " << endl;
#endif

  return;

}
