// 
//  Author:  Alexander Spiridonov              Created:  28.11.01
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgmatcha.C
//       vds-otr matching based on rgfitvtr_()
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/Fit.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "arte/ArteMessage.hh"
#include "rang/zfpar.hh"

#undef DEBUG_PRINT
//#define DEBUG_PRINT

// Prototypes

extern "C" {
  int rgauxremcs_(int& iseg, int& imcass, float& fracmc);
  //  void tfremcse_(int& iseg, int& imcass, float& fracmc);
  void rgauxvtrcor_(ArtePointer<RTRA>, const int &);      
  int rgmc_();
  bool rgauxmrel_(int& mtra_vds, int& mtra_otr ); 
  void rgauxvtrchi_(ArtePointer<RTRA> rtra, float& chi2_vtr);
  bool rgauxtrigvt_(const int&);
  void rgauxcheckz_(ArtePointer<RTRA>, const int&, const int&,const float&,
		    float&, float&);
  void rgcheckhpt_(ArtePointer<RSEG>, const float&,float&, int&);
  void rgauxchmatch_(ArtePointer<RTRA>,const float&, float&, float&, float&);
  void rgauxchmc1_(ArtePointer<RTRA>, float&, int&, int&);

  void rgauxsvm_(float&, float*, float&, float*);
  void rgauxsmv_(float&, float*, float&, float*);
  void rgfitvtr_(ArtePointer<RSEG>, ArtePointer<RSEG>, float&, float&, float&);
}

extern "C" void rgmatcha_() 
{
  ArtePointer<RSEG> vdsm[1000];
  ArtePointer<RSEG> otrm[1000];
  float chi2m[1000];
  float p0m[1000];
  bool ifmatch[1000];
  int mult[1000];
  int N_max = 1000;
  int n_match = 0;

  ArtePointer<RSEG> vds;
  ArtePointer<RSEG> otr;
  //  loop by  vds segments                                    good tracks
  for ( ArteTable<RSEG>::iterator rseg = ArteTable<RSEG>::begin();
	rseg != ArteTable<RSEG>::end(); ++rseg ) 
    {
      
      vds = *rseg;
      
      if( (*rseg)->cmp & Rsegc::bitsign || (*rseg)->fit != 0 
      	  || !( (*rseg)->cmp & Rsegc::vxd)  )  continue; 

	  //  || ( (*rseg)->zf > 208. )  )  continue; 
	  //if(  (*rseg1)->cmp & Rsegc::slt ) continue;
      
#ifdef DEBUG_PRINT            
      int iseg = (*rseg).index();
      int imcass; float fracmc;
      bool test = rgauxremcs_(iseg, imcass, fracmc);
      cout << " rgmatcha : ----- vds seg " << iseg << " MC " << imcass
	   << " zf " << (*rseg)->zf 
	   << " cmpvxd " << ((*rseg)->cmp & Rsegc::vxd)<< endl;
#endif

      int n_match1 = n_match;

      for ( ArteTable<RSEG>::iterator rseg1 = ArteTable<RSEG>::begin();
	    rseg1 != ArteTable<RSEG>::end(); ++rseg1 ) 
	{      
	  
	  otr = *rseg1;
	  
	  if( (*rseg1)->cmp & Rsegc::bitsign || (*rseg1)->fit != 0   
	      || !( (*rseg1)->cmp & Rsegc::patt  ))  continue;  

#ifdef DEBUG_PRINT      
	  int iseg1 = (*rseg1).index();
	  int imcass1; float fracmc1;
	  bool test1 = rgauxremcs_(iseg1, imcass1, fracmc1);
	  
	  cout << " rgmatcha.C : otr seg " << iseg1 << " MC " << imcass1
	       << " zf " << (*rseg1)->zf 
	       << endl;

	  //counting of good rseg
	  //if((!test || !test1) || (imcass != imcass1) ) continue;
	  //if ((imcass != imcass1) || (fracmc < 0.99 || fracmc1 < 0.99)) 
	  //    continue;
#endif
	  
	  float p_vds[5],p_otr[5],z_vds,z_otr,z0;
	  z0 = 450;
	  p_vds[0] = vds->xe;
	  p_vds[1] = vds->ye;
	  p_vds[2] = vds->txe;
	  p_vds[3] = vds->tye;
	  p_vds[4] = otr->pf;
	  z_vds = vds->ze;
	  	  	  
	  p_otr[0] = otr->xf;
	  p_otr[1] = otr->yf;
	  p_otr[2] = otr->txf;
	  p_otr[3] = otr->tyf;
	  p_otr[4] = otr->pf;
	  z_otr = otr->zf;
	  
	  float x0_vds = p_vds[0] + p_vds[2] * ( z0 - z_vds);
	  float x0_otr = p_otr[0] + p_otr[2] * ( z0 - z_otr);
	  float y0_otr = p_otr[1] + p_otr[3] * ( z0 - z_otr);
	  float y0_vds = p_vds[1] + p_vds[3] * ( z0 - z_vds);
	  if(fabs(x0_otr - x0_vds) > 10.) continue;
	  if(fabs(y0_otr - y0_vds) > 10.) continue;

#ifdef NEW_TEST_Y 
          float z1;
          z1 = (p_vds[1] - z_vds * p_vds[3] - p_otr[1] + z_otr * p_otr[3])
            / (p_otr[3] - p_vds[3]);
          float z2;
          if (z1 < 450.) z2 = 450;
          else if(z1 > otr->zf) z2 = otr->zf;
          else z2 = z1;
          float y2_vds = p_vds[1] + p_vds[3] * ( z2 - z_vds);
          float y2_otr = p_otr[1] + p_otr[3] * ( z2 - z_otr);
          if(fabs(y2_otr - y2_vds) > 5.) continue;
          if(fabs(x0_otr - x0_vds) > 10.) continue; 
#endif

	  float p0,chi2x,chi2y;
	  rgfitvtr_(vds, otr, p0, chi2x, chi2y); 
	  p_vds[4] = p0; p_otr[4] = p0;

#ifdef TEST_DEBUG
          float pvdsm[5],potrm[5],zm; 
          zm = 450;  
          rgauxsvm_(z_vds, p_vds, zm, pvdsm); 
          rgauxsmv_(z_otr, p_otr, zm, potrm); 

	  if ((imcass == imcass1) && fracmc > 0.99 && fracmc1 > 0.99 && false) 
	    cout << " ==== vds " << vds << " otr " << otr 
		 << " zvds " << z_vds << " P "  << 1./p0
		 << " ldx " << fabs(x0_otr - x0_vds) 
		 << " sdx " << fabs(pvdsm[0]-potrm[0]) 
		 << " ldy " << fabs(y0_otr - y0_vds) 
		 << endl;
#endif

	  if(chi2x + chi2y > 40. ) continue;

	  if(zfpar_.hptmode >= 0 )
	    {
	      int n_cross;
	      float dist_hpt;
	      rgcheckhpt_(vds, p0, dist_hpt, n_cross);
	      if(n_cross ==3 && dist_hpt > 1.) continue;
	    }

	  if(n_match >= N_max) 
	    {
	      arteMsg << "rgmatcha: n_match >= N_max " << endl;
	      arteMsg.warn();
#ifdef TEST_DEBUG
	      cout << " rgmatcha.C: to big N_math " << n_match
		   << " -=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-= "
		   << " bell\007\007\007\007\007\007\007\007\n"
		   << " -=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-= "
		   << " bell\007\007\007\007\007\007\007\007\n"
		   << endl;
#endif
	      break;
	    }
	  vdsm[n_match] = vds;
	  otrm[n_match] = otr;
	  chi2m[n_match] = chi2x + chi2y;
	  p0m[n_match] = p0;
	  ifmatch[n_match] = false;
	  ++n_match;

#ifdef DEBUG_PRINT         
	  // if( fabs(otr->yf - y_vds) > 30. || fabs(x0_otr - x0_vds) > 30.) 
	  cout << "rgmatcha  iseg " << iseg << " " << iseg1 
	       << " mc " << imcass << " " << imcass1 << " p " << 1/p0
	       << " chi2 " << chi2;
	  if( imcass == imcass1 ) cout << " -OK- ";
	  cout << endl; 
#endif 

	}                                          //end of loop on otr

      for(int i = 0; i < (n_match - n_match1); ++i) 
	mult[n_match1 + i] = (n_match - n_match1); 

    }                                              // end loop on vds

  //                                            do matching

  if(n_match < 1 ) return;

  //                                            add multiplicity from otr

  for(int i=0; i < n_match; ++i)
    {
      for(int i1=0; i1 < n_match; ++i1)
	{
	  if(i == i1) continue;
	  if(otrm[i] == otrm[i1]) ++mult[i]; 
	}
    }

  int n_pair = n_match;
  ArtePointer<RSEG> vds_best = NULL;
  ArtePointer<RSEG> otr_best = NULL;
  int n_pass = 0;

 StartMatch:float chi2_best = 1000000;          // start matching loop
  int i_best = -1;
  ++n_pass;

#ifdef DEBUG_PRINT       
  cout << " rgmatcha.C --------- n_pass " << n_pass << " n_pair " << n_pair 
       << " i_best " << i_best << endl;
  for(int i=0; i < n_match; ++i)
    {
      if(!ifmatch[i])
      cout << i+1 << " " << vdsm[i] << " " << otrm[i] << " chi2 " << chi2m[i]
	   << " if " << ifmatch[i] << " mult " << mult[i] << endl;
    }
#endif

  for(int i=0; i < n_match; ++i)
    {
      if(ifmatch[i]) continue;
      //if(chi2m[i]  < chi2_best) 
      if(chi2m[i] + float(mult[i]) * 100. < chi2_best) 
	{
  	  i_best = i; 
	  //chi2_best = chi2m[i];
	  chi2_best = chi2m[i] + float(mult[i]) * 100.;
	}
    }
#ifdef DEBUG_PRINT         
  if(i_best == -1 ) { cout << " F I N I S H  i_best" << endl; return;} 
#else
  if(i_best == -1 ) return; 
#endif

  vds_best = vdsm[i_best]; otr_best = otrm[i_best];

#ifdef DEBUG_PRINT       
  cout << " rgmatcha.C : ==== best i " << i_best+1 << " vds " << vds_best
       << " otr " << otr_best << " chi2 " << chi2_best << endl;
#endif

  //createRelation( vds_best, otr_best);
  mmbrel_(  ArteManRelationPointer<RSRS,RSEG>::getLink().getInt(),
            vds_best, otr_best );

  //if(n_pass > 10) return;

  for(int i=0; i < n_match; ++i)
    {
      if(ifmatch[i]) continue;
      if(vds_best == vdsm[i]) {ifmatch[i] = true; n_pair--; continue;}
      if(otr_best == otrm[i]) {ifmatch[i] = true; n_pair--; continue;}
    }

  for(int i=0; i < n_match; ++i)
    {
      if(vds_best == vdsm[i])
	{
	  for(int i1=0; i1 < n_match; ++i1)
	    {
	      if(ifmatch[i1]) continue;
	      if(otrm[i] == otrm[i1]) --mult[i1];
	    }
	}
    }

  for(int i=0; i < n_match; ++i)
    {
      if(otr_best == otrm[i])
	{
	  for(int i1=0; i1 < n_match; ++i1)
	    {
	      if(ifmatch[i1]) continue;
	      if(vdsm[i] == vdsm[i1]) --mult[i1];
	    }
	}
    }

#ifdef DEBUG_PRINT       
  if(n_pair == 0) { cout << " F I N I S H  n_pair" << endl; return;} 
#else
  if(n_pair == 0)  return; 
#endif

  goto StartMatch;

}
