*-- Author :    A. Spiridonov   27/11/98

      subroutine tfbuild()
*
*  Control routine to invoke ranger++ fit and build track
*      (book RTRA table) from segments reconstucted 
*         in VDS,magnet+pattern and tc area    
*             
*     Combinations of segments to be stored as track :
*
*             VDS    patt&magn  tc area  muon
*
*       1      +         +        +        
*       2      +         +                 
*       3      +                           
*       4                +        +        
*       5                +                 
*       6      +         +        +        +
*       7      +         +                 +
*       8      +                           +
*       9                +        +        +
*      10                +                 +
*
*
      implicit none
*
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
*
* 
      integer rgseg2t,rgsv2t
      integer rs,rt,iirs,ind_rs,ii,jj,kk,ll
      integer if_seg,segVec(20)
      integer n_beg,seg_beg(20)      
      integer n_end,seg_end(20),n_end1,seg_end1(20)
      integer n_end2,seg_end2(20)      

      integer rgfitsv
        
      logical rang_fit
      data rang_fit/.false./
      save rang_fit

#include "arte/Arte.ff"
#include "auto/RSEG.ff"

*--------------------------------------------------

      if(rlevel_fit.ge.2) then
        if(rlevel_zfpar.ge.2) then
          rang_fit = .true.
        else if(rlevel_zfpar.eq.0) then
          rang_fit = .true.
        else
          rang_fit = .false.
        end if
      else
        rang_fit = .false.
      end if
    
      if(jrseg.le.0)   go to 999        ! skip empty event
      if(NRSEG().le.0) go to 999 

      do rs=1,NRSEG()                             ! loop on segments
        if (iand(irseg_cmp(rs),rsegc_bitsign).eq.0) then !  alive segment
          call tfunbeg(rs,n_beg,seg_beg)
          if((n_beg.eq.0)
     +    .and.( (iand(irseg_cmp(rs),rsegc_vxd ).ne.0)
     +    .or.   (iand(irseg_cmp(rs),rsegc_magt).ne.0) 
     +    .or.   (iand(irseg_cmp(rs),rsegc_patt).ne.0) ) ) then

          call tfunend(rs,n_end,seg_end)
            if(n_end.gt.0) then         !   # segments .ge. 2
              do ii=1,n_end
                segVec(1) = rs          
                segVec(2) = seg_end(ii)
                call tfunend(segVec(2),n_end1,seg_end1)
                if(iand(irseg_cmp(rs),rsegc_vxd ).ne.0.and.
     +          iand(irseg_cmp(seg_end(ii)),rsegc_muon ).eq.0 ) then
*               **** covariance of momentum for SVD segment
                  do kk=11,14
                    q(qrseg_cvf(kk,rs))=0.
                    q(qrseg_cve(kk,rs))=0.
                  end do
                  q(qrseg_cvf(15,rs))= frseg_cvf(15,segVec(2))
                  q(qrseg_cve(15,rs))= frseg_cvf(15,segVec(2))
                end if
                if(n_end1.gt.0) then       !   # segments .ge. 3
                  do jj=1,n_end1
                    segVec(3) = seg_end1(jj)
                    call tfunend(segVec(3),n_end2,seg_end2)
                    if(n_end2.gt.0) then   !   # segments .ge. 4
                      do kk=1,n_end2       !   # segents  .eq. 4
                        segVec(4) = seg_end2(kk)
                        if(rang_fit) then
                          if(iand(irseg_cmp(segVec(4)),rsegc_muon).eq.0) 
     +                                                              then
                            rt = rgfitsv(segVec,4,0)
                          else
                            rt = rgfitsv(segVec,3,0)
                          end if
                        end if
                        rt = rgsv2t(segVec,4)
                      end do            ! 1,n_end2
                    else                ! # segments .eq. 3
                      if(rang_fit) then
                        if(iand(irseg_cmp(segVec(3)),rsegc_muon).eq.0) 
     +                                                            then
                          rt = rgfitsv(segVec,3,0)
                        else
                          rt = rgfitsv(segVec,2,0)
                        end if
                      end if
                      rt = rgsv2t(segVec,3)   
                    end if              ! endif # segments .ge.4 

                  end do                ! 1,n_end1
                else                    ! # segments .eq. 2
                  if(rang_fit) then
                    if(iand(irseg_cmp(segVec(2)),rsegc_muon).eq.0) 
     +                                                        then
                      rt = rgfitsv(segVec,2,0)
                    else
                      rt = rgfitsv(segVec,1,0)
                    end if
                  end if
                  rt = rgsv2t(segVec,2)
                end if                ! endif # segments .ge. 3
              end do                  ! 1,n_end
            else                      ! #segments .eq. 1
              if(rang_fit) call rgfit(rs,0)      
              rt = rgseg2t(rs)       
            end if                ! end treat of segment
          end if                  ! end of VDS or magnet with n_beg=0
        end if                    ! endif of alive segment
      end do                      ! end of loop on segments
 
 999  end
