** 
**  Author:  A. Spiridonov                                 Created:  12-Dec-2001
**  changed: 
**  
 
      subroutine tfdownse3(iseg,ift1,ift2,istat)
*
*     seed candidate from VDS
*     for downstream propagation through mc01/s01
*     clone of tfdownse
*

#define NEW_QP_SEED 
*#define FILL_MC

      implicit none

      integer iseg,ift1,ift2,istat,izf,ift,dom_mc1,dom,i,j,dw,dl,sl
      integer rgnamdom,rgwidlent,maxwin,nwin,iiwin,iseed
      real cms
**      parameter (maxwin=40,cms=4.e-6)
***      parameter (maxwin=40,cms=1.e-5)
      parameter (maxwin=40,cms=1.e-10)
      integer vecwin(maxwin)
      real rgwizmax
      real xmin,xmax,ymin,ymax
      integer jaux,imc,imimp,nhmimp,nh,nh_PC
      real z_PC
      
      real x_mc,y_mc,ex_mc,ey_mc,e_mc(5,5),zdl

      logical init
      character*4 cgesl

#ifdef FILL_MC
      integer imcass
      real frmcass
#endif

*     **** packing scheme for covariance
      integer matrix_pack(5,5)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
* 
      integer ii,jj,kk,ll
      real fracmc
      real fact_PC
      data fact_PC/1.7/


#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/GEO.fi"
#include "auto/RSEG.fi"
#include "auto/HITB.fi"

#include "rang/zf.fi"

#ifdef NEW_QP_SEED
      integer nqpmax,nqp_seed
      parameter (nqpmax=100) 
      real qp_seed(nqpmax),eqp_seed(nqpmax)
#endif 

      data init /.false./
      save init,dom_mc1
      save nwin,vecwin

      double precision c11 , c12 , c13 , c14 , c15
      double precision       c22 , c23 , c24 , c25
      double precision             c33 , c34 , c35
      double precision                   c44 , c45
      double precision                         c55
 
      double precision g11 , g12 , g13 , g14 , g15
      double precision g21 , g22 , g23 , g24 , g25
      double precision g31 , g32 , g33 , g34 , g35
      double precision g41 , g42 , g43 , g44 , g45
      double precision g51 , g52 , g53 , g54 , g55

      double precision f13,f15,f24,f25,f35,f45,f(5,5)
      double precision x,y,d_z,sum
      double precision FL_1,FL_2,FL_3
      double precision GL_1,GL_2,GL_3

      equivalence (f13,f(1,3)),(f15,f(1,5)),(f24,f(2,4))
     +           ,(f25,f(2,5)),(f35,f(3,5)),(f45,f(4,5))

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/GEO.ff"
#include "auto/RSEG.ff"
#include "auto/HITB.ff"
*
*      FL_1(x,y,z) = x + f13*y 
*      FL_2(x,y  ) = x + f24*y 
*      FL_3(x,y  ) = x 

*      GL_1(x,y,z) = x + f13*y 
*      GL_2(x,y  ) = x + f24*y 
*      GL_3(x,y  ) = x 

       Fl_1(x,y) = x + f13*y
*
*================================================================

      if (.not.init) then 
         dom_mc1 = rgnamdom('MC1')
         call rgdomwin(dom_mc1,maxwin,vecwin,nwin)
         print *,' tfdownse: domwins for MC1:',nwin
         init = .true.
      endif                                   ! end of initalization
               
      istat = 0
      ift1 = 0
      ift2 = -1

*     **** plant seed from segment iseg

      do 20 iiwin=1,nwin
         dw = vecwin(iiwin)
         dl = rgwidlent(dw,+1)
         zdl = rgwizmax(dw)
         call rgwibord(dw,xmin,xmax,ymin,ymax)

*        ***** extrapolate to domain window
         x_mc = frseg_xe(iseg) + (zdl-frseg_ze(iseg)) * frseg_txe(iseg)
         y_mc = frseg_ye(iseg) + (zdl-frseg_ze(iseg)) * frseg_tye(iseg)

#ifdef dmdebug
         print *,' '
         print *,' dl=',dl,' dw=',dw,' xmin/x/xmax=',
     +        xmin_dw(dw),x_mc,xmax_dw(dw)
         print *,' dl=',dl,' dw=',dw,' ymin/y/ymax=',
     +        ymin_dw(dw),y_mc,ymax_dw(dw)
#endif

        d_z = ( zdl - frseg_ze(iseg))
        c11 = frseg_cve( 1,iseg) * fact_PC 
        c13 = frseg_cve( 4,iseg) * fact_PC 
        c33 = frseg_cve( 6,iseg) * fact_PC + cms
        ex_mc = c11 + 2. * d_z * c13 + d_z * d_z * c33 
        ex_mc = sqrt( ex_mc )

        if ((x_mc+ex_mc).lt.xmin) go to 20
        if ((x_mc-ex_mc).gt.xmax) go to 20

        c22 = frseg_cve( 3,iseg)  * fact_PC 
        c24 = frseg_cve( 8,iseg)  * fact_PC 
        c44 = frseg_cve(10,iseg) * fact_PC + cms
        ey_mc = c22 + 2. * d_z * c24 + d_z * d_z * c44 
        ey_mc = sqrt( ey_mc )

        if ((y_mc+ey_mc).lt.ymin) go to 20
        if ((y_mc-ey_mc).gt.ymax) go to 20

#ifdef NEW_QP_SEED 
        call tfdownqp(zdl,x_mc,y_mc,frseg_txe(iseg),frseg_tye(iseg)
     +               ,nqpmax,nqp_seed,qp_seed,eqp_seed)
        do iseed=1,nqp_seed
#else
        do iseed=1,3    ! loop over seeding momenta
#endif

           if (n_zf.lt.nzfmx) then ! create new entry in zf
              n_zf = n_zf + 1
              izf = n_zf
              xx_zf(1,izf) = x_mc
              xx_zf(2,izf) = y_mc
              xx_zf(3,izf) = frseg_txe(iseg)
              xx_zf(4,izf) = frseg_tye(iseg)

#ifdef NEW_QP_SEED 
              xx_zf(5,izf) = qp_seed(iseed)
#else
              if (iseed.eq.1) then
                 xx_zf(5,izf) = 0.
              elseif (iseed.eq.2) then
                 xx_zf(5,izf) = .8
              else
                 xx_zf(5,izf) = -.8
              endif
#endif

              f13 = d_z

              c11 = frseg_cve( 1,iseg) * fact_PC 
              c12 = frseg_cve( 2,iseg) * fact_PC 
              c13 = frseg_cve( 4,iseg) * fact_PC 
              c14 = frseg_cve( 7,iseg) * fact_PC 
              c22 = frseg_cve( 3,iseg) * fact_PC 
              c23 = frseg_cve( 5,iseg) * fact_PC 
              c24 = frseg_cve( 8,iseg) * fact_PC 
              c33 = frseg_cve( 6,iseg) * fact_PC + cms
              c34 = frseg_cve( 9,iseg) * fact_PC 
              c44 = frseg_cve(10,iseg) * fact_PC + cms
              c15 = 0.
              c25 = 0.
              c35 = 0.
              c45 = 0.
#ifdef NEW_QP_SEED
              c55 = eqp_seed(iseed) ** 2
#else              
*     *              c55 =  frseg_cvf(matrix_pack(5,5),iseg)
              c55 = 1.          ! assumed squared error in q/p
#endif              
              g11 = FL_1( c11 , c13 )
              g12 = FL_1( c12 , c23 )
              g13 = FL_1( c13 , c33 )
              g14 = FL_1( c14 , c34 )
              g15 = FL_1( c15 , c35 )
              
              g21 = FL_1( c12 , c14 )
              g22 = FL_1( c22 , c24 )
              g23 = FL_1( c23 , c34 )
              g24 = FL_1( c24 , c44 )
              g25 = FL_1( c25 , c45 )
              
              g31 = c13 
              g32 = c23 
              g33 = c33
              g34 = c34 
              g35 = c35

              g41 = c14             
              g42 = c24             
              g43 = c34             
              g44 = c44             
              g45 = c45             

              g51 = c15             
              g52 = c25             
              g53 = c35             
              g54 = c45             
              g55 = c55             
              
              cx_zf(1,1,izf) = FL_1( g11 , g13 )
              cx_zf(2,1,izf) = FL_1( g21 , g23 )
              cx_zf(3,1,izf) = FL_1( g31 , g33 )
              cx_zf(4,1,izf) = FL_1( g41 , g43 )
              cx_zf(5,1,izf) = FL_1( g41 , g43 )
              cx_zf(5,1,izf) = FL_1( g51 , g53 )
              
              cx_zf(1,2,izf) = cx_zf(2,1,izf)
              cx_zf(2,2,izf) = FL_1( g22 , g24 )
              cx_zf(3,2,izf) = FL_1( g32 , g34 )
              cx_zf(4,2,izf) = FL_1( g42 , g44 )
              cx_zf(5,2,izf) = FL_1( g52 , g54 )

              cx_zf(1,3,izf) = cx_zf(3,1,izf)
              cx_zf(2,3,izf) = cx_zf(3,2,izf)
              cx_zf(3,3,izf) = g33 
              cx_zf(4,3,izf) = g43 
              cx_zf(5,3,izf) = g53 
              
              cx_zf(1,4,izf) = cx_zf(4,1,izf)
              cx_zf(2,4,izf) = cx_zf(4,2,izf)
              cx_zf(3,4,izf) = cx_zf(4,3,izf)
              cx_zf(4,4,izf) = g44             
              cx_zf(5,4,izf) = g54            

              cx_zf(1,5,izf) = cx_zf(5,1,izf)
              cx_zf(2,5,izf) = cx_zf(5,2,izf)
              cx_zf(3,5,izf) = cx_zf(5,3,izf)
              cx_zf(4,5,izf) = cx_zf(5,4,izf)
              cx_zf(5,5,izf) = g55             
*     
*     
              do i=1,dimm
                 xm_zf(i,izf) = 0.
                 do j=1,dimm
                    cm_zf(i,j,izf) = 999999.
                 enddo
                 do j=1,4
                    h_zf(i,j,izf) = 0.
                 enddo
              enddo

              z_zf(izf)      = zdl
              ch_zf(izf)     = 0.
              cht_zf(izf)    = 0.
              hit_zf(izf)    = 0 ! dummy hit
              nhit_zf(izf)   = 1
              sign_zf(izf)   = 0
              plane_zf(izf)  = 0 ! dummy hit
              domlay_zf(izf) = dl
              prev_zf(izf)   = 0
              prevs_zf(izf)  = 0
              fault_zf(izf)  = 0
              pfault_zf(izf) = 0
              dim_zf(izf)    = 0
              shadow_zf(izf) = 0
              whit_zf(izf)   = 0

#ifdef FILL_MC
              call tfremcse(iseg,imcass,frmcass)
              if(frmcass.ge.0.99) mc_zf(izf) = imcass
              print *,' tfdownse.F : iseg ',iseg,' ift ',(nca_ft+1)
     +             ,' izf ',izf,' mc ',mc_zf(izf)
#endif
              if (nca_ft.lt.ncamx) then ! create new candidate
                 nca_ft = nca_ft + 1 
                 ift = nca_ft
                 if (ift1.eq.0) ift1 = ift
                 ift2 = ift
                 first_ft(ift) = izf
                 last_ft(ift) = izf
                 prev_ft(ift) = 0
                 gen_ft(ift) = 1
                 nhit_ft(ift) = 1
                 nfault_ft(ift) = 0
                 quality_ft(ift) = 0.
                 stat_ft(ift) = 6
                 alive_ft(ift) = .true.
                 mature_ft(ift) = .false.

#ifdef dmdebug
                 print *,' tfdownse: seed planted in window '
                 call rgwidmp(dw)
                 print *,' .......................layer'
                 call rgdldmp(dl)
#endif

#ifdef dmdebug
                 print *,' tfdownse: seed planted ift=',ift,
     +                ' izf=',izf
*,' sector=',secshad_dw(dw),
*     +                ' plshad=',plshad_dw(dw)

                 print *,'     x=',sngl(xx_zf(1,izf)),
     +                '  ex=',sngl(dsqrt(cx_zf(1,1,izf)))
     +               ,' qp ',sngl(xx_zf(5,izf)) 
     +               ,' eqp ',sngl(dsqrt(cx_zf(5,5,izf)))            
*     +             , ' mc=',fmimp_x(imimp) 
*     +              + (zdl-fmimp_z(imimp)) * fmimp_tx(imimp)
                 print *,'    tx=',sngl(xx_zf(3,izf)),
     +                ' etx=',sngl(dsqrt(cx_zf(3,3,izf)))
*     +              ,' mc=',fmimp_tx(imimp) 

*     print *,' direct z  -- x comparison:'

*     print *,fmimp_z(imimp),fmimp_x(imimp),' mimp '
                 print *,frseg_ze(iseg),frseg_xe(iseg),' ze,xe '
                 print *,zdl,        x_mc,             ' dl,x_mc'  
#endif

              else
                 print *,' () tfdownse: overflowing nca_ft=',nca_ft
                 istat = -10
              endif
           else
              print *,' () tfdownse: overflowing n_zf=',n_zf
              istat = -10
           endif
           
        enddo ! seeding momenta

 20   continue

 999  end
