*-- Author :    A. Spiridonov  02/06/99
*   changed : 
*   new parameter :  iseed                          27/08/00 A. Spiridonov
*   prev_ft(ift) = ift
*   stat_ft(ift) = 3                                 04/09/00  A. Spiridonov
*
*#define dmdebug

      subroutine tfextse(iseed,iseg,ift1,ift2,istat)
*
*     seed candidate for external-propagation in TC chambers
*
*     iseed=1 , seed planted in PC1, downstream propagation
*          =2 ,                 PC4, upstream
*          =3 ,                 TC1, downstream
*          =4 ,                 TC2, upstream 
*
      implicit none

      integer iseed,iseg,ift1,ift2,istat,izf,ift,dom_tc,dom,i,j,dw,dl,sl
      integer rgnamdom,rgwidlent,maxwin,nwin,iiwin
      parameter (maxwin=40)
      integer vecwin(maxwin)
      real rgwizmax
      real xmin,xmax,ymin,ymax
      integer jaux,imc,imimp,nhmimp,nh,nh_PC
      real z_PC
      
      real x_tc,y_tc,ex_tc,ey_tc,e_tc(5,5),zdl

      logical init
      character*4 cgesl

*     **** packing scheme for covariance
      integer matrix_pack(5,5)
      data matrix_pack
     +     / 1,  2,  4,  7, 11,
     +       2,  3,  5,  8, 12,
     +       4,  5,  6,  9, 13,
     +       7,  8,  9, 10, 14,
     +      11, 12, 13, 14, 15 /
      save matrix_pack
* 
      integer ii,jj,kk,ll
      real fracmc

#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/GEO.fi"
#include "auto/RSEG.fi"
#include "auto/HITB.fi"

#include "rang/zf.fi"
#include "rang/zfextse.fi"

      data init /.false./
      save init,dom_tc

      save nwin,vecwin

      double precision c11 , c12 , c13 , c14 , c15
      double precision       c22 , c23 , c24 , c25
      double precision             c33 , c34 , c35
      double precision                   c44 , c45
      double precision                         c55
 
      double precision g11 , g12 , g13 , g14 , g15
      double precision g21 , g22 , g23 , g24 , g25
      double precision g31 , g32 , g33 , g34 , g35
      double precision g41 , g42 , g43 , g44 , g45
      double precision g51 , g52 , g53 , g54 , g55

      double precision f13,f15,f24,f25,f35,f45,f(5,5)
      double precision x,y,d_z,sum
      double precision FL_1,FL_2,FL_3
      double precision GL_1,GL_2,GL_3

      equivalence (f13,f(1,3)),(f15,f(1,5)),(f24,f(2,4))
     +           ,(f25,f(2,5)),(f35,f(3,5)),(f45,f(4,5))

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/GEO.ff"
#include "auto/RSEG.ff"
#include "auto/HITB.ff"
*
*      FL_1(x,y,z) = x + f13*y 
*      FL_2(x,y  ) = x + f24*y 
*      FL_3(x,y  ) = x 

*      GL_1(x,y,z) = x + f13*y 
*      GL_2(x,y  ) = x + f24*y 
*      GL_3(x,y  ) = x 

       Fl_1(x,y) = x + f13*y
*
*================================================================

      if (.not.init) then 

*         print *,'tfextse : new navigation for seed ',iseg

         if(iseed.eq.1) dom_tc = rgnamdom('PC1')
         if(iseed.eq.2) dom_tc = rgnamdom('PC4')
         if(iseed.eq.3) dom_tc = rgnamdom('TC1')
         if(iseed.eq.4) dom_tc = rgnamdom('TC2')

*         print *,'tfextse: dom_tc ',dom_tc

         call rgdomwin(dom_tc,maxwin,vecwin,nwin)

*         print *,'tfextse: maxwin,nwin ',maxwin,nwin

      endif                                   ! end of initalization
               
      istat = 0
      ift1 = 0
      ift2 = -1

*     **** simulate a seed from segment iseg

*      print *,' dom_tc=',dom_tc,' win1=',win1_dm(dom_tc),
*     +     ' nwin=',nwin_dm(dom_tc)

*     **** plant seed

      do 20 iiwin=1,nwin
         dw = vecwin(iiwin)
         if(iseed.eq.2.or.iseed.eq.4) dl = rgwidlent(dw,-1) ! upstream 
         if(iseed.eq.1.or.iseed.eq.3) dl = rgwidlent(dw,+1) ! downstream
         zdl = rgwizmax(dw)
         call rgwibord(dw,xmin,xmax,ymin,ymax)

*        ***** extrapolate to domain window

         x_tc = x_seed(iseg) + (zdl - z_seed(iseg)) * tx_seed(iseg)
         y_tc = y_seed(iseg) + (zdl - z_seed(iseg)) * ty_seed(iseg)


*        ***** x error extrapolation    

        d_z = ( zdl - z_seed(iseg))
        c11 = cov_seed(1,iseg)
        c13 = cov_seed(4,iseg)
        c33 = cov_seed(6,iseg)
        ex_tc = c11 + 2. * d_z * c13 + d_z * d_z * c33 
        ex_tc = sqrt( ex_tc ) * 3.

#ifdef dmdebug

         print *,'tested domain '
         print *,' dl=',dl,' dw=',dw,' xmin/x/xmax=',
     +        xmin,x_tc,xmax
         print *,' dl=',dl,' dw=',dw,' ymin/y/ymax=',
     +        ymin,y_tc,ymax
#endif


         if ((x_tc+ex_tc).lt.xmin) go to 20
         if ((x_tc-ex_tc).gt.xmax) go to 20

*        ***** y error extrapolation    

        c22 = cov_seed(3,iseg)
        c24 = cov_seed(8,iseg)
        c44 = cov_seed(10,iseg)
        ey_tc = c22 + 2. * d_z * c24 + d_z * d_z * c44 
        ey_tc = sqrt( ey_tc ) * 3.

         if ((y_tc+ey_tc).lt.ymin) go to 20
         if ((y_tc-ey_tc).gt.ymax) go to 20

#ifdef TC_TEST
         print *,' -- accepted domain'
         print  '(" d_z ",f8.3," mixma ex",3(1x,f8.3), "ex ",e11.4)'
     +          ,d_z,xmin,x_tc,xmax,ex_tc
         print  '(" d_z ",f8.3," miyma",3(1x,f8.3), "ey ",e11.4)'
     +          ,d_z,ymin,y_tc,ymax,ey_tc
*         print  '(" cov_seed(1,3,6,10,15) ",5e11.4)'
*     +          ,cov_seed(1,iseg)
*     +          ,cov_seed(3,iseg)
*     +          ,cov_seed(6,iseg)
*     +          ,cov_seed(10,iseg)
*     +          ,cov_seed(15,iseg)
#endif
         if (n_zf.lt.nzfmx) then ! create new entry in zf
            n_zf = n_zf + 1
            izf = n_zf
            xx_zf(1,izf) = x_tc
            xx_zf(2,izf) = y_tc
            xx_zf(3,izf) = tx_seed(iseg)
            xx_zf(4,izf) = ty_seed(iseg)
            xx_zf(5,izf) = q_seed(iseg)

#ifdef RT_TEST.
            do ii=1,5
              do jj=1,5
                if(ii.ne.5.and.jj.ne.5) then
                  cx_zf(ii,jj,izf) = frseg_cve(matrix_pack(ii,jj),iseg)
                else
                  cx_zf(ii,jj,izf) = 0.
                end if
              end do
            end do
            cx_zf(5,5,izf) = frseg_cvf(matrix_pack(5,5),iseg)
#endif

            f13 = d_z

            c11 = cov_seed( 1,iseg)  
            c12 = cov_seed( 2,iseg)  
            c13 = cov_seed( 4,iseg)  
	    c14 = cov_seed( 7,iseg)  
            c22 = cov_seed( 3,iseg)  
            c23 = cov_seed( 5,iseg)  
            c24 = cov_seed( 8,iseg)  
            c33 = cov_seed( 6,iseg)  
	    c34 = cov_seed( 9,iseg)  
            c44 = cov_seed(10,iseg) 
            c15 = 0.
            c25 = 0.
            c35 = 0.
            c45 = 0.
            c55 =  frseg_cvf(matrix_pack(5,5),iseg)
  
            g11 = FL_1( c11 , c13 )
            g12 = FL_1( c12 , c23 )
            g13 = FL_1( c13 , c33 )
            g14 = FL_1( c14 , c34 )
            g15 = FL_1( c15 , c35 )
        
            g21 = FL_1( c12 , c14 )
            g22 = FL_1( c22 , c24 )
            g23 = FL_1( c23 , c34 )
            g24 = FL_1( c24 , c44 )
            g25 = FL_1( c25 , c45 )

            g31 = c13 
            g32 = c23 
            g33 = c33
            g34 = c34 
            g35 = c35

            g41 = c14             
            g42 = c24             
            g43 = c34             
            g44 = c44             
            g45 = c45             

            g51 = c15             
            g52 = c25             
            g53 = c35             
            g54 = c45             
            g55 = c55             
    
            cx_zf(1,1,izf) = FL_1( g11 , g13 )
            cx_zf(2,1,izf) = FL_1( g21 , g23 )
            cx_zf(3,1,izf) = FL_1( g31 , g33 )
            cx_zf(4,1,izf) = FL_1( g41 , g43 )
            cx_zf(5,1,izf) = FL_1( g41 , g43 )
            cx_zf(5,1,izf) = FL_1( g51 , g53 )
 
            cx_zf(1,2,izf) = cx_zf(2,1,izf)
            cx_zf(2,2,izf) = FL_1( g22 , g24 )
            cx_zf(3,2,izf) = FL_1( g32 , g34 )
            cx_zf(4,2,izf) = FL_1( g42 , g44 )
            cx_zf(5,2,izf) = FL_1( g52 , g54 )

            cx_zf(1,3,izf) = cx_zf(3,1,izf)
            cx_zf(2,3,izf) = cx_zf(3,2,izf)
            cx_zf(3,3,izf) = g33 
            cx_zf(4,3,izf) = g43 
            cx_zf(5,3,izf) = g53 

            cx_zf(1,4,izf) = cx_zf(4,1,izf)
            cx_zf(2,4,izf) = cx_zf(4,2,izf)
            cx_zf(3,4,izf) = cx_zf(4,3,izf)
            cx_zf(4,4,izf) = g44             
            cx_zf(5,4,izf) = g54            

            cx_zf(1,5,izf) = cx_zf(5,1,izf)
            cx_zf(2,5,izf) = cx_zf(5,2,izf)
            cx_zf(3,5,izf) = cx_zf(5,3,izf)
            cx_zf(4,5,izf) = cx_zf(5,4,izf)
            cx_zf(5,5,izf) = g55             
*
#ifdef RT_TEST
            print '("tfextse fast ")'    
            print '("cx 1:",5(e11.4))',(cx_zf(1,ii,izf),ii=1,5)
            print '("cx 2:",5(e11.4))',(cx_zf(2,ii,izf),ii=1,5)
            print '("cx 3:",5(e11.4))',(cx_zf(3,ii,izf),ii=1,5)
            print '("cx 4:",5(e11.4))',(cx_zf(4,ii,izf),ii=1,5)
            print '("cx 5:",5(e11.4))',(cx_zf(5,ii,izf),ii=1,5)

            do ii=1,5
              do jj=1,5
                if(ii.ne.jj) then
                  f(ii,jj) = 0.
                else
                  f(ii,jj) = 1.
                end if
              end do
            end do
            f13 = d_z
            f24 = d_z

            do ii=1,5 
              do jj=1,5
                if(ii.ne.5.or.jj.ne.5) then
                  sum = 0.
                  do kk=1,5
                    do ll=1,5                 
                      sum = sum + f(ii,kk) 
     +                * cov_seed(matrix_pack(kk,ll),iseg) * f(jj,ll)
                    end do
                  end do
                  cx_zf(ii,jj,izf) = sum
                else if(ii.eq.5.and.jj.eq.5) then
                  cx_zf(ii,jj,izf) =  cov_seed(matrix_pack(ii,jj),iseg)
                else
                  cx_zf(ii,jj,izf) = 0.
                end if
              end do
            end do
*
            print '("tfextse slow ")'    
            print '("cx 1:",5(e11.4))',(cx_zf(1,ii,izf),ii=1,5)
            print '("cx 2:",5(e11.4))',(cx_zf(2,ii,izf),ii=1,5)
            print '("cx 3:",5(e11.4))',(cx_zf(3,ii,izf),ii=1,5)
            print '("cx 4:",5(e11.4))',(cx_zf(4,ii,izf),ii=1,5)
            print '("cx 5:",5(e11.4))',(cx_zf(5,ii,izf),ii=1,5)
#endif
*
            do i=1,dimm
               xm_zf(i,izf) = 0.
               do j=1,dimm
                  cm_zf(i,j,izf) = 999999.
               enddo
               do j=1,4
                  h_zf(i,j,izf) = 0.
               enddo
            enddo

#ifdef TC_TEST
*           ****  define inc,mimp
            nh_PC = 0
            imimp = 0
            z_PC = 0.
            jaux = prseg_hitb(iseg)
  27        if(jaux.eq.0) go to 30 
            nh = mrseg_hitb(jaux)
            z_PC = fhitb_z(nh)
            if(nh.gt.0) nh_PC = nh
            jaux = xrseg_hitb(jaux)
            go to 27 
  30        continue

            if(nh_PC.gt.0) then
              call tuhmimp(nh,imc,imimp,nhmimp)
            end if

            call tfremcse(iseg,imc,fracmc)

*            print'(/,"tfextse:s,h,z,mc,mi,nhm,izf,dw "
*     +      ,2(x,i4),x,f8.2,5(x,i4))'
*     +      ,iseg,nh,z_PC,imc,imimp,nhmimp,izf,dw
#endif

*           print '(" tfextse : iseg ",i5)',iseg
*           call tftcmtest(cx_zf,izf,'se cx_zf is',iseg)    !!!!!!!!!!!!!!!!

            z_zf(izf)      = zdl
            ch_zf(izf)     = 0.
            cht_zf(izf)    = 0.
            hit_zf(izf)    = 0  ! dummy hit
            nhit_zf(izf)   = 1
            sign_zf(izf)   = 0
            plane_zf(izf)  = 0  ! dummy hit
            domlay_zf(izf) = dl
            prev_zf(izf)   = 0
            prevs_zf(izf)  = 0
            fault_zf(izf)  = 0
            pfault_zf(izf) = 0
#ifdef TC_TEST                                  ! mimp --> seed
****---------------------------------------------------
            if(imimp.gt.0) then
              z_zf(izf) = fmimp_z(imimp)
              xx_zf(1,izf) = fmimp_x(imimp)
              xx_zf(2,izf) = fmimp_y(imimp)
              xx_zf(3,izf) = fmimp_tx(imimp)
              xx_zf(4,izf) = fmimp_ty(imimp)
            end if
*****----------------------------------------------------
#endif
            
            if(track_MC(iseg).gt.0) then
              mc_zf(izf) = track_MC(iseg)
            end if

            dim_zf(izf)    = 0
            shadow_zf(izf) = 0
            whit_zf(izf)   = 0

            if (nca_ft.lt.ncamx) then ! create new candidate
               nca_ft = nca_ft + 1 
               ift = nca_ft
               if (ift1.eq.0) ift1 = ift
               ift2 = ift
               first_ft(ift) = izf
               last_ft(ift) = izf
**               prev_ft(ift) = 0
               prev_ft(ift) = ift
               gen_ft(ift) = 1
               nhit_ft(ift) = 1
               nfault_ft(ift) = 0
               quality_ft(ift) = 0.
               stat_ft(ift) = 3
               alive_ft(ift) = .true.
               mature_ft(ift) = .false.

#ifdef dmdebug
               print *,' tfextse: seed planted in window '
               call rgwidmp(dw)
               print *,' .......................layer'
               call rgdldmp(dl)
#endif

#ifdef dmdebug

               print *,' tfextse: seed planted ift=',ift,
     +              ' izf=',izf,' dw ',dw

*     +              ' izf=',izf,' sector=',secshad_dw(dw),
*     +              ' plshad=',plshad_dw(dw)


               print *,'     x=',sngl(xx_zf(1,izf)),
     +              '  ex=',sngl(dsqrt(cx_zf(1,1,izf)))
     +             , ' mc= ',mc_zf(izf) 
*     +             , ' mc=',fmimp_x(imimp) 
*     +              + (zdl-fmimp_z(imimp)) * fmimp_tx(imimp)
               print *,'    tx=',sngl(xx_zf(3,izf)),
     +              ' etx=',sngl(dsqrt(cx_zf(3,3,izf)))
*     +              ,' mc=',fmimp_tx(imimp) 

*               print *,' direct z  -- x comparison:'

*               print *,fmimp_z(imimp),fmimp_x(imimp),' mimp '
               print *,z_seed(iseg),x_seed(iseg),' zseed,xseed '
               print *,zdl,x_tc,' zdl,x_tc'  
#endif

            else
               print *,' () tfextse: overflowing nca_ft=',nca_ft
               istat = -10
            endif
         else
            print *,' () tfextse: overflowing n_zf=',n_zf
            istat = -10
         endif

 20   continue

 999  end
