
*-- Author :    Rainer Mankel   18/02/97
*-- changed:    A.Spiridonov    07/05/98
* RPNT at begin of PC segment, flag RPNT_NEW_PC  26/07/00  A. Spiridonov 
* store momentum for slt_mode_zfpar.gt.0         05/09/00  A. Spiridonov
* cancel  discarding of bad segment                    05/11/00  A. Spiridonov
* new flag MAGN_HIT_CHECK                              01/12/00  A. Spiridonov
* use of fast_mode_sfpar, if_kill                      03/04/01  A. Spiridonov
* check segment : abs(xseg_1).lt.300. ...              05/05/01  A. Spiridonov
* new flag INR_HIT_CHECK                              20/07/01  A. Spiridonov
*
#define SEG_TEST
#define LIST_OF_MC
#define BAD_HIT_DISCARD
#define COV_COR_500MKM
#define TY_CORRECTION
#define RPNT_NEW_PC
#define MAGN_HIT_CHECK
#define INR_HIT_CHECK
*#define DEBUG_TFSTSEG

      subroutine tfstseg(ift)

*     **** take track candidate ift from ranger buffer
*     **** store in segment table
      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MTRA.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "auto/RPNT.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zcut.fi"
#include "rang/zfpar.fi"
#include "arte/RSEG_cmp.fi"

      integer nzfmx_s
      parameter (nzfmx_s=300)

      integer izf, ift, ih, ii,
     +     jft, iift, ihf, izf_s(nzfmx_s),
     +     nzf_s, iizf, iseg
      integer jj, rgsetcmp, iLowZ, iHighZ, iInc, zfLow, zfHigh
#ifdef LIST_OF_MC
      integer max_ass 
      parameter(max_ass = 40)
      integer imc(max_ass),nmc
      real fracmc(max_ass)
      logical rgmc
#else
      integer imc
      real fracmc
#endif

      logical lchi2,llsmoo,smoothed(nzfmx_s),init,sm

      integer maxpnt
#ifdef RPNT_NEW_PC
      parameter (maxpnt=5)
#else
      parameter (maxpnt=4)
#endif
      integer zfPnt(maxpnt),ipnt,jpnt,rp
      real zPnt(maxpnt),zlow,zhigh
      logical smPnt(maxpnt)
      character*4 cc
      integer indrp

#include "pris/zmpack.fi"

      save init,zpnt,zlow,zhigh
      data init /.false./

      real xseg_1,xseg_2,yseg_1,yseg_2
      integer message_id_1

#ifdef SEG_TEST
      real xx_1,tx_1,y_1,ty_1,y_targ,q_1,y_targ_max/15./,dz_min/60./
      real tfqptest
#endif

#ifdef BAD_HIT_DISCARD
      integer ihbad,iftbad
#endif

#ifdef  COV_COR_500MKM 
      real cov_corf(4),cov_core(4)
**      data cov_cor/1.54,1.458,1.204,1.31/   !  old
      data cov_corf/1.62,1.69,1.97,1.69/
      data cov_core/1.79,1.56,1.54,1.05/

      integer ix,iy
      save cov_corf,cov_core
#endif

#ifdef MAGN_HIT_CHECK
      integer nhitmin_mag_zfpar
      data nhitmin_mag_zfpar/4/       ! mininal number if hits in magnet
      integer nhtmag
      logical if_magn_discard         ! if .true. discard hits in magnet
#endif
      logical if_kill

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MTRA.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
#include "auto/RPNT.ff"

*********************************************************
*
*     Meaning of the candidate flag stat_ft:
*
*        stat_ft = 1   x candidate
*                  2   y candidate
*                  3   3D, smoothed
*                  4   momentum information
*                  5   momentum information, smoothed
*
*********************************************************

#ifdef DEBUG_TFSTSEG
**       print *,'tfstseg: start ift ',ift,' nh ',nhit_zf(last_ft(ift))
**     +      ,' z1,2 ',z_zf(first_ft(ift)),z_zf(last_ft(ift))
#endif

*      lsmoo = stat_ft(ift).eq.3.or.stat_ft(ift).eq.5
      if_kill = .false.

      if (.not.init) then 
         init = .true.
*        **** default positions
#ifdef RPNT_NEW_PC
         zpnt(1) = 854.         ! begin of RICH
         zpnt(2) = 1174.        ! end   of RICH
         zpnt(3) = 1214.        ! begin of TRD
         zpnt(4) = 1290.        ! end   of TRD
         zpnt(5) = 684.         ! begin of PC
#else
         zpnt(1) = 854.         ! begin of RICH
         zpnt(2) = 1174.        ! end   of RICH
         zpnt(3) = 1214.        ! begin of TRD
         zpnt(4) = 1290.        ! end   of TRD
#endif
         do ii=1,iq(jgesl+2)    ! look at real superlayers
            write(cc,'(a4)') hgesl_name(ii)
#ifdef RPNT_NEW_PC
            if (cc.eq.'RICH') then
               zpnt(1) = fgesl_z1(ii)
               zpnt(2) = fgesl_z2(ii)
*               print *,' tfstseg: RICH start/end=',zpnt(1),zpnt(2)
            elseif (cc.eq.'TRSL') then
               zpnt(3) = fgesl_z1(ii)
               zpnt(4) = fgesl_z2(ii)
*               print *,' tfstseg: TRD  start/end=',zpnt(3),zpnt(4)
            elseif (cc.eq.'MS10') then
               zpnt(5) = fgesl_z1(ii)
*               print *,' tfstseg: MS10 start/end=',zpnt(5)
            endif
#else
            if (cc.eq.'RICH') then
               zpnt(1) = fgesl_z1(ii)
               zpnt(2) = fgesl_z2(ii)
*               print *,' tfstseg: RICH start/end=',zpnt(1),zpnt(2)
            elseif (cc.eq.'TRSL') then
               zpnt(3) = fgesl_z1(ii)
               zpnt(4) = fgesl_z2(ii)
*               print *,' tfstseg: TRD  start/end=',zpnt(3),zpnt(4)
            endif
#endif

         enddo
#ifdef RPNT_NEW_PC
         zlow = zpnt(5) - 100.
         zhigh = zpnt(4) + 100.
#else
         zlow = zpnt(1) - 100.
         zhigh = zpnt(4) + 100.
#endif
      endif

      if (diag_level.ge.5) call tfl()

#ifdef MAGN_HIT_CHECK
      if_magn_discard = .false.
      if(rlevel_zfpar.eq.3.or.rlevel_zfpar.eq.4) then
         if(z_zf(last_ft(ift)).lt.660.) then
            call tfhtmag(ift,nhtmag)
            if(nhtmag.lt.nhitmin_mag_zfpar) then
               if_magn_discard = .true.
            endif
         endif
      endif
#endif

#ifdef BAD_HIT_DISCARD
*     ****  define bad hit
      call tfhtseg(ift,ihbad,iftbad)
*%%%
**      if(iftbad.ne.0) print '(" tfstseg.F : ---- discard ift ",i5 )',ift
******      if(iftbad.ne.0) go to 999         !  discard bad segment
**      if(ihbad.gt.0) then
**         call hf1(533,fhitb_q(ihbad),1.)
**      end if
#endif

*     **** create vector of hits
      nzf_s = 0

*     **** loop over segments in ranger buffer
      do 10 iift=1,3
       if (iift.eq.1) then
        jft = ift
       elseif (prev_ft(jft).gt.0) then
        jft = prev_ft(jft)
       else
        go to 11
       endif

#ifdef DEBUG_TFSTSEG
**       print *,'tfstseg: loop jft ',jft,' nh ',nhit_zf(last_ft(jft))
**     +      ,' z1,2 ',z_zf(first_ft(jft)),z_zf(last_ft(jft))
#endif

       llsmoo = stat_ft(jft).eq.3.or.stat_ft(jft).eq.5

       do iizf=1,nhit_ft(jft)

        if (iizf.eq.1) then
         izf = last_ft(jft)
        else
         if (.not.llsmoo) then
          izf = prev_zf(izf)
         else
*         **** smoothed ordering
          izf = prevs_zf(izf)
         endif
        endif
        if (izf.eq.0) then
         print *,' () tfstseg: izf=', izf,
     +           ' iift,iizf,ift,jft,stat_ft,nhit_ft,llsmoo=',
     +             iift,iizf, ift, jft, stat_ft(ift), nhit_ft(jft),
     +             llsmoo
         call tfwait()
         go to 999
        endif

        if (hit_zf(izf).eq.0) go to 61 ! skip dummy hit

#ifdef BAD_HIT_DISCARD
#ifdef INR_HIT_CHECK
        if (hit_zf(izf).eq.ihbad
     +     .and..not.cats_mode_zfpar ) then ! skip bad hit     
#else
        if (hit_zf(izf).eq.ihbad) then ! skip bad hit
#endif
**        print *,' tfstseg : ======== BAD HIT ift,ihbad,nrseg '
**     +         , ift,ihbad,(nrseg()+1)
        go to 61
        end if
#endif        

#ifdef INR_HIT_CHECK
        if(cats_mode_zfpar) then
           if(inr_zf(izf).ne.1
     +          .and.(z_zf(izf).lt.1000..and.z_zf(izf).gt.680.)) then
**              print *,'tfstseg.F : not cats hit z_zf ',z_zf(izf)
              go to 61
           endif
        endif
#endif

#ifdef MAGN_HIT_CHECK
        if(if_magn_discard) then
           if(z_zf(izf).gt.206..and.
     +          z_zf(izf).lt.660.) go to 61
        endif
#endif
        if (nzf_s.lt.nzfmx_s) then

           if(nzf_s.gt.0) then
              do jj=1,nzf_s
                 if(hit_zf(izf_s(jj)).eq.hit_zf(izf)) go to 61 !skip double hit
              end do
           end if

           nzf_s = nzf_s + 1
           izf_s(nzf_s) = izf
           smoothed(nzf_s) = llsmoo
* 61        continue
        else
           print *,' () tfstseg: overflowing nzf_s=', nzf_s
           go to 11
        endif
 61     continue
       enddo
 31    continue
 10   continue
 11   continue
      
      if (diag_level.gt.0) then
       print *,' tfstseg: seg=',nrseg()+1,' nzf_s=', nzf_s
       print *,'         izf_s=', (hit_zf(izf_s(iizf)),iizf=1,nzf_s)
 
       do iizf=1,nzf_s-1
         do ih=iizf+1,nzf_s
           if(hit_zf(izf_s(iizf)).eq.hit_zf(izf_s(ih)) ) then
                    print *,' tfstseg: hits iizf,ih ',iizf,ih
     +                     ,'                identical =============='       
*                    stop 'tfstseg : identical'
           endif
         enddo
       enddo
      endif

*      **** security check
      ih = hit_zf(izf_s(1))
      if (nzf_s.eq.0.or.ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfstseg: nzf_s,ii,ih,iq(jhitb+2),ift,nhit_ft =',
     +        nzf_s,ii,ih,iq(jhitb+2),ift,
     +        nhit_ft(ift)
         call tfwait()
         go to 999
      endif

*     **** identify indices of lowest/highest z
      if (z_zf(izf_s(1)).lt.z_zf(izf_s(nzf_s))) then
         iLowZ  = 1         ! normal ordering
         iHighZ = nzf_s
         iInc   = +1        ! loops from low to high use +iInc
      else
         iLowZ  = nzf_s     ! reverse ordering
         iHighZ = 1
         iInc   = -1        ! loops from high to low use -iInc
      endif

*     **** take impact parameter of lowest-z point
      zfLow  = izf_s(iLowZ)
      zfHigh = izf_s(iHighZ)

*    *****  check segment coordinates

      if (.not.smoothed(iLowZ)) then ! first point segment not smoothed
         if (smoothed(iHighZ)) then 
            xseg_1 = xx_zf(1,zfLow)
            xseg_2 = xs_zf(1,zfHigh)
            yseg_1 = xx_zf(2,zfLow)
            yseg_2 = xs_zf(2,zfHigh)
         else
            xseg_1 = xx_zf(1,zfLow)
            xseg_2 = xx_zf(1,zfHigh)
            yseg_1 = xx_zf(2,zfLow)
            yseg_2 = xx_zf(2,zfHigh)
         endif
      else                      ! first point segment smoothed
         if (smoothed(iHighZ)) then
            xseg_1 = xs_zf(1,zfLow)
            xseg_2 = xs_zf(1,zfHigh)
            yseg_1 = xs_zf(2,zfLow)
            yseg_2 = xs_zf(2,zfHigh)
         else
            xseg_1 = xs_zf(1,zfLow)
            xseg_2 = xx_zf(1,zfHigh)
            yseg_1 = xs_zf(2,zfLow)
            yseg_2 = xx_zf(2,zfHigh)
         endif
      endif

      if(  abs(xseg_1).lt.300..and.abs(xseg_2).lt.300.
     + .and.abs(yseg_1).lt.350..and.abs(yseg_2).lt.350. ) then ! wrong x or y
         go to 21
      else

#ifdef DEBUG_TFSTSEG
         print '("tfstseg.F : is,x12,y12 =",i4,4(x,e11.4))'
     +        ,iseg,xseg_1,xseg_2,yseg_1,yseg_2
#endif
        call mepric(message_id_1,1,'tfstseg.F : x > 300 or y > 350')
        go to 999
      end if
 21   continue

#ifdef SEG_TEST
#ifdef INR_HIT_CHECK
      if(abs(z_zf(zfHigh) - z_zf(zfLow)).lt.dz_min
     +  .and..not.cats_mode_zfpar) then ! short segment
#else
      if(abs(z_zf(zfHigh) - z_zf(zfLow)).lt.dz_min) then ! short segment
#endif

#ifdef DEBUG_TFSTSEG
         print '("tfstseg.F : short z1,z2 ",2(x,f8.3))'
     +        ,z_zf(zfLow),z_zf(zfHigh)
#endif
         if_kill = .true.
         if(.not.fast_mode_zfpar) go to 999
      endif

*     **** define y_targ
      if (.not.smoothed(iLowZ)) then ! first point segment not smoothed
         if (smoothed(iHighZ)) then 
            xx_1 = xx_zf(1,zfLow)
            tx_1 = xx_zf(3,zfLow)
            y_1 = xx_zf(2,zfLow)
            ty_1 = xx_zf(4,zfLow)
         else
            xx_1 = xx_zf(1,zfLow)
            tx_1 = xx_zf(3,zfLow)
            y_1 = xx_zf(2,zfLow) 
            ty_1 = xx_zf(4,zfLow) 
         endif
      else                      ! first point segment smoothed
         if (smoothed(iHighZ)) then
            xx_1 = xs_zf(1,zfLow)
            tx_1 = xs_zf(3,zfLow)
            y_1 = xs_zf(2,zfLow)
            ty_1 = xs_zf(4,zfLow)
         else
            xx_1 = xs_zf(1,zfLow)
            tx_1 = xs_zf(3,zfLow)
            y_1 = xs_zf(2,zfLow) 
            ty_1 = xs_zf(4,zfLow) 

         endif
      endif

      y_targ = y_1 - ty_1 * z_zf(zfLow)
      q_1 = -tfqptest(z_zf(zfLow),xx_1,tx_1) * 1.031  

*%%%
**      print '(" tfstseg : y_1,ty_1,y_targ ",4(x,f9.3))'
**     +       ,y_1,ty_1,y_targ,q_1

#ifdef SEG_TEST_USE 
      if( abs(y_targ).gt.y_targ_max) then       !  wrong y_targ
#ifdef DEBUG_TFSTSEG
         print '(" tfstseg : wrong y_targ ",f9.3)',abs(y_targ)
#endif
         if_kill = .true
         if(.not.fast_mode_zfpar) go to 999
      endif

      if(rlevel_zfpar.ne.3.and.rlevel_zfpar.ne.4) then
         if(abs(q_1).gt.1.) then                 ! small P
#ifdef DEBUG_TFSTSEG
            print '(" tfstseg : small p ",f8.3)',(1./abs(q_1))
#endif
            if_kill = .true.
            if(.not.fast_mode_zfpar) go to 999
         endif        
      end if
#endif

#endif

      call mmbook(jrseg,1)      ! increase row counter
      iseg = nrseg()

      lchi2 = .true.

      q(qrseg_zf_l()) = z_zf(zfLow)
      q(qrseg_ze_l()) = z_zf(zfHigh)

*     **** fill track parameters
      if (.not.smoothed(iLowZ)) then ! first point segment not smoothed
         if (smoothed(iHighZ)) then 
#ifdef SEG_TEST
            if(rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5) then
*     *      print *,' tfstseg.F : cx cs '
               xx_zf(5,zfLow) = q_1      
               xs_zf(5,zfHigh) = q_1
               cx_zf(5,5,zfLow) = 1.738
               cs_zf(5,5,zfHigh) = 1.738
            else if(rlevel_zfpar.eq.3.or.rlevel_zfpar.eq.4) then
               xs_zf(5,zfHigh) = xx_zf(5,zfLow)
               cs_zf(5,5,zfHigh) = cx_zf(5,5,zfLow)
            end if
#ifdef   COV_COR_500MKM 
            do ix=1,4
               do iy=1,4
                  cx_zf(ix,iy,zfLow) = cx_zf(ix,iy,zfLow)
     +            * cov_corf(ix) * cov_corf(iy) 
                  cs_zf(ix,iy,zfHigh) = cs_zf(ix,iy,zfHigh)
     +            * cov_core(ix) * cov_core(iy) 
               end do
            end do
#endif
#endif
#ifdef TY_CORRECTION
            xs_zf(4,zfHigh) = (xs_zf(2,zfHigh) - xx_zf(2,zfLow))
     +      / (z_zf(zfHigh) - z_zf(zfLow))
**            xs_zf(4,zfHigh) = xs_zf(2,zfHigh) / z_zf(zfHigh)
#endif

            call tfsegfill(iseg,xx_zf(1,zfLow),cx_zf(1,1,zfLow),
     +           xs_zf(1,zfHigh),cs_zf(1,1,zfHigh))
         else
#ifdef SEG_TEST
            if(rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5) then
*     *            print *,' tfstseg.F : cx cx '
               xx_zf(5,zfLow) = q_1
               xx_zf(5,zfHigh) = q_1
               cx_zf(5,5,zfLow) = 1.738
               cx_zf(5,5,zfHigh) = 1.738
            end if
#ifdef   COV_COR_500MKM_X 
            do ix=1,4
               do iy=1,4
                  cx_zf(ix,iy,zfLow) = cx_zf(ix,iy,zfLow)
     +            * cov_cor(ix) * cov_cor(iy)
                  cx_zf(ix,iy,zfHigh) = cx_zf(ix,iy,zfHigh)
     +            * cov_cor(ix) * cov_cor(iy)
               end do
            end do
#endif
#endif
            call tfsegfill(iseg,xx_zf(1,zfLow),cx_zf(1,1,zfLow),
     +           xx_zf(1,zfHigh),cx_zf(1,1,zfHigh))
         endif
      else                      ! first point segment smoothed
         if (smoothed(iHighZ)) then
#ifdef SEG_TEST
            if(rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5
     +      .or.slt_mode_zfpar.gt.0) then
*     *            print *,' tfstseg.F : cs cs '
               xs_zf(5,zfLow) = q_1
               xs_zf(5,zfHigh) = q_1
               cs_zf(5,5,zfLow) = 1.738
               cs_zf(5,5,zfHigh) = 1.738
            end if
#ifdef   COV_COR_500MKM_X 
            do ix=1,4
               do iy=1,4
                  cs_zf(ix,iy,zfLow) = cs_zf(ix,iy,zfLow)
     +            * cov_cor(ix) * cov_cor(iy)
                  cs_zf(ix,iy,zfHigh) = cs_zf(ix,iy,zfHigh)
     +            * cov_cor(ix) * cov_cor(iy)
               end do
            end do
#endif
#endif
            call tfsegfill(iseg,xs_zf(1,zfLow),cs_zf(1,1,zfLow),
     +           xs_zf(1,zfHigh),cs_zf(1,1,zfHigh))
         else
#ifdef SEG_TEST
            if(rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5) then
*     *            print *,' tfstseg.F : cs cx '
               xs_zf(5,zfLow) = q_1
               xx_zf(5,zfHigh) = q_1
               cs_zf(5,5,zfLow) = 1.738
               cx_zf(5,5,zfHigh) = 1.738
            end if
#ifdef   COV_COR_500MKM_X 
            do ix=1,4
               do iy=1,4
                  cs_zf(ix,iy,zfLow) = cs_zf(ix,iy,zfLow)
     +            * cov_cor(ix) * cov_cor(iy)
                  cx_zf(ix,iy,zfHigh) = cx_zf(ix,iy,zfHigh)
     +            * cov_cor(ix) * cov_cor(iy)
               end do
            end do
#endif
#endif
            call tfsegfill(iseg,xs_zf(1,zfLow),cs_zf(1,1,zfLow),
     +           xx_zf(1,zfHigh),cx_zf(1,1,zfHigh))
         endif
      endif

*     **** set segment flag
      iq(iqrseg_fit_l()) = 0
      q (qrseg_chi_l()) = cht_zf(izf_s(1))

      iq(iqrseg_nhit_l()) = nzf_s 
      if(rlevel_zfpar.le.2) then
         iq(iqrseg_npar_l()) = 4
      else
         iq(iqrseg_npar_l()) = 5         
      endif

      do 20 ii=iHighZ,iLowZ,-iInc ! decreasing z order
         izf = izf_s(ii)
         ih = hit_zf(izf)
         if (ih.le.0.or.ih.gt.nhitb()) then
            print *,' () tfstseg: izf, nzf_s, ii, ih, iq(jhitb+2)=',
     +           izf, nzf_s, ii, ih, iq(jhitb+2)
            go to 20
         endif
*        **** allocate row for new hit in hfit table
         call mmbook(jrhit,1)
         ihf = nrhit()

         if (.not.smoothed(ii)) then
            q(qrhit_x_l())  = xx_zf(1,izf)
            q(qrhit_y_l())  = xx_zf(2,izf)
            q(qrhit_tx_l()) = xx_zf(3,izf)
            q(qrhit_ty_l()) = xx_zf(4,izf)
            q(qrhit_p_l())  = xx_zf(5,izf)
#ifdef SEG_TEST 
            q(qrhit_p_l()) = q_1
#endif
         else
            q(qrhit_x_l())  = xs_zf(1,izf)
            q(qrhit_y_l())  = xs_zf(2,izf)
            q(qrhit_tx_l()) = xs_zf(3,izf)
            q(qrhit_ty_l()) = xs_zf(4,izf)
            q(qrhit_p_l())  = xs_zf(5,izf)
#ifdef SEG_TEST  
            q(qrhit_p_l()) = q_1
#endif

         endif

         if (igede_cmp(plane_zf(izf)).eq.2) then ! set quantity in RHIT
            q(qrhit_q_l()) = abs(fhitb_q(ih)) * sign_zf(izf)
         else
            q(qrhit_q_l()) = 0.
         endif

         call mmbrel(jhirh,ih,ihf) ! relation hitb <-> rhit

         call mmbrel(jrsrh,iseg,ihf) ! relation rseg <-> rhit

*        **** set track assignment in zhitb
         if (ih.gt.0.and.ih.le.nhitb()) then
            call mmbrel(jrshi,iseg,ih)
         else
            print *,' () tfstseg: invalid ih=', ih
         endif

 20   continue   ! hitf loop


      if (jmtra.ne.0) then 
#ifdef LIST_OF_MC
         if(rgmc()) then
*     **** MC owned  ?
            call tfremcl(izf_s,nzf_s,max_ass,nmc,imc,fracmc)
            
            if(nmc.gt.0) then 
               do ii = 1,nmc 
                  if (fracmc(ii).gt.0.7) then
*    **** set relation rseg <-> mtra
**            call mmbrel(jrsmt,iseg,imc)  ! relation swap
                     call mmbrel(jmtrs,imc(ii),iseg)
                  endif
               end do
            end if
         end if
#else
      if (jmtra.ne.0) then 
*        **** MC owned  ?
         call tfremcs(izf_s,nzf_s,imc,fracmc)

         if (imc.ne.0.and.fracmc.gt.0.7) then
*           **** set relation rseg <-> mtra
**            call mmbrel(jrsmt,iseg,imc)  ! relation swap
            call mmbrel(jmtrs,imc,iseg)
         endif
#endif
      endif

      iq(iqrseg_cmp_l()) = rgsetcmp(iseg,0)   ! set cmp flag

*     **** produce RPNTs
*     **** ipnt = 1      before RICH
*     ****        2      after  RICH
*     ****        3      before TRD
*     ****        4      after  TRD
#ifdef RPNT_NEW_PC 
*     ****        5      before PC
#endif
      do ipnt=1,maxpnt
         zfPnt(ipnt) = 0
         smPnt(ipnt) = .false.
      enddo

*     **** locate the proper points
      do 40 ii=iLowZ,iHighZ,iInc       ! loop over hits
         izf = izf_s(ii)
         sm  = smoothed(ii)
         ih = hit_zf(izf)
         if (ih.le.0) go to 40
         if (z_zf(izf).lt.zlow.or.z_zf(izf).gt.zhigh) go to 40
         
         ipnt = 1
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-100.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            endif
         endif

         ipnt = 2
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+100.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            endif
         endif

         ipnt = 3
         if (z_zf(izf).le.zPnt(ipnt).and.z_zf(izf).gt.(zPnt(ipnt)-100.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            elseif (z_zf(zfPnt(ipnt)).lt.z_zf(izf)) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            endif
         endif

         ipnt = 4
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+100.)) 
     +        then
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            endif
         endif

#ifdef RPNT_NEW_PC 
         ipnt = 5
**         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+100.)) 
         if (z_zf(izf).ge.zPnt(ipnt).and.z_zf(izf).lt.(zPnt(ipnt)+200.)) 
     +        then
#ifdef INR_HIT_CHECK
            if(inr_zf(izf).eq.1.and.cats_mode_zfpar.or.
     +           .not.cats_mode_zfpar) then
               if (zfPnt(ipnt).eq.0) then
                  zfPnt(ipnt) = izf
                  smPnt(ipnt) = sm
               elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
                  zfPnt(ipnt) = izf
                  smPnt(ipnt) = sm
               endif
            endif
#else
            if (zfPnt(ipnt).eq.0) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            elseif (z_zf(zfPnt(ipnt)).gt.z_zf(izf)) then
               zfPnt(ipnt) = izf
               smPnt(ipnt) = sm
            endif
#endif
         endif
#endif
 40   continue

*     **** weedout the duplicates
      do ipnt=1,maxpnt
         do jpnt=ipnt+1,maxpnt
            if (zfPnt(jpnt).eq.zfPnt(ipnt)) zfPnt(jpnt) = 0
         enddo
      enddo

      if(if_kill.and.fast_mode_zfpar) then                ! kill segment
         iq(iqrseg_cmp_l()) = IAND(iq(iqrseg_cmp_l()),rsegc_bitsign)

#ifdef DEBUG_TFSTSEG 
         print *,'tfstseg.F:-\/-/\-\/-/\-\/ ift,nrseg ',ift,nrseg() 
#endif

      endif

*     **** store the RPNTs
      do ipnt=maxpnt,1,-1
         if (zfPnt(ipnt).gt.0) then
            izf = zfPnt(ipnt)
            call mmbook(jrpnt,1)
            rp = nrpnt()
            q(qrpnt_zf_l()) = z_zf(izf)
            if (.not.smPnt(ipnt)) then ! for tracks without smoothing
               call tfpnfill(rp,xx_zf(1,izf),cx_zf(1,1,izf))
            else                ! for tracks with smoothing
               call tfpnfill(rp,xs_zf(1,izf),cs_zf(1,1,izf))
            endif

            call mmbrel(jrsrp,iseg,rp) ! set relation
         endif
      enddo

 50   if (diag_level.ge.1) then
       print *,' **************************************************'
       print *,' *    track stored, current number=',iseg
       print *,' *                             ift=',ift
       print *,' *                  number of hits=',nzf_s
       print *,' *                    total chi**2=',frseg_chi(iseg)
       print *,' **************************************************'
      endif

 999  return
      end
