*-- Author :    Rainer Mankel   24/02/96

      subroutine tftrane(dz,izf,jzf,f,istat)

*     **** construct transport matrix for electrons
      implicit none
#include "arte/Arte.fi"
      integer izf, jzf, npoints, ifstart, ifend, istat, ii, jj, kk, ll,
     +        mm,iii,jjj,ndimmag,ipl,imc,mimp,nnmimp
      parameter (ndimmag=5)
      double precision dz, dzto, rrstart
      real entry_pt(3), exit_pt(3), pnoise, dnoise, sqxy, tfwall,
     +     rad_thick, sum_wall
      double precision entry_z, exit_z, sum, cnoise(5,5)
#include "rang/zr.fi"
#include "rang/zf.fi"
#include "rang/zcut.fi"

#include "rang/zma.fi"
      double precision f (ndimmag,ndimmag), f1(ndimmag,ndimmag),
     +       f2(ndimmag,ndimmag)
      double precision x_border(ndimmag)

#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"

*     **** local statement functions
      entry_z() = dble( entry_pt(3) )
      exit_z()  = dble( exit_pt (3) )

      istat = 0
      ipl = plane_zf(izf)


      dzto = z_zf(izf) + dz

*     **** step 1: determine case flags
*            ifstart=1 : starting point outside magnet
*                    2 :    ||          inside    ||
*            ifend  =1 : exit     point outside   ||
*                    2 :    ||          inside    ||


      if (z_zf(izf).gt.(ffeld_z(1)+ffeld_r(1))
     +     .and.dzto.gt.(ffeld_z(1)+ffeld_r(1))) then
       ifstart = 1
       ifend   = 1
      else
*      **** check more precisely if starting point is inside magnet
       rrstart = (z_zf(izf) - ffeld_z(1))**2 + xx_zf(1,izf)**2
*      **** start flag
       if (rrstart.gt.dble(ffeld_r(1)**2)) then
        ifstart = 1
**        print *,' tftrane: starting point outside magnet'
       else
        ifstart = 2
**        print *,' tftrane: starting point inside magnet'
       endif
*      **** search intersection
       call tfmgl(ifstart,izf,npoints,entry_pt,exit_pt)
*      **** check endpoint
       if (npoints.gt.0) then
        if (ifstart.eq.1) then
         if (dzto.gt.entry_z().or.z_zf(izf).lt.entry_z()) then
          ifend= 1
**          print *,' tftrane: end point outside magnet'
         else
          ifend = 2
**          print *,' tftrane: end point inside magnet'
         endif
        else
         if (dzto.lt.exit_z()) then
          ifend= 1
**          print *,' tftrane: end point outside magnet'
         else
          ifend = 2
**          print *,' tftrane: end point inside magnet'
         endif
        endif
       else
*       **** no further intersection with magnet path
*       **** assume track stays in medium
        ifend = ifstart
       endif
      endif

*     **** step 2: transport vector & fill derivative matrix f
      if (ifstart.eq.1.and.ifend.eq.1) then
*      **** start/end outside magnet
*      **** ignore possibility of WHOLE MAGNET in between
       xp_zf(1,jzf) = xx_zf(1,izf) + dz * xx_zf(3,izf)
       xp_zf(2,jzf) = xx_zf(2,izf) + dz * xx_zf(4,izf)
       xp_zf(3,jzf) = xx_zf(3,izf)
       xp_zf(4,jzf) = xx_zf(4,izf)
       xp_zf(5,jzf) = xx_zf(5,izf)

*      **** f matrix
       do ii=1,5
        do jj=1,5
         if (ii.eq.jj) then
          f(ii,jj) = 1.
         elseif ((ii.eq.1.and.jj.eq.3).or.(ii.eq.2.and.jj.eq.4)) then
          f(ii,jj) = dz
         else
          f(ii,jj) = 0.
         endif
        enddo
       enddo
      elseif (ifstart.eq.2.and.ifend.eq.2) then
*      **** track fully contained in magnet
       call tfthel(ndimmag,xx_zf(1,izf),dz,xp_zf(1,jzf),f,istat)
       if (istat.lt.0) then
        print *,' tftrane: transport impossible (hel) '
        go to 999
       endif
      else
*      **** split transport into inside & outside pieces
       if (ifstart.eq.1.and.ifend.eq.2) then
*       **** from outside to inside
        call tftlin(ndimmag,xx_zf(1,izf),entry_z()-z_zf(izf),
     +             x_border,f1)
        call tfthel(ndimmag,x_border,dzto-entry_z(),
     +             xp_zf(1,jzf),f2,istat)
        if (istat.lt.0) then
         print *,' tftrane: transport impossible (lin/hel) '
         go to 999
        endif

       elseif (ifstart.eq.2.and.ifend.eq.1) then
*       **** from inside to outside
        call tfthel(ndimmag,xx_zf(1,izf),exit_z()-z_zf(izf),
     +             x_border,f1,istat)
        if (istat.lt.0) then
         print *,' tftrane: transport impossible (hel/lin) '
         go to 999
        endif

        call tftlin(ndimmag,x_border,dzto-exit_z(),
     +             xp_zf(1,jzf),f2)
       endif

*      **** combine derivative matrices
       do ii=1,ndimmag
        do jj=1,ndimmag
         sum = 0.
         do kk=1,ndimmag
          sum = sum + f2(ii,kk) * f1(kk,jj)
         enddo
         f(ii,jj) = sum
        enddo
       enddo
      endif

*     **** step 3: propagate cov matrix
      call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)
      pnoise = amax1(abs( fmimp_p(mimp) ),1.)
*     **** get radiation thickness
      sum_wall = tfwall(ipl,sngl(dzto),
     +     sngl(xx_zf(1,izf)),
     +     sngl(xx_zf(2,izf)),
     +     sngl(xx_zf(3,izf)),
     +     sngl(xx_zf(4,izf)))
      dnoise = 3.0 * sum_wall / pnoise**2


*     **** correct for angle
      sqxy = dsqrt(1.d0 + xp_zf(3,jzf)**2 + xp_zf(4,jzf)**2)
      dnoise = dnoise * sqxy
      rad_thick = sum_wall * sqxy / 0.0136**2

      do ii=1,5
         do jj=1,5
            cnoise(ii,jj) = 0.
         enddo
      enddo
      cnoise(3,3) = (1.+xp_zf(3,jzf)**2) * sqxy**2 * dnoise
      cnoise(4,4) = (1.+xp_zf(4,jzf)**2) * sqxy**2 * dnoise
      cnoise(3,4) = -xp_zf(3,jzf) * xp_zf(4,jzf) * sqxy**2 * dnoise
      cnoise(4,3) = cnoise(3,4)

      do ii=1,5
       do jj=1,ii
        sum = 0.
        do ll=1,5
         do mm=1,5
           sum = sum
     +         + f(ii,ll) * (cx_zf(ll,mm,izf)+cnoise(ll,mm)) * f(jj,mm)
         enddo
        enddo
        cp_zf(ii,jj,jzf) = sum
        cp_zf(jj,ii,jzf) = sum
       enddo
      enddo

*     **** electron energy loss correction
      xp_zf(5,jzf) = xp_zf(5,jzf) * exp(- rad_thick)
      cp_zf(5,5,jzf) = cp_zf(5,5,jzf)
     +     + xp_zf(5,jzf)**2 * (exp(-rad_thick * alog(3.)/alog(2.))
     +     - exp(-2.*rad_thick))

      if (mprizr.ge.6) then
       print *,' tftrane: dz, izf=',dz,izf
       print *,' tftrane: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
       print *,' tftrane: cx_zf(,,izf)',
     +     ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
       print *,' tftrane: xp_zf=',(xp_zf(iii,jzf),iii=1,5)
       print *,' tftrane: cp_zf=',
     +     ((cp_zf(iii,jjj,jzf),iii=1,5),jjj=1,5)
      endif

 999  end



