      subroutine tfversion()

************************************************************************
*                                                                      *
*  Author: Rainer Mankel                                               *
*                                                                      *
*  Creation date: 10-Nov-96                                            *
*                                                                      *
*  changed: A. Spiridonov                                              *
*                                                                      *
*  Date of first change : 27-Okt-99                                    *
*                                                                      *
************************************************************************

*     **** print ranger version id 
      implicit none

**      call mewarn('ranger 4.16/21 ')
      call mewarn('ranger 4.18/05 ')

      end


************************************************************************
* Version history:
* 4.18/05  arte-03-09-r7 
*          HitPattern.C: a small bug in printing was fixed
*          Fit.C: not use 1,3 pass in rangerFit(rtra,fit(0,1) in FitL(rtra,rseg...
*          Geom.C: fudge  otr,itr,hi-pt
*          Track.C,HitBase.C: debug printing
*          Node.C,HitWire.C: //#include <TH1.h>
*          Thin.C,Thick.C,State.C: applyDeDxe based on gede->dedx
*          StateP.C: #define TRANSCD
*          Volume.C: set dedxValue in rangerVolume::makeVolume()
*          rk4order.C: new rktransf_()
*          tfunrf.F: remove call rgseg2t(rs)
*          tfdownstr3.F: check mcmode_zfpar
*
* 4.18/04  arte-03-09-r6 
*          rgcheckhpt.C,rgfitvtr.C,rgmatcha.C,rgauxsvm.C : new
*          Uniq.C : minor change 
*          tfdownse3.F,tfdownstr3.F,tffilmn3.F,tfjoint.F,tfpropmn3.F,tfstseg3.F:new
*          tf1init.F : set param. mcmode_,match_,hptmode_zfpar 
*          tfevntr.F : call tfdownstr3,rgmatcha
*          tfkfpar.F : new parameters mcmode,matchmode,hptmode
*          tfrsegft.F : xs_zf(5,izf) = frseg_pe(iseg)
*          Geom.C : check of evrc->alca in condUpdate()
*          Volume.C: remove message from rangerVolume::makeVolume()
*
* 4.18/03  arte-03-09-r5 
*          rgsltget.C : use SLT tracks from single lepton triggers also.
*                       Due to a bug in the online SLT code, the muons in 
*                       the single track triggered runs are also 
*                       called electrons.
*          tfmcren.F :  save old rsegc_cmp
*          tftcren.F :  store slt flag
*          tfunrf.F : rlevel_fit=0 no, PC segment fit=1, PC+TC fit=3
*
* 4.18/02  arte-03-09-r4 
*          tfevntr.F : .and..not.cats_mode_zfpar) call rgsltre
*
* 4.18/01  arte-03-09-r3 
*          tf1init.F : set param. outlmode_zfpar,store_magn_zfpar
*          tfkfpar.F : new parameter  outlmode
*          tfmatripn.F : reaction on store_magn_zfpar
*          tfmcren.F : inr_zf(ii) = 0
*          tfrsegft.F : correct setting of plane_zf(izf)
*          tfstseg.F : new flag INR_HIT_CHECK
*
* 4.17/06  arte-03-09-r2
*          Geom.C : Removed trd/hipt walls
*                   Added routine getActiveVolumes (in .hh)
*          Track.C : insertWalls: better procedure to find walls in magnet 
*                    insertWallsV: removed/replaced by insertWalls
*                    extrapolateDownstream/extrapolateUpstream: new routines
*                    used by rangerHitPattern
*                    fit: extra smoother/filter step before inserting walls
*          HitPattern.C : new routine
*          RichRing.C : added plane routine which finds `dummy' rich plane 
*                       needed 04/07/01 S.Lanyov
*                       for proper insertion of walls. (See also ECClus.C)
*          tf1init.F : more strict settings in init. cov. matrix
*          tfevntr.F : call tfmcren()
*                      .and.slt_mode_zfpar.le.3) call rgsltre()
*          tffilmn.F : flag DEBUG_TFFILMN
*          tfmcren.F : new routine
*          tfpropmn.F : flag DEBUG_TFPROPMN, precold=-1
*          tfrsegft.F : new routine
*
* 4.17/04  arte-03-09-r1
*          tffilmn.F : define Y_TARGET_CHECK
*          tffilmn2.F : new
*          tfmatripn.F : (rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5)
*          tfmprep.F : prev_zf(izf) = 0, nhit_ft(jft) = 0
*          tfpropmn2.F : call tffilmn2()
*          tfremcs.F : if(mcass(1).eq.imc) go to 20
*          rgdom.C : add new enty in SNM list for sectors:
*                    2,1 2,2 2,3 2,4 2,5 2,6 2,11 2,12
*          RMap.C : static float zTol0=150;
*
* 4.17/04  Geom.C : use of all gwals in the vds
*          Track.C : fixed problem which occurs only when there are two 
*                    hits at exactly the same z-position.
*          ECClus.C : #undef USEENERGY, int rangerECClus::plane()
*
* 4.17/03  tf1init.F : uniq_mode_zfpar = 1
*          tfclusy.F : if(z_set(s2) - z_clus) .lt. dzmin) go to 20
*          tfextfil.F : use 4 parameters in state vector
*          tfstseg.F : check segment : abs(xseg_1).lt.300. ...
*          tftcfil.F : use 4 parammeters in state vector
*          tftcsen.F : n_zf = 1
*          tftctranz.F : use 4 parammeters in state vector
*          Uniq.C : if((int) hitIntersect.size() > 3)
*          Track.C : float dz = (*insertBaseNode)->getState().z() - z;
*
* 4.17/02  tf1init.F : whit_cmp_zfpar(3)=1,uniq_mode_zfpar = 0
*                      unchi_mode_zfpar = .false.
*          tfclusy : check nclus.lt.maxclus
*          tffilx.F : + whit_cmp_zfpar(cmp)   bonus for new hit
*          tftripxn.F : select triplet matching parameters according to cmp
*          tffilyn.F : + whit_cmp_zfpar(cmp) ,bonus for new hit
*          tfpropyn.F : whit_zf(izf).lt.whitmin_y_zfpar
*          rgdom.C : flag ALL_COMBINATION_ITR_PC12
*          rghlcr.C : test of z for ITR locked hits
*
* 4.17/01  new option y-projection reconstruction in PC (cluster from sets)
*          tf1init.F : set param. fast_mode_zfpar,unchi_mode_zfpar
*          tfclusy.F : new , produce cluster from sets
*          tfevntr.F : call rguniqchi()
*          tfindfit.F : new, fit of set if point in zf 
*          tfkfpar.F : parameters fastmode, unchimode
*          tfkill.F : new routine
*          tflfit.F : new, fit of candidate
*          tfmatripn.F : call tfclusy() instead of tfcontyn()
*                        use of option fast_mode_zfpar
*          tfpropcly.F : new, propagate vertical clusters made of sets
*          tfstseg.F :  use of fast_mode_sfpar, if_kill
*          tfkuip.cdf : add parametters fast,unchi
*          rguniqchi.C : new routine
*          Track.C : //  added filling of rtra->ndof,
*                        removed chiSquare data member 
*
* 4.16/21  tffilyn.F : remove call tumchit(..)
*          tfpropcyn.F : exclude flag #NEWNAV
*          tftcpron.F : remove flag NEWNAV and check of diff_x in loop on hits
*          tftctranz.F : cp_zf(2,2,jzf) = cp_zf(2,2,jzf) + sx * 10.
*          tfcontyn.F : test rgepipe
*          tftcfil.F : off OLDCHECK
*                      dy_marg = dsqrt(cx_zf(2,2,jzf)*chmax_TC_zfpar)
*          tftcsen.F : * check domain window without extrapolation 
*                        remove flag NEWNAV
*          rgepipe.C : new routine
*
* 4.16/20  tfevntr.F : call of tema_reco, selective call of tfunco
*                      call of rgdef for Ranger
*          tfkfpar.F : new parameters tema,uniqmode,itrmode
*          tf1init.F : new parameter tema,uniqmode,itrmode
*                      set ranger parameters according to rgmc()
*                      set identical parameters for MC and data 
*          rgsltre.C : call of rgdef()
*          rgdef.C : check itrmode to include MS12
*          tfcontyn.F : x_acs = rgxseg(fhitb_z(hitb),rgwidom(dw)),cmp=1,3
*          rgdom.C : on PROXY,off PROXY_OTR,on PROXY_ITR
*
* 4.16/19 Track.C : upper limit for magnet > 660. in rangerTrack::genCmp()   
*         setCmp.C :  upper limit for magnet < 660 cm
*
* 4.16/18  tfevntr.F : call of OtrCats (via rgcatsre())  
*          tfkfpar.F : new parameters cats,fitmagn
*          tfkuip.cdf : 
*          tf1init.F : set param, cats_,fit_magn_zfpar
*          rgcatsre.C : new, interface for call of OtrCats
*          Track.C : check parameter fitmagn  in rangerTrack(rtra..
*          rgdef.C : SI08 is excluded from MC1
*          Uniq.C : int sltFlag is added in class rangerSegment
*                   segments with sltFlag == 1 are preferable
*          tfpropmn.F : call rghlcr(dlnext,4,dble(zdom),x_db(1,dom)..
*          tfpropmn2.F :
*          tfpromms.F :
*          tfmprep.F :    message for the case cp_zf(4,4,last_ft(ift)).lt.0.
*          Node.C : arteMsg in rangerNode::smooth
*          StateP.C : remove printout from StateP::predict
*          HitWire.C : //  changes in rangerHitWire::rangerHitWire 
*          needed for calibration
*
* 4.16/17   tf1init.F : set param. slt_magn_,tc_mode_,slt_clone_zfpar
*           tfcountyn.F : new treatment for PROXY_TFCONTY (rghlpr,rgtabssws)
*           tfevntr.F : call of rgsltre  after normal ranger,
*                       kill clones before TC propagation
*           tfextre.F : magnet tracking of slt segments
*           tfkfpar.F : new parameters sltmagn,tcmode,sltclone
*           tfmatripn.F :  exclude flag #NEWNAV
*           tfpropcxn.F :  exclude flag #NEWNAV
*           tfpropcyn.F : exclude flag #NEWNAV
*           tfpropmn.F : exclude flag #NEWNAV
*           tfpropms.F : new , magnet tracking for SLT seeded PC segments
*           tfpropxn.F : exclude flag #NEWNAV
*           tfstseg.F : cancel  discarding of bad segment
*           tftcres.F : new, track reconstruction in TC chambers for SLT seeds
*           tftcpros.F : new , 3D track-follow of SLT seeds in TC chambers
*           tftripxn.F : sort cluster according to mult_clus
*           Uniq.C : new UniqS for slt SLT seeded segments
*           rgdownstr.C : call of UniqA
*           rghladd.C : new, number of elements is NOT reset before writing
*           rghlpr.C : new, nummber of array elements is reset (and rghladd_)
*           rgsltre.C : added magnet tracking of slt seeds
*           rgtabssws.C : new, tailored from rgtabssw.C
*           tftcpron.F : call of rghlcrd() ( unlock hits in TC)
*            
* 4.16/16   rgsltre : muon settings for seeds 
*           tfpropyn.F : whitmin_y_zfpar is used for selection
*           tfkfpar.F : new comments
*
* 4.16/15   rgsltre : check of patt,magt,trit flags when set slt flag 
*
* 4.16/14   tfextinit.F : quality_ext_min =8.5
*           tfsmfin.F : define seg_first(last)(2) for stat_ft.ne.2
*           tfstseg.F : store momentum for slt_mode_zfpar.gt.0
*           Uniq.C : check if treated segments was produced by ranger
*           rgsltre.C : set bit flag Rsegc::slt, new cov for seeds
*           rgsltget.C : check if track is stored
*
* 4.16/13   tf1init.F  : set parameter slt_mode_zfpar
*           tfevntr.F : call rgsltre()
*           tfextfil.F : flag EXT_DEBUG
*           tfextinit.F : new initial values
*           tfextpro.F : new parameter seed
*           tfextre.F : new parameter seed
*           tfextse.F : new parameter iseed,prev_ft(ift) = ift,stat_ft(ift)=3
*           tfkfpar.F, tfkuip.cdf : new parameter sltmode
*           tfmatripn.F : check of slt_mode_zfpar when initialize
*           tfsmfin.F : skip dummy hits
*           rghlcrd.C : new, clone of rghlcr-(..), ulocked hits
*           rgsltget.C : new, get parameters of slt tracks
*           rgsltre.C : new, reconstruct tracks seeded by slt
*           Node.C : arteMsg in rangerNode::makeNode
*           zfpar.fi,zfpar.hh : new parameter slt_mode_zfpar
*           rgExtDef.hh : remove prototipe of tfextre_()
*           rgextreco.C : new prototype of tfextre_(..)
*
* 4.16/12   Geom.C : Introduced list of active walls
*           Hit.C : few comments about hits check 
*           HitBase.C : corrected smoothing of residuals and chi2,
*           introduced ::filterOhneAbsorb, ::predictGlobal and ::absorbGlobal,
*                    faster matrix manipulation in ::absorb
*           HitWire.C : new flag NEW_MODEL, but not used
*           MatchedRsegL.C : new
*           Node.C : introduction of ::makeNode for RichRing/Rseg,
*                    correction of smoothing of residuals
*           RMap.C : Introduced ::chiSqProb
*           RichRing.C : new
*           State.C,StateL.C,StateLI.C,StateP.C,StatePI.C : moved many routines
*                      from other state classes to State.C
*           Track.C : in ::insertWalls: loop `active' volumes only,
*                      new  rangerTrack::fitGlobal(), trick for path in magnet
*           Thick.C,Thin.C : slight modification in inclusion of header files 
*           Volume.C : faster access to rotation matrix
*           Fit.C : call of t.fitGlobal() for slinemode = true
*           rgdef.C :  MC06 is included in SL MC6 
*           zfpar.fi(.hh) : new parameter sline_mode_zfpar
*           tf1init.F,tfkuip.cdf,tfkfpar.F : treatment of this new parameter 
*                      sline_mode_zfpar
*           tfcontyn.F :  parameter (y_marg=2.), flag TRIPLET_CUTY off
*           tffilmn.F : check of y coorfinate only
*           tfplx.F : new definition of sn(cs)tot_plx for VDS
*
* 4.16/11   Fit.C : new rangerFitL(vector<ArtePointer<RSEG>,..)
*           HitWire :  new flag HITWIRE_FUDGE introduced 
*           Geom.C : selective use of walls , flag GWALL_SELECT
*           rgfit.C,rgfitsv.C : include use of rangerFitL
*           tffilyn.F : strict test of y cordinate, flag FILYN_Y_TEST
*           tfunrfr.F : selective refit of PC segments
*
* 4.16/10   rghlcr.C :  added flag USER_TEST_HIT
*           tfevntr.F : remove call of tfdownstr           
*           tfunidm.F : new parameters to cut on fraction of good hits 
*           rgdownstr.C : new module to control downstream propagation
*           tftcren.F : fixed bug in filling PC-TC segments
*           StateP.C : dedx correction is off 
*   
* 4.16/09   zfpar.fi : new varables qpmax_trip_zfpar,down_mode_zfpar
*                      and qmin_down_zfpar  
*           Uniq.C :   more strict criteria for clone :
*                            hitIntersect.size() > 2
*           rghlcr.C : minor changes
*           tfevntr.F : call of downstream propagation 
*           tf1init.F : initialize new variables
*           tftripxn.F : control of qp_max via kumac parameter
*           tftcren.F : minor changes
*           tfdownstr.F : -- // --
*           tfdownse.F : call of tfdownqp(...)
*           tfdownqp.F : new, define list of q/p values for downstr. seeds
*           tfkfpar.F : 3 new kumac parameters
*           tfkuip.cdf :   -- // --
*   
* 4.16/08   Track.C : fixed problem in filling of rpnt
*           tfstseg.F : discarding of bad hits, #define BAD_HIT_DISCARD
*                       fudge factor in covariance matrix, 
*                       #define COV_COR_500MKM
*                       filling rseg->pf,pe for level=2 and 5 ,
*                       #ifdef SEG_TEST
*                       new evaluation of rseg->yf,ye ,#ifdef TY_CORRECTION 
*           tfhtseg.F   new routine used for discarding of bad hit             
*           rgauxht.C                 --  //  --
*
* 4.16/07   Track.C : in rangerTrack::orderIfNeeded()  1. check ... == zfault,
*                     2. if (nOrderFault > 0)
*           Fit.C   : filling of rseg->err instead of rseg->fit,
*                     set rtra->fit = 100 when refit fails.
*           rgfitpar.C : new, refit of segment without overwriting of rseg
*                        parameters
*           rghlcr.C  : locking of used hits during 3D propagation
*
* 4.16/06   tfstseg.F : store rseg->nhit,rseg->npar 
*                       store list of related MC produced by tfremcl(...) 
*           tfremcl.F : new, produce list of MC related to segment 
*
* 4.16/05   tfmprep.F : nhit_zf(izf)   = 1 
*
* 4.16/04   tftripxn.F #define NEW_X_MAXHIT,NEW_TRIPLETX
*           tf1init.F  new default values
*           tfcontyn.F #define NEW_Y_MAXHIT,TRIPLET_CUTY
*           tfdzone2.F #define STACK_OVER_IGNORE 
*           tfevntr.F  minor changes
*           tfpropcyn.F       parameter (w_targ = 0.25) !    
*           tfstseg.F    SEG_TEST option was added but not used
*           tfunco.F   weedout of old stuff
*           Uniq.C   if (frac1 > .5 && frac2 > .5) --> clone
*           rghl.C   locking of used hits
*           rgmaintr.C  weedout of old stuff
* 
* 4.16/03   Uniq.C bug was fixed. Added UniqA (rguniqa) for test of all 
*           segments and UniqP (rguniqp) for test in PC area. 
*           Segment is considered as clone if overlap 50% (old method)
*           tfunco.F  call of rguniqp instead of rguniq.
*           tf1init.F        segstor_zfpar = .true.    
*
* 4.16/02   Fit.C,Fit.hh,Track.C,Track.hh added function for fast fit of VDS segments
*           rgextvdmu.C minor changes
* 
* 4.16/01 - first version for real data reconstruction 
*           dev341,30/11/99 
*           tfcontyn.F changed parameters of triplet selection, unlocked used 
*           hits, excluded that triplet hits should be from different planes 
*           tfkfpar.F     set of new parameters was added 
*           tfmatripn.F   changed limits of storage loop in zf-buffer, added cut 
*                         of segment on dz  
*           tfpropcxn.F   new clean-up duplicates, use of x-target constraint 
*           tfpropcyn.F   new clean-up of duplicates, use of y-target constraint
*           tfstseg.F     new check of double hits 
*           tftcren.F     check of segment dz.gt.30 
*           tftripxn.F changed parameters of triplet selection,  
*                     excluded that triplet hits should be from different planes  
*           tffilx.F,tffilyn.F,tfmprep.F,tftctranz.F - minor changes 
*           Uniq.C        segments is considered as clone if overlap >= 2 
*           rgdom.C       creation of seeds in PC02 PC03 
*           Node.C,StateP.C,Track.C,rghl.C,rghlevnt.C - minor changes
*           new routines
*           tfevntr.F     clone of tfevnt for on-line reconstruction
*           tfunrfr.F     control routine for ranger++ fit of segments 
*                         (clone on tfunrf for on-line reconstruction)
*           tfsngold()    return # of reference golden decay in /zpstat/
*
* 4.15/04 - HitWire.C LRSign = (rhit->q)>0 ? 1 : -1; , instead of rhit->hitb->q
*           dev331,27/10/99
*
*                    ---------------------------------
*
* 4.15/03 - cut parameters in tfmatrip(n),tfpropy(n).
*           Same-plane rejection in triplet finders tftripxn.F
*           and tfcontyn.F. 
*           rgzone.C uses now entry layer to branch to next window.
*           rgzonew.C is now obsolete. 
*           Exclusion ranges from OTDR table are filled in rgdom.C.
*           Stereo angle margins in rgdom.C increased. 
*           (20-Sep-99)
* 4.15/02 - inline comments of rg*.C improved.
* 4.15/01 - rgextios.C: mmbook and mmbrel were replaced.
* 4.15/00 - Improved composite layer construction in rgdom.
*           Downstream propagation added.
*           External seed propagation added.
* 4.14/04 - Correction in tfcontyn. Some printouts changed or removed.
* 4.14/03 - Removal of stop and exit statements
* 4.14/02 - New routine tfremv.
* 4.14/01 - Muon segment treatment included in tfbuild.F
*           Pattern tracker segments stored by tfbuild.F
*           Reduced output from new navigator
* 4.14/00 - New navigator. (Many new files)
*           Many changes for modular geometry.
*           Setting of qptEst in HitBase introduced (for holmes fitting)
*           Superlayer setting in dmlay fixed.
*           tfkuip splitted.
*           dgsel selection in old navigator.
*           New parameters qualminX,qualminY,nhitmin,whitmin,
*               dgsel,navmode in zfpar.
*           Search of appropriate mimp improved in tftparm.
*           Monitor class.
* 4.13/00 - autosort in Track.C constructors, new scheme in Geom.C,
*           MS06 included in navigation table (dmdef.F),
*           modified reference track criteria because of new 
*           layer structure in magnet (tfref.F,tfstam1.F)
* 4.12/04 - RCCL copy in seg2Track.C, rgideal checks segstor before 
*           storing RTRA, no refit after pattern reco in rgmaintr,
*           no exit on dz exception in Track.C
* 4.12/03 - Bug fix in ::storeRpnt in State.hh,StateP.hh and StateP.C
* 4.12/02 - The routine rgmaintr() was introduced which is the user routine 
*           for standard main tracker reconstruction in the full geometry. 
* 4.12/01 - self-initialization, fixes in seg2track.C,tftcre.F,RMap.C,
*           removal of mc_zf,mimp_zf
* 4.12/00 - adaption to ARTE-02-05 and new C++ interface
* 4.11/00 - TC propagation, clone weedout, SVD integration, control 
*           structures
* 4.10/00 - condUpdate, hitb constructors, domain name printout, rgsv2t
* 4.09/02 - SI08 included in navigation table
* 4.09/00 - object oriented ranger fit,
*           fast magnet propagation
*           rtdir remains removed
* 4.08/02 - hardcoded domains fixed (tfdzone2.F), zmax_ec  (tfinit.F)
*           rinit (tfrfseg.F), rtdir replaced (tftpar2.F),
*           rkmain parameter list (tftrkut.F)
* 4.08/01 - modulo 2**16 in igede_sec (dmdir.F): release as ranger 4.8
* 4.08/00 - same
* 4.07/06 - new rk routines (T. Oest, T. Kuhn-Sander)
* 4.07/05 - overdue cvs add
* 4.07/04 - new include file reference scheme
*
************************************************************************
