
// ********************************************************************
//
//  Routine:      rcRICH.C
//  Author:       T.Oest/D.Samtleben
//
//  Description:  rich stand alone reconstruction
//
//  Modification:
//  -- remove occupancy cut (included in the RICH reconstruction)
//                                                    T.Oest 25.05.00
//  -- include new ring search                        T.Oest 01.06.00
//  -- moved to rcRICH.C                              AG     02.01.01
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include "rich/rich.h"
#include "rise/RingSearchARTE.h"
#include "reco/rcflags.hh"

//*****************************************************************
// function
//*****************************************************************

int
rcRICH( int level )
{

//==================================================================
// 1. create hits
//           dric2hitb_(): fills HITB table with RICH hits
//==================================================================


     if (level == 1 || level == 3) dric2hitb_();

//==================================================================
// 2. reconstruct rich rings
//           rcringsdb_()  with database access
//
//==================================================================

     if (level > 1)  {
        if (recoRICHmodule == 2) { ringsearchRSEG();
	 } else {                  rcringsdb_();
	 };
     };

     return 0;
}
