// ********************************************************************
//
// source:    rcRcclRtra
//
//
// created:   18-01-01
// modified:  
//
// author:    Mauro Villa
//
// Loop on RCCL and copy any charged cluster information to RTRA
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include <algorithm>

// ARTE includes
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"

void rcRcclRtra()
{
  //---------------------------------------------------------
  // recover lost RCCL-RSEG relations
  //---------------------------------------------------------

  for( ArteTable<RCCL>::iterator rccl = ArteTable<RCCL>::begin();
       rccl != ArteTable<RCCL>::end(); ++rccl ) {
    vector<ArtePointer<RTRA> > rtras;
    for( ArteRelationIterator<RTRA>::iterator itra = rccl->rtra.begin();
        itra!=rccl->rtra.end(); ++itra){
      rtras.push_back(*itra);
    }
    for( ArteRelationIterator<RSEG>::iterator iseg = rccl->rseg.begin();
        iseg!=rccl->rseg.end(); ++iseg){
        ArtePointer<RSEG> rseg = *iseg;
      if( (rseg->cmp & (Rsegc::trit|Rsegc::patt) ) !=0 && rseg->fit==0){
        for( ArteRelationIterator<RTRA>::iterator itra = rseg->rtra.begin();
          itra!=rseg->rtra.end(); ++itra){
          if( std::find(rtras.begin(), rtras.end(), *itra)
                == rtras.end() ){
	    //             cout<< "x lost relation RCCL"<<*rccl<<" - RTRA"<<*itra<<endl;
             if( (*itra)->cecal <= 0 ){
                (*itra)->cecal = (*rccl).index();
               (*itra)->hca = int((*rccl)->wid);
             }
             (*itra)->cmp |= Rsegc::ecal;
             createRelation(*itra, *rccl, &RTRA::rccl );
          }
        }
      }
    }
  } 
}
