// 
//  Author:  Rainer Mankel                     Created:   3-Jun-99
//           Thomas Lohse
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// set momentum and cov matrix of RSEG range to VDS track default values

#include "reco/rcsetp0.hh"

void rcsetp0(const ArteTableIterator<RSEG>& rs1,
	     const ArteTableIterator<RSEG>& rs2) {
  for(ArteTableIterator<RSEG> rsi=rs1; rsi != rs2; ++rsi) {
    (*rsi)->pf = sqrt( (*rsi)->txf * (*rsi)->txf 
		       + (*rsi)->tyf * (*rsi)->tyf) / 0.25;
    (*rsi)->cvf[14] = 100;
    (*rsi)->pe = sqrt( (*rsi)->txe * (*rsi)->txe 
		       + (*rsi)->tye * (*rsi)->tye) / 0.25;
    (*rsi)->cve[14] = 100;

    // loop over RHITS
    for ( ArteRelationIterator<RHIT> rhitIt = (*rsi)->rhit.begin();
	  rhitIt != (*rsi)->rhit.end(); ++rhitIt ) {
      ArtePointer<RHIT> rhit(*rhitIt);
      rhit->p = (*rsi)->pf;
    }
  }
}

