//--*-C++-*--
#include "arte/arte.hh"
#include "rich/rich.h"

#ifdef RICH_ROOT
#include "TROOT.h"
#include "TFile.h"
#include "TDirectory.h"
#include "TTree.h"
#include "TNtuple.h"
#include "TH1.h"
#include "TH2.h"
#include "TMath.h"
#endif


#ifdef RICH_ROOT

class RichQuality {
private:
  TFile *qFile;
  TH1F  *ring_sigma, *ring_chi2, *ring_photons, *ring_prob;
  TH1F  *ring_rad, *rich_occup, *rich_bx, *rich_rings;
  TH1F  *rich_vds, *rich_otr, *rich_muon, *rich_ecal, *rich_rtra;
  TH1F  *ring_nr2, *fed_occup;
  TH1F  *ring_S, *ring_Rb, *phot_assign, *seed_rings;
  TH2F  *rich_phi_lam, *phot_phi_lam;
  TH1F  *rich_occup_cut, *ring_sn;
  TH2F  *time_occup;
  ArteTableIterator<RCCL> ecalBias(ArtePointer<RSEG> rich);
  TNtuple *ring_ntuple;
  void  fillHistosMC();
  void  fillHistosData();

  TH1F *rtra_rings, *rtra_nr2, *rtra_Rb, *rtra_S, *rtra_sn, *rtra_photons ;



public:
  RichQuality();
  ~RichQuality();

  void  fillHistos(int mode);
  void  bookHistos();
};

extern RichQuality *RICH_Quality;

#endif
