// **********************************************************
//
// sltinfo_arte.C
//
// Arte interface to the sltinfo library
//
// Changes:
//  13 Nov 2000 (BP) Make multiple calls per event faster
//
// **********************************************************

#include "arte/arte.hh"
#include "etb.h"
#include "sltinfo.h"

extern "C" {
int ARTE_get_feds_DSLT( int max, ETB_fed *feds, int *n );
void ARTE_put_feds_DSLT( ETB_fed *feds, int num,int size );
}

/* Read SLT information from DSLT bank */

extern "C" SLTRC SLTReadDSLT()
{
  int rc;
  static int prev_event=-1;
  static int prev_run=-1;
  ETB_fed feds[MAX_SLT_FEDS];
  int num;

  if (ArteTable<EVHD>::size()) {      // check if already decoded the event
    if (prev_event==(*ArtePointer<EVHD>(1)).evt&&
        prev_run  ==(*ArtePointer<EVHD>(1)).run) {
	return SLT_OK;
      }
    else {
      prev_event=(*ArtePointer<EVHD>(1)).evt;
      prev_run  =(*ArtePointer<EVHD>(1)).run;
    }
  }

  rc=ARTE_get_feds_DSLT(MAX_SLT_FEDS, feds, &num );

  if (rc!=ETB_ok) return SLT_NODSLTBANK;
  return SLTReadEvent(feds,num);
}

extern "C" SLTRC SLTPipeToDSLT()
{
  int rc,size,num;

  ETB_fed feds[MAX_SLT_FEDS];
  rc=SLTPipeFeds(MAX_SLT_FEDS, feds, &num,&size );

  if (rc!=ETB_ok) return SLT_NODSLTBANK;
  ARTE_put_feds_DSLT(feds,num,size);
  return SLT_OK;
}
