#ifndef _L3_VTSTRUCT_HH_
#define _L3_VTSTRUCT_HH_
// *****************************************************************************
//
// source:    L3_VTstruct.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************

#include <CLHEP/Utilities/fortran.h>
#include "L3_VTtypes.hh"

const int ntrtot = 300;
const int nvttrk =   5;
const int nvtmax =  50;
const int ntrk   = 100;
const int ncomax =   5;
const int nwmax  =  20;

const float chi2vtr = 14;
const float ch2stt = 6.;
const float ch2stv = 8.;
const float ch2svw = 1.;
const float Bvimpc = 0.1;
const int nmix = 1;

extern struct
{
  TrackParameter p[ntrtot];
  TCovMatrix v[ntrtot];
  TCovMatrix g[ntrtot];
  double xmass[ntrtot];
  int trmult;
} FORTRAN_COMMON( vttrbf );

extern struct
{
  int nvt;
  int ktr[ntrk][nvtmax];
  int ntr[nvtmax];
  int nv[ntrtot];
  int kv[ntrtot][nvttrk];
  int jv[nvtmax][ntrtot];
  int vtset[nvtmax];
} FORTRAN_COMMON( vtpntr );

extern struct
{
  Point       xv   [ntrk+1][nvtmax];
  Point       xvs          [nvtmax];
  Point       qv   [ntrk]  [nvtmax];
  VTrackPara  qvs  [ntrk]  [nvtmax];
  PCovMatrix  c    [ntrk+1][nvtmax];
  PCovMatrix  cInv [ntrk+1][nvtmax];
  PCovMatrix  f    [ntrk]  [nvtmax];
  TCovMatrix  gb   [ntrk]  [nvtmax];
  PCovMatrix  w    [ntrk]  [nvtmax];
  PCovMatrix  cs           [nvtmax];
  VTCovMatrix ds   [ntrk]  [nvtmax];
  PCovMatrix  es   [ntrk]  [nvtmax];
  double      chi2 [ntrk]  [nvtmax];
  double      chi2s[ntrk]  [nvtmax];
  Point       xnk  [ntrk]  [nvtmax];
  PCovMatrix cnkInv[ntrk]  [nvtmax];
  PCovMatrix  cnk  [ntrk]  [nvtmax];
  double      ak33 [ntrk]  [nvtmax];
  double      ak34 [ntrk]  [nvtmax];
  double      bk13         [nvtmax];
  int         fit          [nvtmax];
  int         fitm         [nvtmax];
  int         smooth       [nvtmax];
  int         dist         [nvtmax];
  int         invflg[ntrtot];
} FORTRAN_COMMON( vtkalm );


extern struct
{
  double      xmc  [ncomax][nvtmax];
  int         nconst       [nvtmax];
  int         mask [ntrk][ncomax][nvtmax];
} FORTRAN_COMMON( vtcons );


extern struct
{
  Point       xw   [nwmax];
  double      phiw [nwmax];
  double      thew [nwmax];
  double      sigtw[nwmax];
  double      siglw[nwmax];
  VTCovMatrix cw   [nwmax];
  int         nw;
} FORTRAN_COMMON( vtwire );  

extern struct
{
  int         nvprim;
  int         ivprim[nvtmax];
} FORTRAN_COMMON( ivprim );

extern struct
{
  int         nvsec;
  int         ivsec[nvtmax];
} FORTRAN_COMMON( ivsec );
#endif
