#ifndef _L3_VTTYPES_H_
#define _L3_VTTYPES_H_

#include <CLHEP/Vector/ThreeVector.h>

struct TrackParameter
{
  double ax;
  double ay;
  double bx;
  double by;
  double moment;
};

ostream & operator << (ostream &, const TrackParameter &);


// Covariance Matrix for the track parameters

struct TCovMatrix
{
  double a[5][5];
};

struct Point
{
  double x;
  double y;
  double z;

  Point() {}
  Point( double xx, double yy, double zz ): x( xx ), y( yy ), z( zz ) {}

  inline operator Hep3Vector () const;
};

ostream & operator << (ostream &, const Point &);


// Covariance matrix for a point object

struct PCovMatrix
{
  double a[3][3];
};

ostream & operator << (ostream &, const PCovMatrix &);
ostream & operator << (ostream &, const TCovMatrix &);


// Same classes for vertex positions (same as Point).

typedef Point VTrackPara;
typedef PCovMatrix VTCovMatrix;

#include "L3_VTtypes.icc"
#endif
