*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_REC

**********************************************************************
*
* Description: TRD reconstruction (software)
*
* Main routine for the TRD reconstruction.
*
* For segment track reconstruction used the information from TRD only!
*                 
* Called from: USEVNT
*
* 
*
* Arguments: none
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      
      REAL X_HELP, Z_HELP, X_TRD_SEED, Y_TRD_SEED, Z_TRD_SEED,
     +     TNXZ_TRD_SEED, TNYZ_TRD_SEED, Y_HELP, X1_BL_LEFT, DEL_Z,
     +     X1_SEED, Z1_SEED, X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT,
     +     LAYER_A, LAYER_B, LAYER_C, LAYER_D, SIGMA, SIGMA_MIN,
     +     SIGMA_HELP, X_BL_RT

      INTEGER isl, INDX, ROW, IGD, N_STRAW, IDB, ROW_HIT, N_MR, I, 
     +        ME_HELP, N_BLOK, N_ROW, N_MAX, NB_TRD_SEED, N_MATR,
     +        ROAD, FLAG, N_STR_HIT, N_FL, NN_BLOK, K, FL_H,
     +        N_MR_H, LAYER_N, N_MR1, I1, I_N_TR1, N_BLOK1,N_BL_MIN, 
     +        N_MR2, I2, I_N_TR2, N_BLOK2, N_TR, N_MR_MIN, I_MIN,
     +        TRD_VIEW, TRD_HITB, N_TR_MIN, N_MR_M, I_M, NTR_MIN,TRACK

      INTEGER N_BLOK_TRD, N_STRAW_TRD, N_TRD_SEED, N_K, N_L, N_TRA
      INTEGER PARAM_1, PARAM_2, PARAM_3, PARAM_4, PARAM_5, PARAM_6,
     +        PARAM_7, PARAM_8, PARAM_9

      COMMON /TRD_HLP/ X_HELP, Y_HELP, Z_HELP, ME_HELP
      COMMON /TRD_SD/ X_TRD_SEED, Y_TRD_SEED, Z_TRD_SEED, TNXZ_TRD_SEED,
     +                TNYZ_TRD_SEED, NB_TRD_SEED, N_MATR
      COMMON /TRD_ROAD/ ROAD, FLAG, N_STR_HIT, TRACK
      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      COMMON /TRD_LAYER/ LAYER_A, LAYER_B, LAYER_C, LAYER_D,
     +                   LAYER_N, SIGMA
      COMMON /TRD_ALL/ TRD_VIEW, TRD_HITB

      PARAMETER (N_MAX = 1000)
      PARAMETER (N_BLOK_TRD = 12, N_STRAW_TRD = 78, N_TRD_SEED = 4)
      PARAMETER (N_K = 15, N_L = 16, N_TRA = 100)

      DIMENSION ME_HELP(N_BLOK_TRD,N_TRD_SEED,N_STRAW_TRD) 
      DIMENSION X_HELP(N_BLOK_TRD,N_TRD_SEED,N_STRAW_TRD)
      DIMENSION Z_HELP(N_BLOK_TRD,N_TRD_SEED,N_STRAW_TRD) 
      DIMENSION Y_HELP(N_BLOK_TRD,N_TRD_SEED,N_STRAW_TRD)
      DIMENSION X1_BL_LEFT(N_BLOK_TRD,N_TRD_SEED)
      DIMENSION X_TRD_SEED(N_MAX,N_K),Y_TRD_SEED(N_MAX,N_K)
      DIMENSION Z_TRD_SEED(N_MAX,N_K), NB_TRD_SEED(N_MAX,N_K)
      DIMENSION TNXZ_TRD_SEED(N_MAX,N_K), TNYZ_TRD_SEED(N_MAX,N_K)
      DIMENSION ROAD(N_MAX,N_K,N_L,N_TRA), N_STR_HIT(3) 
      DIMENSION FLAG(N_MAX,N_K,N_L), TRACK(N_MAX,N_K,N_TRA)
      DIMENSION X_BL_LEFT(N_BLOK_TRD,N_L), Z_BL_ST(N_BLOK_TRD,N_L)
      DIMENSION Y_BL_LT(N_BLOK_TRD,N_L), Y_BL_RT(N_BLOK_TRD,N_L)
      DIMENSION X_BL_RT(N_BLOK_TRD,N_L) 
      DIMENSION LAYER_A(N_MAX,N_K,N_TRA), LAYER_B(N_MAX,N_K,N_TRA)
      DIMENSION LAYER_C(N_MAX,N_K,N_TRA), LAYER_D(N_MAX,N_K,N_TRA)
      DIMENSION SIGMA(N_MAX,N_K,N_TRA), N_MR_MIN(N_MAX,N_K,N_TRA)
      DIMENSION LAYER_N(N_MAX,N_K), I_MIN(N_BLOK_TRD,N_TRA)
      DIMENSION N_BL_MIN(N_MAX,N_K,N_TRA)
      DIMENSION TRD_VIEW(N_BLOK_TRD,N_L,N_STRAW_TRD)
      DIMENSION TRD_HITB(N_BLOK_TRD,N_L,N_STRAW_TRD)
      DIMENSION NTR_MIN(N_MAX,N_K)

C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
      PRINT *,'START analysis for TRD'
C
      PARAM_1 = N_BLOK_TRD*N_TRD_SEED*N_STRAW_TRD
C
      CALL VZERO(ME_HELP,PARAM_1)
      CALL VZERO(X_HELP,PARAM_1)
      CALL VZERO(Z_HELP,PARAM_1)
      CALL VZERO(Y_HELP,PARAM_1)
C
      PARAM_2 = N_BLOK_TRD*N_TRD_SEED
C
      CALL VZERO(X1_BL_LEFT,PARAM_2)
C
      PARAM_3 = N_MAX*N_K*N_L
      PARAM_4 = N_MAX*N_K*N_L*N_TRA
C
      CALL VZERO(FLAG,PARAM_3)
      CALL VZERO(ROAD,PARAM_4)
C
      PARAM_5 = N_BLOK_TRD*N_TRA
      CALL VZERO(I_MIN,PARAM_5)
C
      PARAM_6 = N_MAX*N_K*N_TRA
C 
      CALL VZERO(TRACK,   PARAM_6)
      CALL VZERO(N_MR_MIN,PARAM_6)
      CALL VZERO(N_BL_MIN,PARAM_6) 
      CALL VZERO(LAYER_A, PARAM_6)
      CALL VZERO(LAYER_B, PARAM_6)
      CALL VZERO(LAYER_C, PARAM_6)
      CALL VZERO(LAYER_D, PARAM_6)
      CALL VZERO(SIGMA,   PARAM_6)
C
      PARAM_7 = N_BLOK_TRD*N_L*N_STRAW_TRD
C
      CALL VZERO(TRD_VIEW,PARAM_7)
      CALL VZERO(TRD_HITB,PARAM_7)
C
      PARAM_8 = N_MAX*N_K
C
      CALL VZERO(LAYER_N,PARAM_8) 
      CALL VZERO(NTR_MIN,PARAM_8)
C
      PARAM_9 = N_BLOK_TRD*N_L
C
      CALL VZERO(X_BL_LEFT, PARAM_9)
      CALL VZERO(X_BL_RT, PARAM_9)
      CALL VZERO(Z_BL_ST, PARAM_9)
      CALL VZERO(Y_BL_LT, PARAM_9)
      CALL VZERO(Y_BL_RT, PARAM_9)
C
      DEL_Z = 2.3125
      FL_H  = 0
C
         DO isl = 1, NGESL()
            IF(IGESL_CMP(isl).EQ.LGESL_TRD)   THEN
               INDX = PGESL_GEDE(isl)
               DO WHILE (INDX.NE.0)
                  ROW = MGESL_GEDE(INDX)
                  INDX = XGESL_GEDE(INDX)
C
                  IF(IGEDE_LAY(ROW).LE.4) 
     +            X1_BL_LEFT(IGEDE_SEC(ROW), IGEDE_LAY(ROW)) = 
     +                                          FGEDE_XMIN(ROW)
C
                  X_BL_LEFT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_XMIN(ROW)
                  X_BL_RT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_XMAX(ROW)
                  Z_BL_ST(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_ZFW(1,ROW)
                  Y_BL_LT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_YMIN(ROW) 
                  Y_BL_RT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_YMAX(ROW) 
C
               DO IDB = IQ(IQGEDE_DIG1(ROW)),IQ(IQGEDE_DIGL(ROW))
C
                     N_STRAW = INT(IQ(IQDIGB_ID(IDB))/10000)
                     IGD     = IQ(IQDIGB_ID(IDB)) - N_STRAW*10000
C                     
                     IF(IGD.EQ.ROW) THEN
C
                        ROW_HIT = ODIGB_HITB(IDB)
C
                        N_BLOK = IGEDE_SEC(ROW)
                        N_ROW  = IGEDE_LAY(ROW)
c                IF(N_BLOK.EQ.1) WRITE
c     +  (*,'(''HITB REC==>'',3(1X,I4),4(1X,F8.3))')
c     +  IGEDE_SEC(ROW), IGEDE_LAY(ROW), N_STRAW, Q (QDIGB_Q(IDB)),
c     + Q (QHITB_X(ROW_HIT)), Q (QHITB_Z(ROW_HIT)), Q (QHITB_Q(ROW_HIT))
C
                        IF(IGEDE_LAY(ROW).LE.4) THEN
C
                           N_BLOK = IGEDE_SEC(ROW)
                           N_ROW  = IGEDE_LAY(ROW)
C
                           ME_HELP(N_BLOK,N_ROW,N_STRAW) = 1
                           X_HELP(N_BLOK,N_ROW,N_STRAW) = 
     +                                       Q (QHITB_X(ROW_HIT))
                           Y_HELP(N_BLOK,N_ROW,N_STRAW) = 
     +           (Q(QGEDE_YMIN(ROW)) + Q(QGEDE_YMAX(ROW)))/2.
                           Z_HELP(N_BLOK,N_ROW,N_STRAW) = 
     +                                       Q (QHITB_Z(ROW_HIT))
C
                        END IF
C
                        TRD_VIEW(N_BLOK,N_ROW,N_STRAW) = N_STRAW
                        TRD_HITB(N_BLOK,N_ROW,N_STRAW) = ROW_HIT
C
c                WRITE
c     +  (*,'(''HITB REC==>'',3(1X,I4),3(1X,F8.3))')
c     +  IGEDE_SEC(ROW), IGEDE_LAY(ROW), N_STRAW, 
c     + Q (QHITB_X(ROW_HIT)), Q (QHITB_Z(ROW_HIT)), Q (QHITB_Q(ROW_HIT))
C
                     END IF
                  END DO
C 
               END DO
            END IF
         END DO
C
         CALL TRD_SEED
C
         N_FL   = 1
         DO NN_BLOK = 1, 12
C
         DO N_MR = 1, N_MATR
            DO I = 1, 15 
               IF(NB_TRD_SEED(N_MR,I).EQ.NN_BLOK) THEN
                  DO N_ROW = 4, 1, -1
C
                    Z1_SEED  = Z_TRD_SEED(N_MR,I)
                    X1_SEED  = X_TRD_SEED(N_MR,I) - (4 - N_ROW)*DEL_Z*
     +                         TNXZ_TRD_SEED(N_MR,I)
                   N_STRAW = INT((X1_SEED - X1_BL_LEFT(NN_BLOK,N_ROW))
     +                   /0.61)  + 1
C
                   IF(TRD_VIEW(NN_BLOK,N_ROW,N_STRAW).NE.0) THEN
                      ROAD(N_MR,I,N_ROW,N_FL)  = N_STRAW
                      FLAG(N_MR,I,N_ROW)       = N_FL
                      TRACK(N_MR,I,N_FL)       = N_FL
                   END IF
C
                  END DO
               END IF
            END DO
         END DO
C
c         IF(FL_H.EQ.1) GO TO 11
C
         DO N_MR = 1, N_MATR
            DO I = 1, 15
C
              DO N_TR = 1, TRACK(N_MR,I,N_FL)
C
               IF(NB_TRD_SEED(N_MR,I).EQ.NN_BLOK.AND.
     +                              TRACK(N_MR,I,N_TR).NE.0) THEN
                  CALL TRD_WAY(N_MR,I,NN_BLOK)
                  IF(NB_TRD_SEED(N_MR,I).NE.0) 
     +                           CALL TRD_TRA(N_MR,I,NN_BLOK)
C
                  IF(NB_TRD_SEED(N_MR,I).GE.7.AND.FL_H.EQ.0) THEN
                     FL_H = 1
                     N_MR_H = N_MR
                  END IF
C
               END IF
             END DO       ! +
            END DO
         END DO
C
 11      CONTINUE
C
         END DO
C
         DO N_MR = 1, N_MATR
C
            SIGMA_MIN = 1000.
            N_MR_M    = 0
            I_M       = 0
            N_TR_MIN  = 0
C
            DO I = 1, 15 
C
               N_BLOK = NB_TRD_SEED(N_MR,I)
C
               DO N_TR = 1, LAYER_N(N_MR, I) 
C
               IF(N_BLOK.NE.0.AND.N_TR.NE.0.AND.TRACK(N_MR,I,N_TR).
     +                                                      NE.0) THEN
C
c          PRINT *,'SIGMA',N_MR,I,N_TR,SIGMA(N_MR, I, N_TR), N_BLOK
C
                  SIGMA_HELP = SIGMA(N_MR, I, N_TR)
                  IF(SIGMA_HELP.LT.SIGMA_MIN) THEN
                     SIGMA_MIN = SIGMA(N_MR, I, N_TR)
                     N_MR_M    = N_MR
                     I_M       = I
                     N_TR_MIN  = N_TR
C
c                     N_MR_MIN(N_MR,I,N_TR)  = N_MR
c                     N_BL_MIN(N_MR,I,N_TR)  = N_BLOK
                  END IF
C
               END IF
C
             END DO
C
            END DO
C
            IF(N_TR_MIN.NE.0) THEN
               N_MR_MIN(N_MR_M,I_M,N_TR_MIN)  = N_MR_M
               N_BL_MIN(N_MR_M,I_M,N_TR_MIN)  = 
     +                         NB_TRD_SEED(N_MR_M,I_M)
               NTR_MIN(N_MR_M,I_M) = N_TR_MIN
            END IF
C
         END DO
C
         DO N_MR1 = 1, N_MR_H - 1
            DO I1 = 1, 15
C
               I_N_TR1 = NTR_MIN(N_MR1, I1)
C
              IF(N_MR_MIN(N_MR1,I1,I_N_TR1).NE.0.AND.
     +                                   I_N_TR1.NE.0) THEN 
C
                 N_BLOK1 = N_BL_MIN(N_MR1,I1,I_N_TR1)
C
                 DO N_MR2 = N_MR_H, N_MATR
                   DO I2 = 1, 15
C
                    I_N_TR2 = NTR_MIN(N_MR2, I2)
C
                    IF(N_MR_MIN(N_MR2,I2,I_N_TR2).NE.0.AND.
     +                                   I_N_TR2.NE.0) THEN 
C
                       N_BLOK2 = N_BL_MIN(N_MR2,I2,I_N_TR2)
C
                       CALL TRD_CROS(N_MR1, I1, I_N_TR1, N_BLOK1, 
     +                               N_MR2, I2, I_N_TR2, N_BLOK2)
c                       print *,'sigma',SIGMA(N_MR1, I1, I_N_TR1),
c     +                                 SIGMA(N_MR2, I2, I_N_TR2)
C
                    END IF
                  END DO
                 END DO
C
              END IF
            END DO
         END DO
C
c         DO N_MR = 1, N_MATR
c            DO I = 1, 15
c               DO N_ROW = 1, 16
c                  IF(FLAG(N_MR,I,N_ROW).NE.0.AND.
c     +                    NB_TRD_SEED(N_MR,I).NE.0) THEN
c                     DO K = 1, FLAG(N_MR,I,N_ROW) 
c                        WRITE
c     +  (*,'(''WAY_TRD==>'',6(1X,I4))')
c     +    N_MR, I, N_ROW, ROAD(N_MR,I,N_ROW,K), FLAG(N_MR,I,N_ROW),
c     +    NB_TRD_SEED(N_MR,I)
c                   END DO
c                  END IF
c                END DO
c            END DO
c         END DO 
C
*      PRINT *,'STOP CHECK analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_REC
************************************************************************
